﻿///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                   Description: DxMediaApi C# API CLASS 
//                                                    VER:1.1.0.0
//                                                   Write by Tony yu   E-mail:  tony@zhonganvisioin.com
//                                                   Copyright (C) 2011/11 ShenZhen ZhongAn Vision              
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;



namespace VideoTestDemo
{
    class DxMediaApi
    {
        public const string DxMediaApiDll = "DXMediaCap.dll";
     


        public enum TVideoState
        {
            state_stopped,
            state_paused,
            state_running
        }

        public enum TDeinterlace
        {
            di_none,
            di_blend,
            di_bob,
            di_weave
        }
            public  enum TosdType
        {
            osd_time,
            osd_text,
            osd_image,
            osd_Line,
            osd_Rect

        }

		    public  enum TlineStyle
        {
            style_solid,
            style_dash,
            style_dot,
            style_dashdot

        }
        public enum TColorSpace
        {
            cs_rgb24,
            cs_rgb32,
            cs_yuy2

        }
    /*    public struct TDEVICE_TAG
        {
            public int idx;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public char[] deviceName;
        }

        public struct TCODEC_TAG
        {
            public int idx;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public char[] CodecName;
        }
*/
        [StructLayoutAttribute(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct TCODEC_TAG
        {
            public int idx;

            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
            public string CodecName;
        }

        [StructLayoutAttribute(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct TDEVICE_TAG
       {
           public int idx;

           [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
           public string Name;
       }

        [StructLayoutAttribute(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct TVideoSource
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
            public string Name;
        }


        public struct RECT
        {
            public int Left;
            public int Top;
            public int Right;
            public int Bottom;
        }
        public static RECT TRect = new RECT();

      

        public struct Device_ColorProp
        {
            public int ColorType;
            public int MinVal;
            public int MaxVal;
            public int StepVal;
            public int DefaultVal;
            public int CurVal;


        }
        public struct TosdInfo
        {
            public int TimeX;
            public int TimeY;
            public int TxtPlaceX;
            public int TxtPlaceY;
            public int PicPlaceX;
            public int PicPlaceY;
            public int TimeFontSizeVal;
            public int TxtFontSizeVal;
            public string Osd_Txtstring;
            public string PicOsdFile;
          //  public string TimeFont;
          //  public string TxtFont;
            public int TxtColor;
            public int TimeColor;
			         public int RectX;
            public int RectY;
            public int RectWidth;
            public int RectHeight;
            public int RectLineSizeVal;
            public int RectLineStyle;
            public int RectLineColor;
            public int LineX0;
            public int LineY0;
            public int LineX1;
            public int LineY1;
            public int LineSizeVal;
            public int LineStyle;
            public int LineColor;

        

        }

        public enum TcodecType
        {
            codec_sys, 
            codec_intel264,
            codec_x264,
            nvidia_Codec

        }


        public enum TCodecMode
        {
            codec_CBR ,
            codec_VBR

        }

   public enum TSwsAlogrithm
                {
	                SWS_SA_FAST_BILINEAR	= 0,
	                SWS_SA_BILINEAR			,
	                SWS_SA_BICUBIC			,
	                SWS_SA_X				,
	                SWS_SA_POINT			,
	                SWS_SA_AREA				,
	                SWS_SA_BICUBLIN			,
	                SWS_SA_GAUSS			,
	                SWS_SA_SINC				,
	                SWS_SA_LANCZOS			,
	                SWS_SA_SPLINE			
                };
   

      //  public static TCodecMode TEncodMode = new TCodecMode();

        public struct TDRateColorPara
        {
            public int nBrightness; // 亮度，取值(-255到255)
            public int nContrast;  //对比度，取值(-100到100)
        };
        public struct TVidCodecSysPara
         {
             public int bitrate; // 码率（单位：kbps）
             public int keyinterval;  //关键帧间隔
        }

        [StructLayout(LayoutKind.Sequential)]  
        public struct TVidCodecX264Para
        {
            public int fps;
            public int keyframeinterval;
            public TCodecMode rcMode;   //码率控制,x264_cqp(恒定质量), x264_crf(恒定码率), x264_abr(平均码率)
            public int Quality;
            public int Bitrate;
            public int Maxrbps;
            public int Peekbps;

          
        }

        [StructLayout(LayoutKind.Sequential)]  
        public struct TVidScalePara
        {
            public int src_stride;
            public int src_width;
            public int  src_height;   
            public int dst_stride;
            public int dst_width;
            public int dst_height;
            public TSwsAlogrithm algorithm;
        }


        [StructLayoutAttribute(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct TNetTransPara
        {
            public short port;//rtsp服务器监听端口(默认为554)

            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
            public string crtmp_uri;
        }

         public enum TNetStreamType
        {
            net_crtsp,
             net_crtmp,
             net_all

        }

         public enum TDataType
         {
             data_vid,   //video stream
             data_aud     //audio stream
  

         }
      

               //callback function
          ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            // init sdk
            //origin stream callback
            public delegate void TfnRawVideoCallback(IntPtr buffer, int colorSpace,
                                     int width, int height, int bytesWidth, IntPtr context);


            //encoder stream callback
            public delegate void fnEncVideoCallback(IntPtr buffer, int bufferSize,
                                                    Boolean bIsKey,
                                                    ulong nTmStamp, 
                                                    IntPtr Mp4FileHandel,
                                                    IntPtr context);


      
            //////////////////////////////////////////////////////////////////////////////////////////////////////////////

 

            //copy memory
            [DllImport("Kernel32.dll", EntryPoint = "RtlMoveMemory", SetLastError = false)]
            public static extern void MoveMemory(IntPtr dest, IntPtr src, int size);

            [DllImport("user32.dll")]
            public static extern int PostMessage(IntPtr hWnd, uint Msg, int wParam, int lParam);


            //write ini file
            [DllImport("kernel32")]
            public static extern long WritePrivateProfileString(string section, string key,
            string val, string filePath);

            //write ini file
            [DllImport("kernel32")]
            public static extern int GetPrivateProfileString(string section,
                                             string key, string def,
                                             StringBuilder retVal, int size, string filePath);


            [DllImport("kernel32")]
            public static extern int GetPrivateProfileInt(string section,
                                             string key, int nDefault, string lpFileName);
 


        /// <summary>
        /// ///////////////////////////////////////zhongan sdk api///////////////////////////
        /// </summary>
        /// <returns></returns>
            [DllImport(DxMediaApiDll)]
            public static extern int DXInitialize();
            // get card channels number
            [DllImport(DxMediaApiDll)]
            public static extern void DXUninitialize();

            [DllImport(DxMediaApiDll)]
            public static extern int DXGetDeviceCount();


            [DllImport(DxMediaApiDll)]
            public static extern int DXEnumVideoDevices(IntPtr  devTags, ref int Vidnum);

            [DllImport(DxMediaApiDll)]
            public static extern int DXEnumAudioDevices(IntPtr  devTags, ref int Audnum);

            [DllImport(DxMediaApiDll)]
            public static extern int DXEnumVideoCodecs(IntPtr devTags, ref int VideCodecnum);

            [DllImport(DxMediaApiDll)]
            public static extern int DXEnumAudioCodecs(IntPtr devTags, ref int AudioCodecnum);

            [DllImport(DxMediaApiDll)]
            public static extern int DXEnumSoundDevices(IntPtr devTags, int num);

            [DllImport(DxMediaApiDll)]
            public static extern IntPtr DXOpenDevice(int idx, ref int err);

            [DllImport(DxMediaApiDll)]
            public static extern int DXCloseDevice(IntPtr device);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSetVideoSource(IntPtr Device, int source);
            
              [DllImport(DxMediaApiDll)]
            public static extern int DXSetVideoSourceEx(IntPtr Device, int source);

        

            [DllImport(DxMediaApiDll)]
            public static extern int DXGetVideoSource(IntPtr Device,
                                                    ref int curSource,
                                                    IntPtr  sources,
                                                    ref char num);

           
             [DllImport(DxMediaApiDll)]
            public static extern int DXGetSignalPresent(IntPtr Device, ref int signal);
       


            [DllImport(DxMediaApiDll)]
            public static extern int DXDeviceRun(IntPtr device);

            [DllImport(DxMediaApiDll)]
            public static extern int DXDevicePause(IntPtr device);

            [DllImport(DxMediaApiDll)]
            public static extern int DXDeviceStop(IntPtr Device);

            [DllImport(DxMediaApiDll)]
            public static extern int DXGetDeviceState(IntPtr Device, ref int state);



            [DllImport(DxMediaApiDll)]
            public static extern int DXGetVideoPara(IntPtr Device,
                                                    ref int standard, 
                                                    ref int colorspace,
                                                    ref int width,
                                                    ref int height,
                                                    ref float framerate);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSetVideoPara(IntPtr Device, int standard, int colorspace,
                                                       int width, int height, float framerate);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSetDisplayPara(IntPtr Device,
                                                    int paraType,
                                                    int value,
                                                    int flags);



            [DllImport(DxMediaApiDll)]
            public static extern int DXGetDisplayPara(IntPtr Device,
                                                    int paraType,
                                                    ref int value,
                                                    ref int flags);


            [DllImport(DxMediaApiDll)]
            public static extern int DXGetDisplayParaRange(IntPtr Device, int paraType,
                                            ref int pMin,
                                            ref int pMax,
                                            ref int pSteppingDelta,
                                            ref int pDefault,
                                            ref int pCapsFlags);



            [DllImport(DxMediaApiDll)]
            public static extern int DXStartPreview(IntPtr Device, IntPtr hWnd, ref  RECT rect, int vmrtype);

            [DllImport(DxMediaApiDll)]
            public static extern int DXStopPreview(IntPtr Device);

            [DllImport(DxMediaApiDll)]
            public static extern int DXFreezePreview(IntPtr Device, Boolean bFreeze);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSetAudioDevice(IntPtr Device, ref TDEVICE_TAG audioDevice);

           
            [DllImport(DxMediaApiDll)]
            public static extern int DXEnableMute(IntPtr Device, Boolean bMute);


            [DllImport(DxMediaApiDll)]
            public static extern int DXHasAudio(IntPtr Device, ref Boolean bHasAudio);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSetSoundOut(IntPtr Device,  Boolean bSound);



            [DllImport(DxMediaApiDll)]
            public static extern int DXSetAudioVolume(IntPtr Device, char volume, ref char balance);

            [DllImport(DxMediaApiDll)]
            public static extern int DXGetAudioVolume(IntPtr Device, ref char volume, ref char balance);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSetVideoCodec(IntPtr Device, ref TDEVICE_TAG videoEncoder);

             [DllImport(DxMediaApiDll)]
            public static extern int DXSetVideoCodecPara(IntPtr Device, int codecType, ref TVidCodecX264Para VideoCodecPara);


            [DllImport(DxMediaApiDll)]
            public static extern int DXSetAudioCodec(IntPtr Device,ref  TDEVICE_TAG audioEncoder);


            [DllImport(DxMediaApiDll)]
            public static extern int DXStartCapture(IntPtr Device,
                                    string szFileName,
                                    Boolean saveAudio,
                                    ref int timeSize,
                                    ref int dataSize,
                                    int vidRatio);

            [DllImport(DxMediaApiDll)]
            public static extern int DXStopCapture(IntPtr Device);


            [DllImport(DxMediaApiDll)]
            public static extern int DXFreezeCaputre(IntPtr Device,Boolean  bFreeze);





            [DllImport(DxMediaApiDll)]
            public static extern int DXEnableDeinterlace(IntPtr Device, int deinterlace);

            [DllImport(DxMediaApiDll)]
            public static extern int DXEnableDenoise(IntPtr Device, int denoise);

            [DllImport(DxMediaApiDll)]
            public static extern int DXEnableSharpen(IntPtr Device, int deSharpness);



            [DllImport(DxMediaApiDll)]
            public static extern int DXSetTextOSD(IntPtr Device,
                                               int x,
                                                int y,
                                                int TextNO,
                                                IntPtr  osdText,
                                                int pointSize,
                                                string faceName,
                                                int color,
                                                int bgcolor,
                                                Boolean transparent);




            [DllImport(DxMediaApiDll)]
            public static extern int DXSetTimeOSD(IntPtr Device,
                                                 int x,
                                                  int y,
                                                  int pointSize,
                                                  string faceName,
                                                  int color,
                                                  int bgcolor,
                                                  Boolean transparent);




            [DllImport(DxMediaApiDll)]
            public static extern int DXSetPictureOSD(IntPtr Device,
                                                 int x,
                                                int y,
                                                int PicNO,
                                                string picFileName,
                                                Boolean transparent,
                                                 Byte alpha);

			
												 
			//画矩形
			[DllImport(DxMediaApiDll)]
			public static extern int DXSetRectOSD(IntPtr Device,
													int x,
													int y,
													int width, 
													int height,
													int RectNO,
													int lineSize,
													TlineStyle lineStyle,
													int color,
                                                    Byte alpha);
												 
			//画线
			[DllImport(DxMediaApiDll)]
			public static extern int DXSetLineOSD(IntPtr Device,
													int x0,
													int y0,
													int x1, 
													int y1,
													int RectNO,
													int lineSize,
													TlineStyle lineStyle,
													int color,
                                                    Byte alpha);

          //0表示时间叠加，1表示文本叠加，2表示图片叠加，3表示直线叠加，4表示矩形框叠加
          [DllImport(DxMediaApiDll)]
            public static extern int DXEnOSDDisp(IntPtr Device,
                                                 int osdType,
                                                int number,
                                                 Boolean transparent);
                                             





            //////////////////////////////////////////////////////////////////
//            [DllImport(DxMediaApiDll)]
          [DllImport(DxMediaApiDll)]
            public static extern int DXStartRawVideoCallback(IntPtr Device, TfnRawVideoCallback fn, IntPtr context);

//            [DllImport(DxMediaApiDll)]
          [DllImport(DxMediaApiDll)]
            public static extern int DXStopRawVideoCallback(IntPtr Device);


          [DllImport(DxMediaApiDll)]
          public static extern int DXStartEncVideoCallback(IntPtr Device, fnEncVideoCallback fn, IntPtr context);

          //            [DllImport(DxMediaApiDll)]
          [DllImport(DxMediaApiDll)]
          public static extern int DXStopEncVideoCallback(IntPtr Device);

         [DllImport(DxMediaApiDll)]
          public static extern int DXStartEncVideo(IntPtr Device, Boolean saveAudio, int  vidRatio);

         [DllImport(DxMediaApiDll)]
         public static extern int DXCreateMp4file(IntPtr Device, [MarshalAs(UnmanagedType.AnsiBStr)] string szFileName, Boolean  bHasAud);

           [DllImport(DxMediaApiDll)]
         public static extern int DXWriteMp4file(IntPtr mp4hnd,
                                                   TDataType DataType,
                                                   IntPtr pIn,
                                                   int nlen,
                                                   Boolean  isKey,
                                                   ulong TimeStamp);

         [DllImport(DxMediaApiDll)]
           public static extern int DXCloseMp4file(IntPtr Device);


                [DllImport(DxMediaApiDll)]
         public static extern int DXSetParentWnd(IntPtr Device, IntPtr hPtWnd);


         [DllImport(DxMediaApiDll)]
            public static extern int DXGetBuf(IntPtr Device,
                                             ref int width,
                                             ref int height,
                                             IntPtr buffer,
                                             Boolean filp);
                           
                            





           //////////////////////////////////////////////////////////////////////
            [DllImport(DxMediaApiDll)]
            public static extern int DXSnapToBMPFile(IntPtr Device, [MarshalAs(UnmanagedType.AnsiBStr)] string szFileName, ref RECT rect);



            [DllImport(DxMediaApiDll)]
            public static extern int DXSnapToJPGFile(IntPtr Device, [MarshalAs(UnmanagedType.AnsiBStr)] string szFileName, int quality, ref RECT rect);


            [DllImport(DxMediaApiDll)]
            public static extern int DXSaveBMPFile([MarshalAs(UnmanagedType.AnsiBStr)] string szFileName, IntPtr buffer, int bufferLen,int colorSpace,
                             int width, int height, int bytesWidth);

            [DllImport(DxMediaApiDll)]
            public static extern int DXSaveJPGFile([MarshalAs(UnmanagedType.AnsiBStr)] string szFileName,
                                                    IntPtr buffer, 
                                                    int bufferLen,
                                                    int colorSpace,
                                                    int width, 
                                                    int height,
                                                    int bytesWidth, 
                                                    int quality);

            [DllImport(DxMediaApiDll)]
            public static extern int DXGetFrameBuffer(IntPtr Device, 
                                                    IntPtr buffer, 
                                                    int bufferLen,
                                                    ref int gotBufferLen,
                                                    ref int colorSpace,
                                                     ref int width, 
                                                    ref int height, 
                                                    ref int bytesWidth, 
                                                    ref RECT  rect);


         [DllImport(DxMediaApiDll)]
            public static extern int DXConvertYUVtoRGB(IntPtr Device,
                                                        IntPtr pYUVBuf,
                                                        IntPtr pRGBBuf,
                                                        int lImgWidth,
                                                        int lImgHeight,
                                                        Boolean bInverted,
                                                        Boolean bInvertColor);

        


         [DllImport(DxMediaApiDll)]
            public static extern int DXEnDataRaterPara(IntPtr Device, int RateType, ref  TDRateColorPara DataPara);


         [DllImport(DxMediaApiDll)]
         public static extern int DXEnFScale(IntPtr Device, Boolean bEnFScale, ref RECT rec, int enAlogrithm);
           
 
        


        /*
            [DllImport(DxMediaApiDll)]
            public static extern IntPtr DXCreateBufferImg(IntPtr imgbuffer,  int buffersize,
                              int colorSpace,int width,  int height, ref int err);


            [DllImport(DxMediaApiDll)]
            public static extern int DXCreateFileImg(ref string  szImgFile, ref int err);

            [DllImport(DxMediaApiDll)]
            public static extern int DXUpdateImg(IntPtr img, IntPtr hPrevWnd ,ref RECT rect);

            [DllImport(DxMediaApiDll)]
            public static extern int DXDestroyImg(IntPtr img);*/






             

            [DllImport(DxMediaApiDll)]
            public static extern int DXFlipVideo(IntPtr Device,Boolean flip);


            [DllImport(DxMediaApiDll)]
            public static extern int DXMirrorVideo(IntPtr Device, Boolean mirror);

           [DllImport(DxMediaApiDll)]
        public static extern int DXYuy2Gray(IntPtr src,
                                            IntPtr dst,
                                            int pixelsPerLines,
                                            int width,
                                            int height);

           [DllImport(DxMediaApiDll)]
        public static extern int DXStartRawVidScale( ref  TVidScalePara pScalePara, IntPtr pscalehad);
          
         [DllImport(DxMediaApiDll)]
           public static extern int DXRawVidScale(IntPtr scalehad, IntPtr src, IntPtr dst);                            
                                          
           [DllImport(DxMediaApiDll)]
        public static extern int DXStopRawVidScale( IntPtr scalehad);               

        
              [DllImport(DxMediaApiDll)]
           public static extern int DXStartNetTrans(IntPtr Device, TNetStreamType nPrtclType,ref TNetTransPara stNetPara);     
                          
          [DllImport(DxMediaApiDll)]
        public static extern int DXNetTransData(IntPtr Device,
                                            TNetStreamType nPrtclType,
                                            TDataType DataType,
                                            IntPtr data,
                                            int len,
                                            Boolean bIskey,
                                            ulong ms_pts);

  
                [DllImport(DxMediaApiDll)]
             public static extern int DXStopNetTrans(IntPtr device, TNetStreamType nPrtclType);


                [DllImport(DxMediaApiDll)]
                public static extern int DXGetVideoParaHD(IntPtr Device,
                                                ref int colorspace,
                                                ref int width,
                                                ref int height,
                                                ref float framerate);

                [DllImport(DxMediaApiDll)]
                public static extern int DXSetVideoParaHD(IntPtr Device,
                                                 int colorspace,
                                                 int width,
                                                 int height,
                                                float framerate);


                [DllImport(DxMediaApiDll, CharSet= CharSet.Ansi)]
             public static extern IntPtr  DXGetDeviceName(IntPtr Device);


                [DllImport(DxMediaApiDll)]
                public static extern int DXCreatePropertyPage(IntPtr Device,
                                                 int nPropertyType,
                                                  IntPtr hWndOwner,
                                                 int X,
                                                 int Y,
                                                string szCaption);


                //	nGainType - [in]  R:0  G:1  B:2
                [DllImport(DxMediaApiDll)]
                public static extern int DXSetGainHD(IntPtr Device, char nGainType, char chValue);

            [DllImport(DxMediaApiDll)]
                   public static extern Boolean DXDeviceIsHD(IntPtr Device);
                [DllImport(DxMediaApiDll)]
                public static extern Boolean DXDeviceIsUVC(IntPtr Device);
    
         [DllImport(DxMediaApiDll)]
          public static extern Boolean DXVideoCodecFilterIsSupport(string codecFilter);
    
     



            ///////////////////////////////////////////////////////
            // 获得窗口矩形
            [DllImport("user32.dll")]
            public static extern int GetWindowRect(IntPtr hWnd, out RECT lpRect);

            // 获得客户区矩形
            [DllImport("user32.dll")]
            public static extern int GetClientRect(IntPtr hWnd, out RECT lpRect);

            [DllImport("msvcrt.dll", EntryPoint = "memcpy", CallingConvention = CallingConvention.Cdecl, SetLastError = false)]
            public static extern void MemCopy(IntPtr dest, IntPtr src, int count);//字节数组到字节数组的拷贝


            }
            }





















        
    


