
// VcPlayerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcPlayer.h"
#include "VcPlayerDlg.h"
#include "afxdialogex.h"
#include "MediaOpenDlg.h"

#define WM_PLAYEVENT (WM_USER + 1010)

#define MS2HOUR(_t) (int)(_t / (60 * 60 * 1000))
#define MS2MINS(_t) (int)(_t / (60 * 1000) % 60)
#define MS2SEC(_t) (int)(_t / 1000 % 60)

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CVcPlayerDlg dialog




CVcPlayerDlg::CVcPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CVcPlayerDlg::IDD, pParent)
	, m_hPlay(NULL)
	, m_bPaused(FALSE)
	, m_bDrag(FALSE)
	, m_strTime(_T(""))
	, m_bFile(FALSE)
	, m_fFps(0)
	, m_bFullScreen(FALSE)
	, m_bRecord(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVcPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_VIDEO, m_Video);
}

BEGIN_MESSAGE_MAP(CVcPlayerDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MEDIAOPEN, &CVcPlayerDlg::OnBnClickedMediaopen)
	ON_BN_CLICKED(IDC_PLAY, &CVcPlayerDlg::OnBnClickedPlay)
	ON_BN_CLICKED(IDC_PAUSE, &CVcPlayerDlg::OnBnClickedPause)
	ON_BN_CLICKED(IDC_STOP, &CVcPlayerDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_CLOSE, &CVcPlayerDlg::OnBnClickedClose)
	ON_MESSAGE(WM_PLAYEVENT, &CVcPlayerDlg::OnPlayevent)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SNAPSHOT, &CVcPlayerDlg::OnBnClickedSnapshot)
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_FAST, &CVcPlayerDlg::OnBnClickedFast)
	ON_BN_CLICKED(IDC_SLOW, &CVcPlayerDlg::OnBnClickedSlow)
	ON_BN_CLICKED(IDC_MUTE, &CVcPlayerDlg::OnClickedMute)
	ON_BN_CLICKED(IDC_NEXTFRAME, &CVcPlayerDlg::OnBnClickedNextframe)
	ON_BN_CLICKED(IDC_FULLSCREEN, &CVcPlayerDlg::OnBnClickedFullscreen)
	ON_BN_CLICKED(IDC_RECORD, &CVcPlayerDlg::OnBnClickedRecord)
END_MESSAGE_MAP()


// CVcPlayerDlg message handlers

BOOL CVcPlayerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	DXPlayInit();
	UpdatePlayState();

	((CSliderCtrl*)GetDlgItem(IDC_VOLUME))->SetRange(0, 100);
	((CSliderCtrl*)GetDlgItem(IDC_VOLUME))->SetTicFreq(20);
	((CSliderCtrl*)GetDlgItem(IDC_POSITION))->SetRange(0, 10000);
	SetTimer(0, 100, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVcPlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVcPlayerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcPlayerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

static void play_event_cb(play_handle_t hplay, int state, void *data)
{
	ASSERT(data == theApp.m_pMainWnd);
	((CWnd*)data)->PostMessage(WM_PLAYEVENT, (WPARAM)hplay, (LPARAM)state);
}

void CVcPlayerDlg::OnBnClickedMediaopen()
{
	// TODO: Add your control notification handler code here
	CMediaOpenDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		USES_CONVERSION;

		if (m_hPlay)
		{
			OnBnClickedClose();
		}

		if (::PathFileExists(dlg.m_strMedia))
		{
			m_hPlay = DXPlayOpenFile(T2A(dlg.m_strMedia), m_Video.GetSafeHwnd());
			m_bFile = TRUE;
		}
		else
		{
			m_hPlay = DXPlayOpenRtsp(T2A(dlg.m_strMedia), m_Video.GetSafeHwnd());
			m_bFile = FALSE;
		}

		if (m_hPlay)
		{
#define PLAY_STATE_EVENT ( DXPLAY_OPENING | DXPLAY_BUFFERING | DXPLAY_PLAYING | DXPLAY_PAUSED | DXPLAY_STOPPED | DXPLAY_ENDED | DXPLAY_ERROR )
			DXPlayStateEvent(m_hPlay, PLAY_STATE_EVENT, play_event_cb, this);
		}

		UpdatePlayState();
	}
}


void CVcPlayerDlg::OnBnClickedPlay()
{
	// TODO: Add your control notification handler code here
	if (m_hPlay)
	{
		DXPlayStart(m_hPlay);
		m_fFps = 0;
		m_bPaused = FALSE;
	}
}


void CVcPlayerDlg::OnBnClickedPause()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		m_bPaused = !m_bPaused;
		DXPlayPause(m_hPlay, m_bPaused);
		UpdatePlayState();
	}
}


void CVcPlayerDlg::OnBnClickedStop()
{
	// TODO: Add your control notification handler code here
	if (m_hPlay)
	{
		if (m_bRecord)
		{
			OnBnClickedRecord();
		}

		DXPlayStop(m_hPlay);
		UpdatePlayState();
	}
}


void CVcPlayerDlg::OnBnClickedClose()
{
	// TODO: Add your control notification handler code here
	if (m_hPlay)
	{
		if (m_bRecord)
		{
			OnBnClickedRecord();
		}

		DXPlayClose(m_hPlay);
		m_hPlay = NULL;
		UpdatePlayState();
	}
}


afx_msg LRESULT CVcPlayerDlg::OnPlayevent(WPARAM wParam, LPARAM lParam)
{
	if (m_hPlay == (play_handle_t)wParam)
	{
		switch (lParam) {
		case DXPLAY_PLAYING:
			if (m_bFile)
			{
				play_time_t t = DXPlayGetLength(m_hPlay);
				m_strTime.Format(_T("%02d:%02d:%02d"), MS2HOUR(t), MS2MINS(t), MS2SEC(t));
			}
			UpdatePlayState();
			::Sleep(100);
			((CSliderCtrl*)GetDlgItem(IDC_VOLUME))->SetPos(DXPlayGetVolume(m_hPlay));
			((CButton*)GetDlgItem(IDC_MUTE))->SetCheck(DXPlayGetMute(m_hPlay) ? BST_CHECKED : BST_UNCHECKED);
			break;
		case DXPLAY_ENDED:
			OnBnClickedStop();
			break;
		case DXPLAY_ERROR:
			OnBnClickedClose();
			MessageBox(_T("An error occurred while playing!"));
			break;
		}
	}
	return 0;
}


void CVcPlayerDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: Add your message handler code here
	OnBnClickedClose();
	DXPlayExit();
}


void CVcPlayerDlg::OnBnClickedSnapshot()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		CFileDialog dlg(FALSE, _T("jpg"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("jpg Files(*.jpg)|*.jpg||"));
		if (dlg.DoModal() == IDOK)
		{
			USES_CONVERSION;
			DXPlayTakeSnapshot(m_hPlay, T2A(dlg.GetPathName()), 0, 0);
		}
	}
}


void CVcPlayerDlg::UpdatePlayState(void)
{
	BOOL bPlay = IsPlay();
	GetDlgItem(IDC_PLAY)->EnableWindow(m_hPlay != NULL);
	GetDlgItem(IDC_CLOSE)->EnableWindow(m_hPlay != NULL);
	GetDlgItem(IDC_STOP)->EnableWindow(bPlay);
	GetDlgItem(IDC_SNAPSHOT)->EnableWindow(bPlay);
	GetDlgItem(IDC_FULLSCREEN)->EnableWindow(bPlay);
	GetDlgItem(IDC_RECORD)->EnableWindow(bPlay);
	SetDlgItemText(IDC_RECORD, m_bRecord ? _T("Rec Stop") : _T("Record"));
	GetDlgItem(IDC_PAUSE)->EnableWindow(m_bFile && bPlay);
	SetDlgItemText(IDC_PAUSE, m_bPaused ? _T("Resume") : _T("Pause"));
	GetDlgItem(IDC_NEXTFRAME)->EnableWindow(m_bFile && bPlay);
	GetDlgItem(IDC_SLOW)->EnableWindow(m_bFile && bPlay);
	GetDlgItem(IDC_FAST)->EnableWindow(m_bFile && bPlay);
	GetDlgItem(IDC_POSITION)->EnableWindow(m_bFile && bPlay);
	GetDlgItem(IDC_INFO)->ShowWindow(bPlay ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_RATE)->ShowWindow(m_bFile && bPlay ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_TIME)->ShowWindow(m_bFile && bPlay ? SW_SHOW : SW_HIDE);
	if (!bPlay)
	{
		((CSliderCtrl*)GetDlgItem(IDC_POSITION))->SetPos(0);
	}
	else if (m_bFile)
	{
		CString str;
		str.Format(_T("%.2fX"), DXPlayGetRate(m_hPlay));
		SetDlgItemText(IDC_RATE, str);
	}
}


void CVcPlayerDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if (IsPlay())
	{
		CString str;
		if (m_bFile)
		{
			if (!m_bDrag)
			{
				float n = DXPlayGetPostion(m_hPlay);
				((CSliderCtrl*)GetDlgItem(IDC_POSITION))->SetPos((int)(n * 10000));
			}

			play_time_t t = DXPlayGetTime(m_hPlay);
			str.Format(_T("%02d:%02d:%02d / "), MS2HOUR(t), MS2MINS(t), MS2SEC(t));
			str += m_strTime;
			SetDlgItemText(IDC_TIME, str);
		}

		if (m_fFps == 0)
		{
			m_fFps = DXPlayGetFrameRate(m_hPlay);
			if (m_fFps > 0)
			{
				unsigned int w, h;
				DXPlayGetVideoSize(m_hPlay, &w, &h);
				str.Format(_T("Video: %u * %u, %.2ffps\n"), w, h, DXPlayGetFrameRate(m_hPlay));
				SetDlgItemText(IDC_INFO, str);
			}
		}
	}

	CDialogEx::OnTimer(nIDEvent);
}


void CVcPlayerDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
	if (IsPlay())
	{
		int nID = pScrollBar->GetDlgCtrlID();
		if (nID == IDC_POSITION)
		{
			m_bDrag = SB_THUMBTRACK == nSBCode;
			if (SB_ENDSCROLL == nSBCode || SB_PAGELEFT == nSBCode || SB_PAGERIGHT == nSBCode)
			{
				if (m_bFile)
				{
					int n = ((CSliderCtrl*)GetDlgItem(IDC_POSITION))->GetPos();
					DXPlaySetPostion(m_hPlay, (float)n / 10000);
				}
			}
		}
		else if (nID == IDC_VOLUME)
		{
			if (SB_ENDSCROLL == nSBCode || SB_PAGELEFT == nSBCode || SB_PAGERIGHT == nSBCode)
			{
				int n = ((CSliderCtrl*)GetDlgItem(IDC_VOLUME))->GetPos();
				DXPlaySetVolume(m_hPlay, n);
			}
		}
	}

	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CVcPlayerDlg::OnBnClickedFast()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		float f = DXPlayGetRate(m_hPlay);
		if (f < 2.0f)
		{
			f += 0.25f;
			DXPlaySetRate(m_hPlay, f);
			UpdatePlayState();
		}
	}
}


void CVcPlayerDlg::OnBnClickedSlow()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		float f = DXPlayGetRate(m_hPlay);
		if (f > 0.5f)
		{
			f -= 0.25f;
			DXPlaySetRate(m_hPlay, f);
			UpdatePlayState();
		}
	}
}


void CVcPlayerDlg::OnClickedMute()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		DXPlaySetMute(m_hPlay, !DXPlayGetMute(m_hPlay));
	}
}


void CVcPlayerDlg::OnBnClickedNextframe()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		DXPlayDisplayNextFrame(m_hPlay);
		m_bPaused = TRUE;
		UpdatePlayState();
	}
}


void CVcPlayerDlg::OnBnClickedFullscreen()
{
	// TODO: Add your control notification handler code here
	if (IsPlay())
	{
		if (m_bFullScreen)
		{
			m_Video.SetParent(this);
			m_Video.MoveWindow(m_Rect);
		}
		else
		{
			CRect rc;
			m_Video.GetWindowRect(m_Rect);
			m_Video.GetClientRect(rc);
			m_Video.ClientToScreen(rc);

			int x = rc.left - m_Rect.left;
			int y = rc.top - m_Rect.top;
			rc.SetRect(0, 0, ::GetSystemMetrics(SM_CXSCREEN), ::GetSystemMetrics(SM_CYSCREEN));
			if (x > 0 || y > 0)
			{ // ȥڱ߿
				rc.InflateRect(x, y);
				rc.MoveToXY(-x, -y);
			}
			m_Video.SetParent(NULL);
			m_Video.MoveWindow(rc);

			ScreenToClient(m_Rect); // δȫǰĴλ
		}
		m_bFullScreen = !m_bFullScreen;
	}
}


void CVcPlayerDlg::OnBnClickedRecord()
{
	// TODO: Add your control notification handler code here
	if (m_bRecord)
	{
		DXPlayRecordStop(m_hPlay);
		m_bRecord = FALSE;
	}
	else if (IsPlay())
	{
		LPMALLOC lpMalloc;
		if (::SHGetMalloc(&lpMalloc) != NOERROR) 
			return;

		TCHAR szDisplayName[_MAX_PATH];
		TCHAR szBuffer[_MAX_PATH];
		BROWSEINFO browseInfo;
		browseInfo.hwndOwner = GetSafeHwnd();
		browseInfo.pidlRoot = NULL;
		browseInfo.pszDisplayName = szDisplayName;
		browseInfo.lpszTitle = _T("Choose File Save Folder");
		browseInfo.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
		browseInfo.lpfn = NULL;
		browseInfo.lParam = 0;

		LPITEMIDLIST lpItemIDList;
		if ((lpItemIDList = ::SHBrowseForFolder(&browseInfo)) != NULL)
		{
			// Get the path of the selected folder from the item ID list.
			if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
			{
				if (szBuffer[0] != '\0')
				{
					USES_CONVERSION;
					m_bRecord = DXPlayRecordStart(m_hPlay, T2A(szBuffer));
				}
			}
		}

		if (lpItemIDList)
		{
			lpMalloc->Free(lpItemIDList);
		}
		lpMalloc->Release();
	}

	UpdatePlayState();
}
