unit ColorSetting;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,IniFiles;

type
  TColorProperty = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    GroupBox1: TGroupBox;
    ScrollBarBright: TScrollBar;
    ScrollBarContrast: TScrollBar;
    ScrollBarHue: TScrollBar;
    ScrollBarSaturation: TScrollBar;
    ScrollBarSharp: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BrightVal: TLabel;
    ContrastVal: TLabel;
    HueVal: TLabel;
    SaturationVal: TLabel;
    SharpVal: TLabel;
    DefColor: TButton;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    RgainValue: TLabel;
    GgainValue: TLabel;
    BgainValue: TLabel;
    btGainDefault: TButton;
    ScrollRgain: TScrollBar;
    ScrollGgain: TScrollBar;
    ScrollBgain: TScrollBar;
    procedure ScrollBarBrightChange(Sender: TObject);
    procedure ScrollBarContrastChange(Sender: TObject);
    procedure ScrollBarHueChange(Sender: TObject);
    procedure ScrollBarSaturationChange(Sender: TObject);
    procedure ScrollBarSharpChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DefColorClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure btGainDefaultClick(Sender: TObject);
    procedure ScrollBgainChange(Sender: TObject);
    procedure ScrollGgainChange(Sender: TObject);
    procedure ScrollRgainChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ColorProperty: TColorProperty;
  iFlags:Integer   ;

implementation
 uses GlobalVar,DxMediaFunction,DxMediaApi;
{$R *.dfm}

procedure TColorProperty.ScrollBarBrightChange(Sender: TObject);
begin
     BrightValue:= ScrollBarBright.Position;
     BrightVal.Caption :=IntToStr(BrightValue);
     DXSetDisplayPara(DeviceInfo[CardNo].dwChannelHandle,0, BrightValue,iFlags);

     SettingIni.WriteInteger('Colorpropterty','BrightnessValue'+inttostr(CardNo),BrightValue);
end;

procedure TColorProperty.ScrollBarContrastChange(Sender: TObject);
begin
    ContrastValue:= ScrollBarContrast.Position;
     ContrastVal.Caption :=IntToStr(ContrastValue);
     DXSetDisplayPara(DeviceInfo[CardNo].dwChannelHandle,1, ContrastValue,iFlags);

     SettingIni.WriteInteger('Colorpropterty','ContrastValue'+inttostr(CardNo),ContrastValue);
end;

procedure TColorProperty.ScrollBarHueChange(Sender: TObject);
begin
      HueValue:= ScrollBarHue.Position;
      HueVal.Caption :=IntToStr(HueValue);
       DXSetDisplayPara(DeviceInfo[CardNo].dwChannelHandle,2, HueValue,iFlags);

      SettingIni.WriteInteger('Colorpropterty','HueValue'+inttostr(CardNo),HueValue);
end;

procedure TColorProperty.ScrollBarSaturationChange(Sender: TObject);
begin
      StaturationValue:= ScrollBarSaturation.Position;
      SaturationVal.Caption :=IntToStr(StaturationValue);
      DXSetDisplayPara(DeviceInfo[CardNo].dwChannelHandle,3, StaturationValue,iFlags);

     SettingIni.WriteInteger('Colorpropterty','StaturationValue'+inttostr(CardNo),StaturationValue);

end;

procedure TColorProperty.ScrollBarSharpChange(Sender: TObject);
begin
      SharpValue:= ScrollBarSharp.Position;
      SharpVal.Caption :=IntToStr(SharpValue);
      DXSetDisplayPara(DeviceInfo[CardNo].dwChannelHandle,4, SharpValue,iFlags);
      
      SettingIni.WriteInteger('Colorpropterty','SharpnessValue'+inttostr(CardNo),SharpValue);
end;

procedure TColorProperty.OKBtnClick(Sender: TObject);
begin
     ColorProperty.Close ;
end;

procedure TColorProperty.FormShow(Sender: TObject);
var
     i:LongWord   ;
begin


        if  (DeviceInfo[CardNo].dwConnectState=True) then
       begin
              for i:=0 to 4 do
              begin
                     //õƵ豸ɫʿռ䷶ΧĬֵ
                       DXGetDisplayParaRange(DeviceInfo[CardNo].dwChannelHandle,i,
                                             DeviceColor[i].MinVal,
                                             DeviceColor[i].MaxVal,
                                             DeviceColor[i].StepVal,
                                             DeviceColor[i].DefaultVal,
                                             iFlags);


              end;
              //ֵȽ
                ScrollBarBright.Max :=DeviceColor[0].MaxVal;
              ScrollBarBright.Min :=DeviceColor[0].MinVal;
              ScrollBarBright.LargeChange :=DeviceColor[0].StepVal;
              ScrollBarBright.Position :=DeviceColor[0].DefaultVal;
              //ֵԱȶȽ
             ScrollBarContrast.Max :=DeviceColor[1].MaxVal;
              ScrollBarContrast.Min :=DeviceColor[1].MinVal;
              ScrollBarContrast.LargeChange :=DeviceColor[1].StepVal;
              ScrollBarContrast.Position :=DeviceColor[1].DefaultVal;
              //ֵͶȽ
              ScrollBarHue.Max :=DeviceColor[2].MaxVal;
              ScrollBarHue.Min :=DeviceColor[2].MinVal;
              ScrollBarHue.LargeChange:=DeviceColor[2].StepVal;
              ScrollBarHue.Position := DeviceColor[2].DefaultVal;
                   //ֵɫȽ
             ScrollBarSaturation.Max :=DeviceColor[3].MaxVal;
              ScrollBarSaturation.Min :=DeviceColor[3].MinVal;
              ScrollBarSaturation.LargeChange:=DeviceColor[3].StepVal;
              ScrollBarSaturation.Position :=DeviceColor[3].DefaultVal;

               ////ֵ
              ScrollBarSharp.Max :=DeviceColor[4].MaxVal;
              ScrollBarSharp.Min :=DeviceColor[4].MinVal;
              ScrollBarSharp.LargeChange :=DeviceColor[4].StepVal;
              ScrollBarSharp.Position :=DeviceColor[4].DefaultVal;

              DeviceInfo[CardNo].dwGainDefault:=64;
              ScrollRgain.Max :=128;
              ScrollRgain.Min:=0;
              ScrollRgain.LargeChange:=1;
              ScrollRgain.Position:=DeviceInfo[CardNo].dwGainDefault;


              ScrollGgain.Max :=128;
              ScrollGgain.Min:=0;
              ScrollGgain.LargeChange:=1;
              ScrollGgain.Position:=DeviceInfo[CardNo].dwGainDefault;



              ScrollBgain.Max :=128;
              ScrollBgain.Min:=0;
              ScrollBgain.LargeChange:=1;
              ScrollBgain.Position:=DeviceInfo[CardNo].dwGainDefault;


       end;








end;

procedure TColorProperty.DefColorClick(Sender: TObject);
var i:LongWord ;


begin
           if  (DeviceInfo[CardNo].dwConnectState=True) then
       begin
            ScrollBarBright.Position :=DeviceColor[0].DefaultVal;
            ScrollBarContrast.Position :=DeviceColor[1].DefaultVal;
            ScrollBarHue.Position := DeviceColor[2].DefaultVal;
            ScrollBarSaturation.Position :=DeviceColor[3].DefaultVal;
            ScrollBarSharp.Position :=DeviceColor[4].DefaultVal;
            for i:=0 to 4 do
            begin
                  DXSetDisplayPara(DeviceInfo[CardNo].dwChannelHandle,i,DeviceColor[i].DefaultVal,iFlags);
            end;

       end;


end;

procedure TColorProperty.CancelBtnClick(Sender: TObject);
begin
      ColorProperty.Close ;
end;

procedure TColorProperty.btGainDefaultClick(Sender: TObject);
var i:longword;
begin
          if  ((DeviceInfo[CardNo].dwConnectState=True)and( DeviceInfo[CardNo].dwHDdevice=true)) then
          begin
                    ScrollRgain.Position:=DeviceInfo[CardNo].dwGainDefault;
                    ScrollGgain.Position:=DeviceInfo[CardNo].dwGainDefault;
                    ScrollBgain.Position:=DeviceInfo[CardNo].dwGainDefault;
                    RgainValue.Caption :='64';
                    GgainValue.Caption :='64';
                    BgainValue.Caption :='64';

                   for i:=0 to 2 do
            begin
                  DXSetGainHD(DeviceInfo[CardNo].dwChannelHandle,i,DeviceInfo[CardNo].dwGainDefault);
            end;

          end;
end;

procedure TColorProperty.ScrollBgainChange(Sender: TObject);
begin
          if  ((DeviceInfo[CardNo].dwConnectState=True)and( DeviceInfo[CardNo].dwHDdevice=true)) then
          begin
                  DeviceInfo[CardNo].dwBgainVal:= ScrollBgain.Position;
                  BgainValue.Caption :=IntToStr(DeviceInfo[CardNo].dwBgainVal);
                  DXSetGainHD(DeviceInfo[CardNo].dwChannelHandle,2,DeviceInfo[CardNo].dwBgainVal);
          end;
end;

procedure TColorProperty.ScrollGgainChange(Sender: TObject);
begin
       if  ((DeviceInfo[CardNo].dwConnectState=True)and( DeviceInfo[CardNo].dwHDdevice=true)) then
          begin
                   DeviceInfo[CardNo].dwGgainVal:= ScrollGgain.Position;
                  GgainValue.Caption :=IntToStr(DeviceInfo[CardNo].dwGgainVal);
                  DXSetGainHD(DeviceInfo[CardNo].dwChannelHandle,1,DeviceInfo[CardNo].dwGgainVal);
          end;
end;

procedure TColorProperty.ScrollRgainChange(Sender: TObject);
begin
        if  ((DeviceInfo[CardNo].dwConnectState=True)and( DeviceInfo[CardNo].dwHDdevice=true)) then
          begin
                   DeviceInfo[CardNo].dwRgainVal:= ScrollRgain.Position;
                  RgainValue.Caption :=IntToStr(DeviceInfo[CardNo].dwRgainVal);
                  DXSetGainHD(DeviceInfo[CardNo].dwChannelHandle,0,DeviceInfo[CardNo].dwRgainVal);
          end;
end;

end.
