////////////////////////////////////////////////////////////////////////////////////////////
//     (Copyright (C) 2011                                                               ///
//    shenzhen zhongan vision  All rights reserved.                                                              ///
//          %version: 1 %                                                                ///
//                                                                                       ///
// Last Update  : %date_modified: tony yu  2014 %   qq:67505494  e-mail:yyhnet@163.com   ///
//                                                                                       ///
// Description: DXMediaCap delphi7 api                                                     ///
///                                                                                      ///
////////////////////////////////////////////////////////////////////////////////////////////

unit DxMediaApi;

interface
uses
 Windows;
const
  DLL_DxMediaApi= 'DXMediaCap.dll';

type
    TNotifyEvent   =   procedure(Sender:   TObject)   of   object;

  TRETERRNO=
  (
	  RET_NOERROR	= 0,		//* no error */
	  RET_EXCEPTION,			//* sdk exception error */
	  RET_ERR_INIT,			//* do not initialize or initialize failed */
	  RET_INVALID_DEV,		//* do not find valid media device */
    RET_INVALID_CHANNEL,	//* invalid channel */
	  RET_BAD_POINTER,		//* invalid or Null pointer param */
	  RET_NO_MATCH,			//* do not match the compatiple object  */
	  RET_DX_FAILED,			//* fail from direct show */
	  RET_INVALID_HANDLE,		//* find null handle */
	  RET_INVALID_PARAM,		//* invalid function param */
	  RET_GDI_ERROR,			//* GDI error */
	  RET_IO_ERROR,			//* common io read or write error */
	  RET_FAILED,				//* common error */
	  RET_VIDFMT_ERROR		//* Video format selected do not support */
   );
         AnalogVideoStandard=
   (
    AnalogVideo_None       = $0,
    AnalogVideo_NTSC_M     = $1,
    AnalogVideo_NTSC_M_J   = $2,
    AnalogVideo_NTSC_433   = $4,
    AnalogVideo_PAL_B      = $10,
    AnalogVideo_PAL_D      = $20,
    AnalogVideo_PAL_H      = $80,
    AnalogVideo_PAL_I      = $100,
    AnalogVideo_PAL_M      = $200,
    AnalogVideo_PAL_N      = $400,
    AnalogVideo_PAL_60     = $800,
    AnalogVideo_SECAM_B    = $1000,
    AnalogVideo_SECAM_D    = $2000,
    AnalogVideo_SECAM_G    = $4000,
    AnalogVideo_SECAM_H    = $8000,
    AnalogVideo_SECAM_K    = $10000,
    AnalogVideo_SECAM_K1   = $20000,
    AnalogVideo_SECAM_L    = $40000,
    AnalogVideo_SECAM_L1   = $80000,
    AnalogVideo_PAL_N_COMBO = $100000
);


   TVideoProCamp_t=
   (
    VIDEOPROCAMP_BRIGHTNESS,            //
    VIDEOPROCAMP_CONTRAST,              //
    VIDEOPROCAMP_HUE,                   //
    VIDEOPROCAMP_SATURATION,            //
    VIDEOPROCAMP_SHARPNESS,             //
    VIDEOPROCAMP_GAMMA,                 //
    VIDEOPROCAMP_COLORENABLE,           //
    VIDEOPROCAMP_WHITEBALANCE,          //
    VIDEOPROCAMP_BACKLIGHT_COMPENSATION,// 
    VIDEOPROCAMP_GAIN                  //
    );
   //video original stream type
   TVideoOutputFormat_t=
   (
     UYVY = 0,                   //@enum BO_1234 - YUV422
     YUY2 = 1,                  //@enum BO_2143 - YUV422
     YV12 = 2,
     RGB24 = 3                 //@enum BO_1234 - RGB24
   );
   TosdType=
   (
     osd_text,
     osd_time,
     osd_image

   );



   THDVideoSource=
  (
    YpbprInput = 0,            //@enum input is CVBS channel 1
    HdmiInput  =1                //@enum input is CVBS channel 2

  );

  TFileType=
  (
    FILE_AVI=1,    //recording to the avi file
    FILE_MP4=2     //recording to the mp4 file

  );

  //video input port
  TVideoSource_t=
  (
    COMPOSITE_1 = 0,            //@enum input is CVBS channel 1
    COMPOSITE_2  =1,                //@enum input is CVBS channel 2
    S_VIDEO_1    =2,                  //@enum input is S-Video channel 1
    S_VIDEO_2    =3
  );
  //video standard
  TVideoStandard_t=
  (
    PAL = 0,                //@enum normal PAL standard
    NTSC = 1,               //@enum normal NTSC standard
    AUTOSTD = 2,             //@enum autodetect standard
    NO_COLOR_50HZ = 3      //@enum no color (black/white) in Auto mode
  );

 //video field type
 TStreamFlagsVideo_t=
 (
    hnOddField = 0,
    hnEvenField ,
    hnInterlaced
 );

 TBitrateControlType_t=
 (
	BITRATETYPE_CBR = 0,
	BITRATETYPE_VBR = 1
 );

 TImage_t =
 (
    IMAGE_BMP,
    IMAGE_JPG
 );

   TNetTransPara=record
            port:SmallInt    ;
            crtmp_uri:array[0..260] of AnsiChar ;

           end;

  TDEVICE_TAG = record
    idx:LongWord    ;
    cfFaceName:array[0..127] of AnsiChar ;
  end;
  PDEVICE_TAG=^TDEVICE_TAG;
   PRect=^ TRect ;


   TDRateColor_Para =record
     nBrightness:LongWord; // ǿȡֵ(-255255)
    	nContrast:LongWord ;  //Աȶǿȡֵ(-100100)
    end;


    ///add h264


TRcmode=
(
    codec_CBR=0,
    codec_VBR

) ;
 TcodecType=
 (
  codec_sys, 
  codec_intel264,
  codec_x264
 );

TVidCodecSysPara=record
	 bitrate:Integer; // ʣλkbps
   keyinterval:Integer;  //ؼ֡
end;

TVidCodecX264Para=record
      fps:Integer;
      keyframeinterval:Integer;
      rcMode:TRcmode;   //ʿ,x264_cqp(㶨), x264_crf(㶨), x264_abr(ƽ)
      Quality:Integer;
      Bitrate :Integer;
      Maxrbps:integer;
      Peekbps:integer;
 end;
   TlineStyle =
   (
            style_solid,
            style_dash,
            style_dot,
            style_dashdot

     );

  TDataType=
  (
     data_vid,   //video stream
     data_aud     //audio stream

  );

      TNetStreamType=
        (
            net_crtsp,
             net_crtmp,
             net_all

       ) ;
   //Զ豸Ϣṹ
Device_Info= Record
            dwCardNo:LongWord;
            dwChannelHandle:THandle;
            dwPrvHandle:THandle;
            dwPrvRect:TRect;
            dwSnapPicRect:TRect;
            dwZoomRect:TRect;
            dwCapHeight:Longword;//DWORD
            dwCapWeight:Longword;//DWORD
            dwFrameRate:Single;//DWORD
            dwColorspace:LongWord;
            dwVidStandard:LongWord ;
            dwOpenDevState:LongWord;
            dwConnectState:Boolean;
            dwPrviewState:Boolean;
            dwSharpness:Longword;  //DWORD
            dwSaturation:Longword; //DWORD
            dwHue:Longword; //DWORD
            dwContrast:Longword;// DWORD
            dwBrightness:Longword; //DWORD
            dwRecOK:Boolean;
            dwFreezeOK:Boolean;
            dwMaxHwnd:Boolean;
            dwVideoCodecStr:string ;
            dwVideoCodecpara:TVidCodecX264Para ;
            dwMp4FileHandle:THandle;
            DeviceName:string;
            dwHDdevice: Boolean ;
            dwGainDefault:byte;
            dwRgainVal:byte;
            dwGgainVal:byte;
            dwBgainVal:byte;



  end;
   pDevice_Info=^Device_Info;

   //OSD
TosdInfo= Record
          TimeX:Integer;
          TimeY:Integer;
          TxtPlaceX:Integer;
          TxtPlaceY: Integer;
         PicPlaceX: Integer;
         PicPlaceY: Integer;
         TimeFontSizeVal:LongWord;
         TxtFontSizeVal: LongWord;
         Osd_Txt:string;
         PicOsdFile: string;
         BackColor:TCOLORREF ;
          TimeColor:TCOLORREF ;
         TextColor:  TCOLORREF ;
         PicAlphaValue:byte;

         RectX:longword;
         RectY:longword;
         RectWidth:longword;
         RectHeight:longword;
         RectLineSizeVal:longword;
         RectLineStyle:TlineStyle;
         RectLineColor:TCOLORREF;
         LineX0:longword;
         LineY0:longword;
         LineX1:longword;
         LineY1:longword;
         LineSizeVal:longword;
         LineStyle:TlineStyle;
         LineColor:TCOLORREF;




end;

   //Ƶ豸ɫֵ
  Device_ColorProp=record
               ColorType:LongWord  ;
               MinVal:Integer  ;
               MaxVal:Integer  ;
               StepVal:Integer ;
               DefaultVal:Integer  ;
               CurVal:Integer  ;

  end;

     TSwsAlogrithm =
                (
	                SWS_SA_FAST_BILINEAR	,
	                SWS_SA_BILINEAR			,
	                SWS_SA_BICUBIC			,
	                SWS_SA_X				,
	                SWS_SA_POINT			,
	                SWS_SA_AREA				,
	                SWS_SA_BICUBLIN			,
	                SWS_SA_GAUSS			,
	                SWS_SA_SINC				,
	                SWS_SA_LANCZOS			,
	                SWS_SA_SPLINE			
                );


    TVidScalePara=record

             src_stride:LongWord  ;
               src_width:LongWord  ;
               src_height:LongWord  ;
               dst_stride:LongWord ;
               dst_width:LongWord  ;
               dst_height:LongWord  ;
                algorithm:TSwsAlogrithm;
        end;






  ///

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//                              HnLiveSdk  delphi7  api
///              
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---- call back functions define
  // ԭʼص
  TRawVideoCallback = procedure (           pBuff: PByte   ;
                                            colorSpace: longword;
                                            lWidth:longword;
                                            lHeight:longword;
                                            bytesWidth:LongWord;
                                            var context:LongWord); stdcall;
//encoder stream callback  function
   TEncVideoCallback = procedure (           pBuff: PByte   ;
                                            bufferSize: longword;
                                            bIsKey:boolean;
                                            nTmStamp:int64;
                                           dxmp4_handle: THandle;
                                            var context:LongWord); stdcall;





   //IOص
   TIOALARM_READ_CALLBACK= procedure(channelNumber: longword;
                                      lAlarmAddr:longword;
                                      lAlarmData:longword;
                                      context:pointer); stdcall;
   //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //    'DXMediaCap.dll';  dllΪdllͺ豸ص ܶװڴdll
   //     DLL_DxMediaApi
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  /// init sdk resource
  function DXInitialize():longword ; stdcall  ; external DLL_DxMediaApi;
  //'uninit sdk resource
   procedure  DXUninitialize(); stdcall; external DLL_DxMediaApi;
   //get sdk version
  function DXGetDeviceCount() :longword; stdcall ; external DLL_DxMediaApi;

  function DXEnumVideoDevices(var evTags:TDEVICE_TAG;var num:longword  ):longword; stdcall; external DLL_DxMediaApi;
  /// get video device number
  function DXEnumVideoCodecs(var evTags:TDEVICE_TAG;var num:longword  ):longword; stdcall; external DLL_DxMediaApi;

  function DXEnumAudioCodecs(var evTags:TDEVICE_TAG;var num:LongWord ):longword; stdcall; external DLL_DxMediaApi;

  function DXSetVideoCodec(device:THandle ; var evTags:TDEVICE_TAG ):longword; stdcall; external DLL_DxMediaApi;

  function DXSetAudioCodec(device:THandle ;var evTags:TDEVICE_TAG ):longword; stdcall; external DLL_DxMediaApi;

  function DXSetVideoCodecPara(device:THandle ;codecType:longword;var pPara:TVidCodecX264Para):longword; stdcall; external DLL_DxMediaApi;


  function DXEnumAudioDevices(var evTags:TDEVICE_TAG;var num:longword  ):longword; stdcall; external DLL_DxMediaApi;

  function DXEnumSoundDevices(var evTags:TDEVICE_TAG;var num:longword  ):longword; stdcall; external DLL_DxMediaApi;

  function DXOpenDevice(idx:longword ; var  err:LongWord  ):THandle   ; stdcall ; external DLL_DxMediaApi;

  function DXCloseDevice(device:THandle ):longword ; stdcall; external DLL_DxMediaApi;

  function DXDeviceRun(device:THandle ):longword ; stdcall; external DLL_DxMediaApi;

  function DXDevicePause(device:THandle ):longword ; stdcall; external DLL_DxMediaApi;

  function DXDeviceStop(device:THandle ):longword ; stdcall; external DLL_DxMediaApi;

  function DXGetDeviceState(device:THandle;var state:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

   function DXSetVideoSource(device:THandle;source:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

   function DXSetVideoSourceEx(device:THandle;source:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

  function DXGetSignalPresent(device:THandle;var signal:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

  function DXGetVideoPara(device:THandle;
                           var standard:LongWord;
                           var colorspace:LongWord;
                           var width:LongWord ;
                           var height:LongWord ;
                           var framerate:Single ):longword ; stdcall; external DLL_DxMediaApi;

  function DXSetVideoPara(device:THandle;
                           standard:LongWord;
                           colorspace:LongWord;
                           width:LongWord ;
                           height:LongWord ;
                           framerate:Single  ):longword ; stdcall; external DLL_DxMediaApi;

  function DXSetDisplayPara(device:THandle;
                           paraType:LongWord;
                           value:Integer ;
                           flags:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

  function DXGetDisplayPara(device:THandle;
                           paraType:LongWord;
                           var value:LongWord;
                           var flags:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

   function DXGetDisplayParaRange(device:THandle;
                                   paraType:LongWord  ;
                                   var pMin:Integer ;
                                   var pMax:Integer  ;
                                   var pSteppingDelta:Integer  ;
                                   var pDefault:Integer;
                                   var pCapsFlags :Integer  ):longword ; stdcall; external DLL_DxMediaApi;


 // function DXGetSignalPresent(device:THandle; var signal:LongWord) :longword ; stdcall; external DLL_DxMediaApi;

  function DXShowDeviceAttr(device:THandle;attrID:LongWord ;hOwner:THandle;var rect:TRect ):longword ; stdcall ; external DLL_DxMediaApi;


  function DXStartPreview(device:THandle;hWnd:THandle;var rect:TRect;vmrtype:LongWord ):longword ; stdcall ; external DLL_DxMediaApi;

  function DXStopPreview(device:THandle):longword ; stdcall ; external DLL_DxMediaApi;


  function DXFreezePreview(device:THandle;bFreeze:Boolean ):longword ; stdcall; external DLL_DxMediaApi;

  function DXHasAudio(device:THandle;var bHasAudio:Boolean  ):longword ; stdcall; external DLL_DxMediaApi;

  function DXSetAudioDevice(device:THandle;var audioDevice:TDEVICE_TAG ):longword ; stdcall; external DLL_DxMediaApi;

  function DXSetSoundOut(device:THandle;bSound:Boolean ):longword ; stdcall; external DLL_DxMediaApi;

  function DXEnableMute(device:THandle;bMute:Boolean):longword ; stdcall; external DLL_DxMediaApi;

  function DXSetAudioVolume(device:THandle;volume:LongWord;var balance:Char):longword ; stdcall; external DLL_DxMediaApi;

    //enum {di_none, di_blend, di_bob, di_weave};    deinterlace=-1 cancel
  function DXEnableDeinterlace(device:THandle;deinterlace:LongWord  ):longword ; stdcall; external DLL_DxMediaApi;

  // ģʽenum {dn_none, dn_b};
  function DXEnableDenoise(device:THandle;denoise:LongWord  ):longword ; stdcall; external DLL_DxMediaApi;


  function DXEnableSharpen(device:THandle;deSharpness:LongWord  ):longword ; stdcall; external DLL_DxMediaApi;




   function DXStartCapture(device:THandle;szFileName:PAnsiChar;saveAudio:Boolean  ;
                            timeSize:PInteger ;dataSize:PInteger ;vidRatio:longword ):longword ; stdcall; external DLL_DxMediaApi;

   function DXStartCaptureEx(device:THandle;
                            szFileName:PAnsiChar;
                            saveAudio:Boolean  ;
                            fileFormat:longword;      //   fileFormat:TFileType;
                            rect:prect;         //
                            timeSize:PInteger ;
                            dataSize:PInteger ;
                            vidRatio:longword ):longword ; stdcall; external DLL_DxMediaApi;




   function DXStopCapture(device:THandle):longword ; stdcall; external DLL_DxMediaApi;



   function DXFreezeCaputre(device:THandle;bFreeze:Boolean ):longword ; stdcall; external DLL_DxMediaApi;



  function DXConvertYUVtoRGB(device:THandle;
                             pYUVBuf:pchar ;
                             pRGBBuf:PChar ;
                             lImgWidth:longWord ;
                             lImgHeight:LongWord;
                             bInverted:Boolean;
                             bInvertColor:Boolean):longword ; stdcall; external DLL_DxMediaApi;

   function DXSetTimeOSD(device:THandle;
                             x:longword ;
                             y:longword ;
                             pointSize:longWord ;
                             faceName:PAnsiChar;
                             color:COLORREF ;
                             bgcolor:COLORREF ;
                             transparent:Boolean ):longword ; stdcall; external DLL_DxMediaApi;

    function DXSetTextOSD(device:THandle;
                             x:longword ;
                             y:longword ;
                             TextNO:longword;
                             osdText:PAnsiChar;
                             pointSize:longWord ;
                             faceName:PAnsiChar;
                             color:COLORREF ;
                             bgcolor:COLORREF ;
                             transparent:Boolean ):longword ; stdcall; external DLL_DxMediaApi;
    function DXSetLineOSD(device:THandle;
                             x0:longword ;
                             y0:longword ;
                             x1:longword ;
                             y1:longword ;
                             LineNO:longword;
                             lineSize:longWord ;
                             lineStyle:TlineStyle;
                             color:COLORREF ;
                             alpha: byte):longword ; stdcall; external DLL_DxMediaApi;
    function DXSetRectOSD(device:THandle;
                             x0:longword ;
                             y0:longword ;
                             width:longword ;
                             height:longword ;
                             RectNO:longword;
                             lineSize:longWord ;
                             lineStyle:TlineStyle;
                             color:COLORREF ;
                             alpha: byte):longword ; stdcall; external DLL_DxMediaApi;

    function DXSetPictureOSD(device:THandle;
                             x:longword ;
                             y:longword ;
                             PicNO:longword;
                             picFileName:PAnsiChar;
                             transparent:Boolean;
                             alpha: byte ):longword ; stdcall; external DLL_DxMediaApi;

   function DXEnOSDDisp(device:THandle;
                             osdType:longword ;  //0ʾʱӣ1ʾıӣ2ʾͼƬ
                             number:longword ;
                              enable:Boolean):longword ; stdcall; external DLL_DxMediaApi;  	//* ӱţnumber = -1ʱΪȫ */





  function DXGetFrameBuffer(device:THandle; buffer:pchar ;bufferLen:LongWord ;
                           var  gotBufferLen:longWord ;var colorSpace:LongWord;
                           var  width:LongWord; var height:LongWord ;
                           var  bytesWidth:LongWord; var rect:TRect ):longword ; stdcall; external DLL_DxMediaApi;


    function DXSaveBMPFile(szFileName:PAnsiChar;buffer:PChar  ;bufferLen:LongWord ;
                            colorSpace:LongWord ;width:LongWord;
                            height:LongWord; bytesWidth:LongWord):longword ; stdcall; external DLL_DxMediaApi;
  function DXSaveJPGFile(szFileName:PAnsiChar;buffer:PChar  ;bufferLen:LongWord ;
                            colorSpace:LongWord ;width:LongWord;
                            height:LongWord; bytesWidth:LongWord;quality:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

  //function DXSnapToBMPFile(device:THandle;szFileName:PAnsiChar;var rect:TRect ):longword ; stdcall; external DLL_DxMediaApi;

   function DXSnapToBMPFile(device:THandle;szFileName:PAnsiChar;rect:PRect ):longword ; stdcall; external DLL_DxMediaApi;



  function DXSnapToJPGFile(device:THandle;szFileName:PAnsiChar ;quality:LongWord ;var rect:TRect ):longword ; stdcall; external DLL_DxMediaApi;




    function DXStartRawVideoCallback(device:THandle; fn:TRawVideoCallback; var context: longword):longword ; stdcall; external DLL_DxMediaApi;


    function DXStopRawVideoCallback(device:THandle):longword ; stdcall; external DLL_DxMediaApi;


    function DXFlipVideo(device:THandle;flip:Boolean ):longword ; stdcall; external DLL_DxMediaApi;


     function DXMirrorVideo(device:THandle;mirror:Boolean ):longword ; stdcall; external DLL_DxMediaApi;

     
    function DXCreateBufferImg(imgbuffer:pchar ;
                               buffersize:LongWord ;
                               colorspace:longWord ;
                               width:LongWord;
                               height:LongWord;
                               var err:LongWord ):THandle ; stdcall; external DLL_DxMediaApi;


    function DXCreateFileImg(szImgFile:pchar;var err:LongWord ):longword ; stdcall; external DLL_DxMediaApi;

    
    function DXUpdateImg(img:THandle;hPrevWnd:THandle; var rect:TRect ):longword ; stdcall; external DLL_DxMediaApi;


    function DXDestroyImg(img:THandle):longword ; stdcall; external DLL_DxMediaApi;


     function DXEnDataRaterPara(device:THandle;RateType:LongWord;var pPara:TDRateColor_Para):longword ; stdcall; external DLL_DxMediaApi;


    function DXEnFScale(device:THandle;bEnFScale:boolean;var rect:TRect;enAlogrithm:LongWord):longword ; stdcall; external DLL_DxMediaApi;



    function DXStartEncVideoCallback(device:THandle; fn:TEncVideoCallback; var context: longword):longword ; stdcall; external DLL_DxMediaApi;


    function DXStopEncVideoCallback(device:THandle):longword ; stdcall; external DLL_DxMediaApi;


    function DXStartEncVideo(device:THandle;saveAudio:boolean;vidRatio:longword):longword ; stdcall; external DLL_DxMediaApi;


    function DXCreateMp4file(device:THandle;szFileName:PAnsiChar; bHasAud:boolean ):THandle ; stdcall; external DLL_DxMediaApi;


      function DXWriteMp4file( mp4hnd:THandle;
                               DataType:TDataType ;
                               IntPtr:pbyte ;
                               nlen:longWord ;
                               isKey:boolean;
                               TimeStamp:int64):longword ; stdcall; external DLL_DxMediaApi;




    function DXCloseMp4file(device:THandle):longword ; stdcall; external DLL_DxMediaApi;



   function DXStartRawVidScale(var pScalePara:TVidScalePara;pscalehad:THandle):longword ; stdcall; external DLL_DxMediaApi;


   function DXRawVidScale(pscalehad:THandle;src:pbyte;dst:pbyte):longword ; stdcall; external DLL_DxMediaApi;


   function DXStopRawVidScale(pscalehad:THandle):longword ; stdcall; external DLL_DxMediaApi;


   function DXStartNetTrans(device:THandle;
                           nPrtclType:TNetStreamType ;
                            var stNetPara:TNetTransPara):longword ; stdcall; external DLL_DxMediaApi;


  
  function DXNetTransData( device:THandle;
                               nPrtclType:TNetStreamType ;
                               DataType:TDataType ;
                               data:pbyte;
                               len:longWord ;
                               isKey:boolean;
                               TimeStamp:int64):longword ; stdcall; external DLL_DxMediaApi;

     function DXStopNetTrans(pscalehad:THandle;DataType:TNetStreamType ):longword ; stdcall; external DLL_DxMediaApi;


     function DXGetDeviceName(device:THandle):PAnsiChar ; stdcall; external DLL_DxMediaApi;

     function DXGetVideoParaHD(device:THandle;
                           var colorspace:LongWord;
                           var width:LongWord ;
                           var height:LongWord ;
                           var framerate:Single ):longword ; stdcall; external DLL_DxMediaApi;
     function DXSetVideoParaHD(device:THandle;
                            colorspace:LongWord;
                           width:LongWord ;
                           height:LongWord ;
                           framerate:Single  ):longword ; stdcall; external DLL_DxMediaApi;


   function DXDeviceIsHD(device:THandle):boolean ; stdcall; external DLL_DxMediaApi;

    function DXDeviceIsUVC(device:THandle):boolean ; stdcall; external DLL_DxMediaApi;

    function DXCreatePropertyPage(device:THandle;
                            nPropertyType:LongWord;
                           hWndOwner:THandle ;
                           x:LongWord ;
                           y:LongWord ;
                           szFileName:PAnsiChar):longword ; stdcall; external DLL_DxMediaApi;

    function DXSetGainHD(device:THandle;nGainType:byte;chValue:byte):longword ; stdcall; external DLL_DxMediaApi;


    function DXSetMirrorHD(pscalehad:THandle;mirror:boolean ):longword ; stdcall; external DLL_DxMediaApi;

   function DXSetFilpHD(pscalehad:THandle;flip:boolean ):longword ; stdcall; external DLL_DxMediaApi;


   function DXVideoCodecFilterIsSupport(codecFilter:PAnsiChar):boolean ; stdcall; external DLL_DxMediaApi;























 var DeviceInf:Device_Info;
     VidCodeInfo:TDEVICE_TAG ;
     AudCodeInfo:TDEVICE_TAG ;
     DeviceOsdInfo:array [0..23]of TosdInfo;
     DeviceInfo:array [0..23]of Device_Info;
     DRateColorPara:array [0..23]of TDRateColor_Para;
     DeviceColor :array [0..23]of Device_ColorProp;
     VideoDeviceInfo:array [0..126]of TDEVICE_TAG;
     AudioDeviceInfo:array [0..126]of TDEVICE_TAG;
     VideoCodecInfo:array [0..126]of TDEVICE_TAG;
    AudioCodecInfo:array [0..126] of TDEVICE_TAG;
      VideoDeviceNum:LongWord  ;
     AudioDeviceNum:LongWord  ;
     VideoNameStr:array [0..16]of string ;
    AudioNameStr:array [0..16]of string ;


implementation


end.

