// EncodeSettingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"
#include "EncodeSettingDlg.h"
#include "afxdialogex.h"


// CEncodeSettingDlg dialog

IMPLEMENT_DYNAMIC(CEncodeSettingDlg, CDialogEx)

CEncodeSettingDlg::CEncodeSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CEncodeSettingDlg::IDD, pParent)
	, m_nDevSel(0)
{

}

CEncodeSettingDlg::~CEncodeSettingDlg()
{
}

void CEncodeSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CEncodeSettingDlg, CDialogEx)
	ON_CBN_SELCHANGE(IDC_DEVICE, &CEncodeSettingDlg::OnSelchangeDevice)
	ON_BN_CLICKED(IDOK, &CEncodeSettingDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CEncodeSettingDlg message handlers


BOOL CEncodeSettingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	CString str;
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_DEVICE);
	for (int i=0; i<MAX_DXDEV_NUM; i++)
	{
		PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(i);
		if (pInfo->devHandle == NULL)
		{
			break;
		}
		str.Format(_T("%d:"), i);
		str += DXGetDeviceName(pInfo->devHandle);
		pCtrl->AddString(str);
	}

	m_nDevSel = 0;
	pCtrl->SetCurSel(m_nDevSel);
	SelDevEncodeParam(m_nDevSel);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CEncodeSettingDlg::SelDevEncodeParam(int nIndex)
{
	((CComboBox*)GetDlgItem(IDC_STREAM_TYPE))->SetCurSel(ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_TYPE)));
	((CComboBox*)GetDlgItem(IDC_STREAM_CTRL))->SetCurSel(ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_CONTROL)));
	((CComboBox*)GetDlgItem(IDC_ENCODER_TYPE))->SetCurSel(ini_dev_read_int(nIndex, INI_DEFAULT(ENC_ENCODER_TYPE)));

	PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(nIndex);

	unsigned nRatio[] = { 1, 2, 3, 4 };
	unsigned nEncRatio = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_FRAME_RATIO));
	CString str;
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_FRAME_RATE);
	pCtrl->ResetContent();
	for (int i=0; i<_countof(nRatio); i++)
	{
		str.Format(_T("%d"), (int)(pInfo->fFrameRate / nRatio[i]));
		pCtrl->SetItemData(pCtrl->AddString(str), nRatio[i]);
		if (nRatio[i] == nEncRatio)
		{
			pCtrl->SetCurSel(i);
		}
	}

	SetDlgItemInt(IDC_ENCODE_BITRATE, ini_dev_read_int(nIndex, INI_DEFAULT(ENC_BIT_RATE)), FALSE);
}


void CEncodeSettingDlg::OnSelchangeDevice()
{
	// TODO: Add your control notification handler code here
	int nSel = ((CComboBox*)GetDlgItem(IDC_DEVICE))->GetCurSel();
	if (nSel >= 0 && m_nDevSel != nSel)
	{
		m_nDevSel = nSel;
		SelDevEncodeParam(nSel);
	}
}


void CEncodeSettingDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	int nSel = ((CComboBox*)GetDlgItem(IDC_STREAM_TYPE))->GetCurSel();
	if (nSel >= 0)
	{
		ini_dev_write_int(m_nDevSel, INI_ENC_STREAM_TYPE, nSel);
	}

	nSel = ((CComboBox*)GetDlgItem(IDC_STREAM_CTRL))->GetCurSel();
	if (nSel >= 0)
	{
		ini_dev_write_int(m_nDevSel, INI_ENC_STREAM_CONTROL, nSel);
	}

	nSel = ((CComboBox*)GetDlgItem(IDC_ENCODER_TYPE))->GetCurSel();
	if (nSel >= 0)
	{
		ini_dev_write_int(m_nDevSel, INI_ENC_ENCODER_TYPE, nSel);
	}

	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_FRAME_RATE);
	nSel = pCtrl->GetCurSel();
	if (nSel >= 0)
	{
		ini_dev_write_int(m_nDevSel, INI_ENC_FRAME_RATIO, pCtrl->GetItemData(nSel));
	}

	BOOL bSuccess;
	int nBitrate = GetDlgItemInt(IDC_ENCODE_BITRATE, &bSuccess);
	if (bSuccess)
	{
		PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(m_nDevSel);
		if (DXDeviceIsHD(pInfo->devHandle) && nBitrate >= 512 && nBitrate <= 8 * 1024 ||
			nBitrate >= 128 && nBitrate <= 4 * 1024)
		{
			ini_dev_write_int(m_nDevSel, INI_ENC_BIT_RATE, nBitrate);
		}
	}

	CDialogEx::OnOK();
}
