// MP4CutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "MP4CutDlg.h"
#include "afxdialogex.h"


// CMP4CutDlg dialog

IMPLEMENT_DYNAMIC(CMP4CutDlg, CDialogEx)

CMP4CutDlg::CMP4CutDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMP4CutDlg::IDD, pParent)
	, m_nBeginTime(0)
	, m_nEndTime(0)
{
	m_FontInfo.fontColor = RGB(0, 0, 255);
	m_FontInfo.pointSize = 20;
	m_FontInfo.fontName = _T("Arial");
}

CMP4CutDlg::~CMP4CutDlg()
{
}

void CMP4CutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_BEGINTIME, m_nBeginTime);
	DDX_Text(pDX, IDC_ENDTIME, m_nEndTime);
	DDX_Control(pDX, IDC_FILESLICE, m_List);
}


BEGIN_MESSAGE_MAP(CMP4CutDlg, CDialogEx)
	ON_BN_CLICKED(IDC_BROWSE, &CMP4CutDlg::OnBnClickedBrowse)
	ON_BN_CLICKED(IDC_ADD, &CMP4CutDlg::OnBnClickedAdd)
	ON_BN_CLICKED(IDC_DELETE, &CMP4CutDlg::OnBnClickedDelete)
	ON_BN_CLICKED(IDOK, &CMP4CutDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_SAVE, &CMP4CutDlg::OnBnClickedSave)
	ON_BN_CLICKED(IDC_PICBROWSE, &CMP4CutDlg::OnBnClickedPicbrowse)
	ON_BN_CLICKED(IDC_STYLE, &CMP4CutDlg::OnBnClickedStyle)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CMP4CutDlg message handlers


void CMP4CutDlg::OnBnClickedBrowse()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("mp4 Files|*.mp4||"));
	if (dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_MP4FILE, dlg.GetPathName());
	}
}


void CMP4CutDlg::OnBnClickedAdd()
{
	// TODO: Add your control notification handler code here
	UpdateData();
	
	CString str;
	GetDlgItemText(IDC_MP4FILE, str);
	if (!str.IsEmpty() && m_nBeginTime < m_nEndTime)
	{
		USES_CONVERSION;

		UINT dur, w, h;
		float fps;
		BOOL bAudio;
		if (DXGetMp4fileInfo(T2A(str), dur, w, h, fps, bAudio) == 0)
		{
			CString strPic, strText;
			GetDlgItemText(IDC_PIC, strPic);
			GetDlgItemText(IDC_TEXT, strText);

			int num = 0;
			if (!strPic.IsEmpty())
			{
				num++;
			}

			if (!strText.IsEmpty())
			{
				num++;
			}

			BOOL bSuccess;
			int disptime = GetDlgItemInt(IDC_DISPLAYTIME, &bSuccess, FALSE);

			int count = 0;
			PMP4LaunchImage image = NULL;
			if (bSuccess && disptime > 0 && num > 0)
			{
				image = new MP4LaunchImage[num];
				if (image)
				{
					if (!strPic.IsEmpty())
					{
						int x = GetDlgItemInt(IDC_PICX, &bSuccess, FALSE);
						if (bSuccess)
						{
							int y = GetDlgItemInt(IDC_PICY, &bSuccess, FALSE);
							if (bSuccess)
							{
								image[count].x = x;
								image[count].y = y;
								image[count].picOpacity = ((CSliderCtrl*)GetDlgItem(IDC_TRANSPARENT))->GetPos();
								image[count].picFileName = _strdup(T2A(strPic));
								image[count].itemText = NULL;
								image[count].textFaceName = NULL;
								count++;
							}
						}
					}

					if (!strText.IsEmpty())
					{
						int x = GetDlgItemInt(IDC_TEXTX, &bSuccess, FALSE);
						if (bSuccess)
						{
							int y = GetDlgItemInt(IDC_TEXTY, &bSuccess, FALSE);
							if (bSuccess)
							{
								image[count].x = x;
								image[count].y = y;
								image[count].picFileName = NULL;
								image[count].itemText = _strdup(T2A(strText));
								image[count].textFaceName = _strdup(T2A(m_FontInfo.fontName));
								image[count].textPointSize = m_FontInfo.pointSize;
								image[count].textColor = m_FontInfo.fontColor;
								image[count].textBgcolor = RGB(0, 0, 0);
								image[count].textTransparent = ((CButton*)GetDlgItem(IDC_TEXTTRANSPARENT))->GetCheck() == BST_CHECKED;
								count++;
							}
						}
					}

					if (count == 0)
					{
						delete []image;
						image = NULL;
					}
				}
			}

			MP4FileSlice slice;
			slice.mp4_filename = _strdup(T2A(str));
			slice.time_begin = m_nBeginTime;
			slice.time_end = m_nEndTime;
			slice.launch_img = image;
			slice.launch_img_num = count;
			slice.launch_img_time = disptime;

			m_Slice.push_back(slice);

			CString s;
			s.Format(_T("%lld ~ %lld "), m_nBeginTime, m_nEndTime);
			s += str;
			str.Format(_T(" %u(ms) %ux%u @%.2ffps "), dur, w, h, fps);
			s += str;
			s += bAudio ? "Audio & Video" : "Video Only";

			m_List.AddString(s);

			SetDlgItemText(IDC_PIC, _T(""));
			SetDlgItemText(IDC_TEXT, _T(""));
		}
	}
}


void CMP4CutDlg::ListSliceDelete(int index)
{
	if (index >= 0 && (size_t)index < m_Slice.size())
	{
		if (m_Slice[index].launch_img)
		{
			for (int i=0; i<m_Slice[index].launch_img_num; i++)
			{
				if (m_Slice[index].launch_img[i].picFileName)
				{
					free(const_cast<char*>(m_Slice[index].launch_img[i].picFileName));
				}
				else
				{
					if (m_Slice[index].launch_img[i].itemText)
					{
						free(const_cast<char*>(m_Slice[index].launch_img[i].itemText));
					}

					if (m_Slice[index].launch_img[i].textFaceName)
					{
						free(const_cast<char*>(m_Slice[index].launch_img[i].textFaceName));
					}
				}
			}

			delete []m_Slice[index].launch_img;
		}

		free(const_cast<char*>(m_Slice[index].mp4_filename));
	}
}

void CMP4CutDlg::OnBnClickedDelete()
{
	// TODO: Add your control notification handler code here
	int n = m_List.GetCurSel();
	if (n != LB_ERR)
	{
		m_List.DeleteString(n);
		ListSliceDelete(n);
		m_Slice.erase(m_Slice.begin() + n);
	}
}


void CMP4CutDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	int r = -1;
	int n = m_Slice.size();
	if (n > 0)
	{
		CString str;
		GetDlgItemText(IDC_SAVEFILE, str);
		if (!str.IsEmpty())
		{
			USES_CONVERSION;
			r = DXMp4fileMerge(T2A(str), ((CButton*)GetDlgItem(IDC_AUDIO))->GetCheck() == BST_CHECKED, m_Slice.data(), n);
		}
	}

	if (r == 0)
	{
		CDialogEx::OnOK();
	}
}


void CMP4CutDlg::OnBnClickedSave()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(FALSE, _T(".mp4"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("MP4 Files|*.mp4||"));
	if (dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_SAVEFILE, dlg.GetPathName());
	}
}


void CMP4CutDlg::OnBnClickedPicbrowse()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Jpeg Files;Png Files;Bitmap Files|*.jpg;*.png;*.bmp|All Files|*.*||"));
	if (dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_PIC, dlg.GetPathName());
	}
}


BOOL CMP4CutDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	((CSliderCtrl*)GetDlgItem(IDC_TRANSPARENT))->SetRange(0, 255);
	((CSliderCtrl*)GetDlgItem(IDC_TRANSPARENT))->SetPos(255);

	((CButton*)GetDlgItem(IDC_AUDIO))->SetCheck(BST_CHECKED);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CMP4CutDlg::OnBnClickedStyle()
{
	// TODO: Add your control notification handler code here
	SetTextColorFont(this, m_FontInfo);
}


void CMP4CutDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: Add your message handler code here
	for (int i=0; i<m_List.GetCount(); i++)
	{
		ListSliceDelete(i);
	}
}
