// NetStreamDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"
#include "NetStreamDlg.h"
#include "afxdialogex.h"


// CNetStreamDlg dialog

IMPLEMENT_DYNAMIC(CNetStreamDlg, CDialogEx)

CNetStreamDlg::CNetStreamDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CNetStreamDlg::IDD, pParent)
	, m_nDevSel(0)
{

}

CNetStreamDlg::~CNetStreamDlg()
{
}

void CNetStreamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CNetStreamDlg, CDialogEx)
	ON_BN_CLICKED(IDOK, &CNetStreamDlg::OnBnClickedOk)
	ON_CBN_SELCHANGE(IDC_DEVICE, &CNetStreamDlg::OnSelchangeDevice)
END_MESSAGE_MAP()


// CNetStreamDlg message handlers


BOOL CNetStreamDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	CString str;
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_DEVICE);
	for (int i=0; i<MAX_DXDEV_NUM; i++)
	{
		PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(i);
		if (pInfo->devHandle == NULL)
		{
			break;
		}
		str.Format(_T("%d:"), i);
		str += DXGetDeviceName(pInfo->devHandle);
		pCtrl->AddString(str);
	}

	m_nDevSel = 0;
	pCtrl->SetCurSel(m_nDevSel);
	SelDevNetStreamParam(m_nDevSel);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CNetStreamDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	int nCheck = ((CButton*)GetDlgItem(IDC_RTSP))->GetCheck();
	ini_dev_write_int(m_nDevSel, INI_NET_RTSP_ENABLE, nCheck == BST_CHECKED ? 1 : 0);
	int nSel = ((CComboBox*)GetDlgItem(IDC_RTSP_PORT))->GetCurSel();
	ini_dev_write_int(m_nDevSel, INI_NET_RTSP_PORT, nSel);

	nCheck = ((CButton*)GetDlgItem(IDC_RTMP))->GetCheck();
	ini_dev_write_int(m_nDevSel, INI_NET_RTMP_ENABLE, nCheck == BST_CHECKED ? 1 : 0);
	CString str;
	GetDlgItemText(IDC_RTMP_URI, str);
	ini_dev_write_string(m_nDevSel, INI_NET_RTMP_URI, str);

	nCheck = ((CButton*)GetDlgItem(IDC_NET_AUDIO))->GetCheck();
	ini_dev_write_int(m_nDevSel, INI_NET_AUDIO_ENABLE, nCheck == BST_CHECKED ? 1 : 0);

	CDialogEx::OnOK();
}


void CNetStreamDlg::SelDevNetStreamParam(int nIndex)
{
	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTSP_ENABLE));
	((CButton*)GetDlgItem(IDC_RTSP))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	((CComboBox*)GetDlgItem(IDC_RTSP_PORT))->SetCurSel(ini_dev_read_int(nIndex, INI_NET_RTSP_PORT, 0));

	n = ini_dev_read_int(nIndex, INI_NET_RTMP_ENABLE, 0);
	((CButton*)GetDlgItem(IDC_RTMP))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	CString str = ini_dev_read_string(nIndex, INI_DEFAULT(NET_RTMP_URI));
	SetDlgItemText(IDC_RTMP_URI, str);

	n = ini_dev_read_int(nIndex, INI_DEFAULT(NET_AUDIO_ENABLE));
	((CButton*)GetDlgItem(IDC_NET_AUDIO))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
}


void CNetStreamDlg::OnSelchangeDevice()
{
	// TODO: Add your control notification handler code here
	int nSel = ((CComboBox*)GetDlgItem(IDC_DEVICE))->GetCurSel();
	if (nSel >= 0 && m_nDevSel != nSel)
	{
		m_nDevSel = nSel;
		SelDevNetStreamParam(nSel);
	}
}


