// OSDSettingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"
#include "OSDSettingDlg.h"
#include "afxdialogex.h"


// COSDSettingDlg dialog

IMPLEMENT_DYNAMIC(COSDSettingDlg, CDialogEx)

COSDSettingDlg::COSDSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(COSDSettingDlg::IDD, pParent)
	, m_nDevSel(0)
{
}

COSDSettingDlg::~COSDSettingDlg()
{
}

void COSDSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(COSDSettingDlg, CDialogEx)
	ON_CBN_SELCHANGE(IDC_DEVICE, &COSDSettingDlg::OnSelchangeDevice)
	ON_BN_CLICKED(IDC_TIMEOSD_FONT, &COSDSettingDlg::OnBnClickedTimeosdFont)
	ON_BN_CLICKED(IDC_TEXTOSD1_FONT, &COSDSettingDlg::OnBnClickedTextosd1Font)
	ON_BN_CLICKED(IDC_TEXTOSD2_FONT, &COSDSettingDlg::OnBnClickedTextosd2Font)
	ON_BN_CLICKED(IDC_PICOSD_BROWSE, &COSDSettingDlg::OnBnClickedPicosdBrowse)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDOK, &COSDSettingDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// COSDSettingDlg message handlers


BOOL COSDSettingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	CString str;
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_DEVICE);
	for (int i=0; i<MAX_DXDEV_NUM; i++)
	{
		PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(i);
		if (pInfo->devHandle == NULL)
		{
			break;
		}
		str.Format(_T("%d:"), i);
		str += DXGetDeviceName(pInfo->devHandle);
		pCtrl->AddString(str);
	}

	m_nDevSel = 0;
	pCtrl->SetCurSel(m_nDevSel);
	SelDevOSDParam(m_nDevSel);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}



void COSDSettingDlg::SelDevOSDParam(int nIndex)
{
	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_ENABLE));
	((CButton*)GetDlgItem(IDC_TIMEOSD_ENABLE))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_TRANSPARENT));
	((CButton*)GetDlgItem(IDC_TIMEOSD_TRANS))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_X));
	SetDlgItemInt(IDC_TIMEOSD_X, n, FALSE);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_Y));
	SetDlgItemInt(IDC_TIMEOSD_Y, n, FALSE);
	m_FontInfo[0].pointSize = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_FONTSZ));
	m_FontInfo[0].fontColor = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_COLOR));
	m_FontInfo[0].fontName = ini_dev_read_string(nIndex, INI_DEFAULT(TIME_OSD_FONTNAME));

	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_ENABLE1));
	((CButton*)GetDlgItem(IDC_TEXTOSD1_ENABLE))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_TRANSPARENT1));
	((CButton*)GetDlgItem(IDC_TEXTOSD1_TRANS))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_X1));
	SetDlgItemInt(IDC_TEXTOSD1_X, n, FALSE);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_Y1));
	SetDlgItemInt(IDC_TEXTOSD1_Y, n, FALSE);
	CString str = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_STR1));
	SetDlgItemText(IDC_TEXTOSD1_STR, str);
	m_FontInfo[1].pointSize = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_FONTSZ1));
	m_FontInfo[1].fontColor = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_COLOR1));
	m_FontInfo[1].fontName = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_FONTNAME1));

	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_ENABLE2));
	((CButton*)GetDlgItem(IDC_TEXTOSD2_ENABLE))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_TRANSPARENT2));
	((CButton*)GetDlgItem(IDC_TEXTOSD2_TRANS))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_X2));
	SetDlgItemInt(IDC_TEXTOSD2_X, n, FALSE);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_Y2));
	SetDlgItemInt(IDC_TEXTOSD2_Y, n, FALSE);
	str = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_STR2));
	SetDlgItemText(IDC_TEXTOSD2_STR, str);
	m_FontInfo[2].pointSize = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_FONTSZ2));
	m_FontInfo[2].fontColor = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_COLOR2));
	m_FontInfo[2].fontName = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_FONTNAME2));

	n = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_ENABLE));
	((CButton*)GetDlgItem(IDC_PICOSD_ENABLE))->SetCheck(n == 0 ? BST_UNCHECKED : BST_CHECKED);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_TRANSPARENT));
	((CSliderCtrl*)GetDlgItem(IDC_PICOSD_TRANS))->SetRange(0, 255);
	((CSliderCtrl*)GetDlgItem(IDC_PICOSD_TRANS))->SetPos(n);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_X));
	SetDlgItemInt(IDC_PICOSD_X, n, FALSE);
	n = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_Y));
	SetDlgItemInt(IDC_PICOSD_Y, n, FALSE);
	str = ini_dev_read_string(nIndex, INI_DEFAULT(PIC_OSD_FILE));
	SetDlgItemText(IDC_PICOSD_FILE, str);
}



void COSDSettingDlg::OnSelchangeDevice()
{
	// TODO: Add your control notification handler code here
	int nSel = ((CComboBox*)GetDlgItem(IDC_DEVICE))->GetCurSel();
	if (nSel >= 0 && nSel != m_nDevSel)
	{
		m_nDevSel = nSel;
		SelDevOSDParam(nSel);
	}
}

void COSDSettingDlg::OnBnClickedTimeosdFont()
{
	// TODO: Add your control notification handler code here
	SetTextColorFont(this, m_FontInfo[0]);
}


void COSDSettingDlg::OnBnClickedTextosd1Font()
{
	// TODO: Add your control notification handler code here
	SetTextColorFont(this, m_FontInfo[1]);
}


void COSDSettingDlg::OnBnClickedTextosd2Font()
{
	// TODO: Add your control notification handler code here
	SetTextColorFont(this, m_FontInfo[2]);
}


void COSDSettingDlg::OnBnClickedPicosdBrowse()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Jpeg Files;Png Files;Bitmap Files|*.jpg;*.png;*.bmp|All Files|*.*||"));
	if (dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_PICOSD_FILE, dlg.GetPathName());
	}
}



void COSDSettingDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	unsigned n = ((CButton*)GetDlgItem(IDC_TIMEOSD_ENABLE))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_TIME_OSD_ENABLE, n);
	n = ((CButton*)GetDlgItem(IDC_TIMEOSD_TRANS))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_TIME_OSD_TRANSPARENT, n);
	BOOL bSuccess;
	n = GetDlgItemInt(IDC_TIMEOSD_X, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_TIME_OSD_X, n);
	}
	n = GetDlgItemInt(IDC_TIMEOSD_Y, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_TIME_OSD_Y, n);
	}
	ini_dev_write_int(m_nDevSel, INI_TIME_OSD_FONTSZ, m_FontInfo[0].pointSize);
	ini_dev_write_int(m_nDevSel, INI_TIME_OSD_COLOR, m_FontInfo[0].fontColor);
	ini_dev_write_string(m_nDevSel, INI_TIME_OSD_FONTNAME, m_FontInfo[0].fontName);

	n = ((CButton*)GetDlgItem(IDC_TEXTOSD1_ENABLE))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_ENABLE1, n);
	n = ((CButton*)GetDlgItem(IDC_TEXTOSD1_TRANS))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_TRANSPARENT1, n);
	n = GetDlgItemInt(IDC_TEXTOSD1_X, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_X1, n);
	}
	n = GetDlgItemInt(IDC_TEXTOSD1_Y, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_Y1, n);
	}
	CString str;
	GetDlgItemText(IDC_TEXTOSD1_STR, str);
	ini_dev_write_string(m_nDevSel, INI_TEXT_OSD_STR1, str);
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_FONTSZ1, m_FontInfo[1].pointSize);
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_COLOR1, m_FontInfo[1].fontColor);
	ini_dev_write_string(m_nDevSel, INI_TEXT_OSD_FONTNAME1, m_FontInfo[1].fontName);

	n = ((CButton*)GetDlgItem(IDC_TEXTOSD2_ENABLE))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_ENABLE2, n);
	n = ((CButton*)GetDlgItem(IDC_TEXTOSD2_TRANS))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_TRANSPARENT2, n);
	n = GetDlgItemInt(IDC_TEXTOSD2_X, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_X2, n);
	}
	n = GetDlgItemInt(IDC_TEXTOSD2_Y, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_Y2, n);
	}
	GetDlgItemText(IDC_TEXTOSD2_STR, str);
	ini_dev_write_string(m_nDevSel, INI_TEXT_OSD_STR2, str);
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_FONTSZ2, m_FontInfo[2].pointSize);
	ini_dev_write_int(m_nDevSel, INI_TEXT_OSD_COLOR2, m_FontInfo[2].fontColor);
	ini_dev_write_string(m_nDevSel, INI_TEXT_OSD_FONTNAME2, m_FontInfo[2].fontName);

	n = ((CButton*)GetDlgItem(IDC_PICOSD_ENABLE))->GetCheck() == BST_CHECKED ? 1 : 0;
	ini_dev_write_int(m_nDevSel, INI_PIC_OSD_ENABLE, n);
	n = ((CSliderCtrl*)GetDlgItem(IDC_PICOSD_TRANS))->GetPos();
	ini_dev_write_int(m_nDevSel, INI_PIC_OSD_TRANSPARENT, n);
	n = GetDlgItemInt(IDC_PICOSD_X, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_PIC_OSD_X, n);
	}
	n = GetDlgItemInt(IDC_PICOSD_Y, &bSuccess, FALSE);
	if (bSuccess)
	{
		ini_dev_write_int(m_nDevSel, INI_PIC_OSD_Y, n);
	}
	GetDlgItemText(IDC_PICOSD_FILE, str);
	ini_dev_write_string(m_nDevSel, INI_PIC_OSD_FILE, str);

	CDialogEx::OnOK();
}
