// SaveSettingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "SaveSettingDlg.h"
#include "afxdialogex.h"


// CSaveSettingDlg dialog

IMPLEMENT_DYNAMIC(CSaveSettingDlg, CDialogEx)

CSaveSettingDlg::CSaveSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSaveSettingDlg::IDD, pParent)
{

}

CSaveSettingDlg::~CSaveSettingDlg()
{
}

void CSaveSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CSaveSettingDlg, CDialogEx)
	ON_BN_CLICKED(IDC_BROWSE, &CSaveSettingDlg::OnBnClickedBrowse)
	ON_BN_CLICKED(IDOK, &CSaveSettingDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CSaveSettingDlg message handlers


void CSaveSettingDlg::OnBnClickedBrowse()
{
	// TODO: Add your control notification handler code here
	LPMALLOC lpMalloc;
	if (::SHGetMalloc(&lpMalloc) != NOERROR) 
		return;

	TCHAR szDisplayName[_MAX_PATH];
	TCHAR szBuffer[_MAX_PATH];
	BROWSEINFO browseInfo;
	browseInfo.hwndOwner = GetSafeHwnd();
	browseInfo.pidlRoot = NULL;
	browseInfo.pszDisplayName = szDisplayName;
	browseInfo.lpszTitle = _T("Choose File Save Folder");
	browseInfo.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
	browseInfo.lpfn = NULL;
	browseInfo.lParam = 0;

	LPITEMIDLIST lpItemIDList;
	if ((lpItemIDList = ::SHBrowseForFolder(&browseInfo)) != NULL)
	{
		// Get the path of the selected folder from the item ID list.
		if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
		{
			if (szBuffer[0] != '\0') 
			{
				SetDlgItemText(IDC_SAVEDIR, szBuffer);
			}
		}
	}

	if (lpItemIDList)
	{
		lpMalloc->Free(lpItemIDList);
	}
	lpMalloc->Release();
}


void CSaveSettingDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	int n = ((CButton*)GetDlgItem(IDC_JPG))->GetCheck();
	INI_WRITE_INT(INI_SAVE_SECTION, INI_CAP_FILE_FORMAT, n == BST_UNCHECKED ? 1 : 0);

	n = ((CSliderCtrl*)GetDlgItem(IDC_JPEG_QUALITY))->GetPos();
	INI_WRITE_INT(INI_SAVE_SECTION, INI_CAP_JPEG_QUALITY, n);

	n = ((CButton*)GetDlgItem(IDC_REPAIR_SUPPORT))->GetCheck();
	INI_WRITE_INT(INI_SAVE_SECTION, INI_MP4_REPAIR_SUPPORT, n == BST_UNCHECKED ? 0 : 1);

	CString str;
	GetDlgItemText(IDC_SAVEDIR, str);
	INI_WRITE_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, str);

	CComboBox * pCtrl = (CComboBox*)GetDlgItem(IDC_RECDUR);
	int nIndex = pCtrl->GetCurSel();
	if (nIndex >= 0)
	{
		INI_WRITE_INT(INI_SAVE_SECTION, INI_REC_FILE_DUR, pCtrl->GetItemData(nIndex));
	}

	CDialogEx::OnOK();
}


BOOL CSaveSettingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	unsigned n = INI_READ_INT(INI_SAVE_SECTION, INI_CAP_FILE_FORMAT, DEFAULT_CAP_FILE_FORMAT);
	((CButton*)GetDlgItem(IDC_JPG))->SetCheck(n == 0 ? BST_CHECKED : BST_UNCHECKED);
	((CButton*)GetDlgItem(IDC_BMP))->SetCheck(n != 0 ? BST_CHECKED : BST_UNCHECKED);

	n = INI_READ_INT(INI_SAVE_SECTION, INI_MP4_REPAIR_SUPPORT, DEFAULT_MP4_REPAIR_SUPPORT);
	((CButton*)GetDlgItem(IDC_REPAIR_SUPPORT))->SetCheck(n != 0 ? BST_CHECKED : BST_UNCHECKED);

	n = INI_READ_INT(INI_SAVE_SECTION, INI_CAP_JPEG_QUALITY, DEFAULT_CAP_JPEG_QUALITY);
	CSliderCtrl *pSilderCtrl = (CSliderCtrl*)GetDlgItem(IDC_JPEG_QUALITY);
	pSilderCtrl->SetRange(0, 100);
	pSilderCtrl->SetPos(n);

	CString str = INI_READ_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, DEFAULT_FILE_SAVE_DIR);
	SetDlgItemText(IDC_SAVEDIR, str);
	
	CComboBox * pCtrl = (CComboBox*)GetDlgItem(IDC_RECDUR);
	unsigned item[] = { 1, 5, 10, 15, 30 };
	for (unsigned i=0; i<_countof(item); i++)
	{
		str.Format(_T("%u mins"), item[i]);
		pCtrl->SetItemData(pCtrl->AddString(str), item[i]);
	}

	n = INI_READ_INT(INI_SAVE_SECTION, INI_REC_FILE_DUR, DEFAULT_REC_FILE_DUR);
	str.Format(_T("%u mins"), n);
	pCtrl->SetCurSel(pCtrl->FindString(-1, str));

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
