
// VcDemo.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CVcDemoApp

BEGIN_MESSAGE_MAP(CVcDemoApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CVcDemoApp construction

CVcDemoApp::CVcDemoApp()
	: m_IniFileName(_T(""))
{
	// support Restart Manager
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CVcDemoApp object

CVcDemoApp theApp;


// CVcDemoApp initialization

BOOL CVcDemoApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();


	AfxEnableControlContainer();

	// Create the shell manager, in case the dialog contains
	// any shell tree view or shell list view controls.
	CShellManager *pShellManager = new CShellManager;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	CString str;
	::GetModuleFileName(NULL, str.GetBuffer(MAX_PATH), MAX_PATH);
	str.ReleaseBuffer();

	int nPos = str.ReverseFind('\\');
	m_IniFileName = str.Left(nPos + 1) + m_pszProfileName;
	if (m_IniFileName.ReverseFind('.') == -1)
	{
		m_IniFileName += _T(".ini");
	}

	unsigned r = DXInitialize();
	DXSDK_CHECK_ERROR("DXInitialize", r);

	CVcDemoDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Delete the shell manager created above.
	if (pShellManager != NULL)
	{
		delete pShellManager;
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}



int CVcDemoApp::ExitInstance()
{
	// TODO: Add your specialized code here and/or call the base class
	DXUninitialize();

	return CWinApp::ExitInstance();
}


void CVcDemoApp::DXSDKErrorMsg(LPCTSTR pDXSDKFunctionName, unsigned int err)
{
	CString str;
	str.Format(_T("DXSDK %s return error %#x!"), pDXSDKFunctionName, err);
	AfxMessageBox(str, MB_OK | MB_ICONERROR);
}

BOOL ini_write_int(LPCTSTR inisection, LPCTSTR iniitem, UINT val)
{
	CString strval;
	strval.Format(_T("%u"), val);
	return INI_WRITE_STRING(inisection, iniitem, strval);
}

CString ini_read_string(LPCTSTR inisection, LPCTSTR iniitem, LPCTSTR defaultstr)
{
	TCHAR s[MAX_PATH];
	::GetPrivateProfileString(inisection, iniitem, defaultstr, s, MAX_PATH, theApp.m_IniFileName);
	return s;
}

void SetTextColorFont(CWnd *pWnd, TEXTFONTINFO &fontInfo)
{
	CDC *pDC = pWnd->GetDC();
	LOGFONT logFont;
	pWnd->GetFont()->GetLogFont(&logFont);
	_tcscpy_s(logFont.lfFaceName, _countof(logFont.lfFaceName), fontInfo.fontName);
	logFont.lfHeight = -MulDiv(fontInfo.pointSize, ::GetDeviceCaps(pDC->m_hDC, LOGPIXELSY), 72);
	pWnd->ReleaseDC(pDC);

	CFontDialog dlg(&logFont);
	dlg.m_cf.rgbColors = fontInfo.fontColor;
	if (dlg.DoModal() == IDOK)
	{
		fontInfo.pointSize = dlg.GetSize() / 10;
		fontInfo.fontColor = dlg.GetColor();
		fontInfo.fontName = dlg.GetFaceName();
	}
}

UINT ini_dev_read_int(unsigned devindex, LPCTSTR iniitem, int defaultval)
{
	CString strsec;
	strsec.Format(_T("%s%d"), INI_DEVICE_SECTION, devindex);
	return INI_READ_INT(strsec, iniitem, defaultval);
}

BOOL ini_dev_write_int(unsigned devindex, LPCTSTR iniitem, UINT val)
{
	CString strsec;
	strsec.Format(_T("%s%d"), INI_DEVICE_SECTION, devindex);
	return ini_write_int(strsec, iniitem, val);
}

CString ini_dev_read_string(unsigned devindex, LPCTSTR iniitem, LPCTSTR defaultstr)
{
	CString strsec;
	strsec.Format(_T("%s%d"), INI_DEVICE_SECTION, devindex);
	return ini_read_string(strsec, iniitem, defaultstr);
}

BOOL ini_dev_write_string(unsigned devindex, LPCTSTR iniitem, LPCTSTR str)
{
	CString strsec;
	strsec.Format(_T("%s%d"), INI_DEVICE_SECTION, devindex);
	return INI_WRITE_STRING(strsec, iniitem, str);
}

