
// VcDemo.h : main header file for the PROJECT_NAME application
//

#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#include "resource.h"		// main symbols
#include "DXMediaCap.h"

enum _DXGetVideoSources_param_sources_e {
	Video_Source_Tuner = 1,
	Video_Source_Composite,
	Video_Source_SVideo,
	Video_Source_RGB,
	Video_Source_YRYBY,
	Video_Source_SerialDigital,
	Video_Source_ParallelDigital
};

enum _DXSetDisplayPara_param_paraType_e {
	video_brightness,
	video_contrast,
	video_saturation,
	video_hue,
	video_sharpness
};

enum _DXSetVideoPara_param_standard_e {
	standard_NTSC_M = 0x1,
	standard_NTSC_M_J = 0x2,
	standard_PAL_B = 0x10,
	standard_PAL_D = 0x20,
	standard_PAL_G = 0x40,
	standard_PAL_H = 0x80,
	standard_PAL_I = 0x100,
	standard_PAL_M = 0x200,
	standard_PAL_N = 0x400,
	standard_SECAM_B = 0x1000,
	standard_SECAM_D = 0x2000,
	standard_SECAM_G = 0x4000,
	standard_SECAM_H = 0x8000,
	standard_SECAM_K = 0x10000,
	standard_SECAM_K1 = 0x20000,
	standard_SECAM_L = 0x40000,
	standard_SECAM_L1 = 0x80000
};

enum _DXEnableDeinterlace_param_deinterlace_e {
	deinterlace_None = -1,
	deinterlace_SimpleBob,
	deinterlace_TomsMoComp,
	deinterlace_Private
};

enum _DXEnOSDDisp_param_osdType_e {
	osd_type_all = -1,
	osd_type_time,
	osd_type_text,
	osd_type_picture
};

#define MAX_DXDEV_NUM		4

#define WM_VIDEOWIN_MSG		( WM_USER + 2018 )

#define WIN_LEFTCLICK		1
#define WIN_LEFTDBCLICK		2
#define WIN_RIGHTCLICK		3

#define DXSDK_CHECK_ERROR(funcname, ret)	do { if (ret != 0) theApp.DXSDKErrorMsg(_T(funcname), ret); } while (0)

#define MIN_2_MILLISEC(x) (x * 60 * 1000)

#define INI_NULL _T("")

#define INI_DEVICE_SECTION _T("DevSection")

#define INI_AUDIO_DEVICE_INDEX _T("AudioDevIndex")
#define DEFAULT_AUDIO_DEVICE_INDEX 0
#define INI_VIDEO_SOURCE_INDEX _T("VideoSrcIndex")
#define DEFAULT_VIDEO_SOURCE_INDEX 0
#define INI_VIDEO_RENDER_TYPE _T("VideoRenderType")
#define DEFAULT_VIDEO_RENDER_TYPE dp_overlay
#define INI_VIDEO_COLOR_SPACE _T("VideoColorSpace")
#define DEFAULT_VIDEO_COLOR_SPACE cs_yuy2

#define INI_ENC_STREAM_TYPE _T("EncStreamType")
#define DEFAULT_ENC_STREAM_TYPE 1 // 0 video only;1 video & audio
#define INI_ENC_STREAM_CONTROL _T("EncStreamCtrl")
#define DEFAULT_ENC_STREAM_CONTROL codec_CBR
#define INI_ENC_ENCODER_TYPE _T("EncEncoderType")
#define DEFAULT_ENC_ENCODER_TYPE 0 // 0 Intel GPU encoder;1 Software encoder
#define INI_ENC_FRAME_RATIO _T("EncFrameRatio")
#define DEFAULT_ENC_FRAME_RATIO 1 // 1 Full frame rate
#define INI_ENC_BIT_RATE _T("EncBitrate")
#define DEFAULT_ENC_BIT_RATE 1024

#define INI_NET_RTSP_ENABLE _T("NetRtspEnable")
#define DEFAULT_NET_RTSP_ENABLE 0
#define INI_NET_RTSP_PORT _T("NetRtspPort")
#define DEFAULT_NET_RTSP_PORT 0 // 0 port 554;1 port 8554
#define INI_NET_RTMP_ENABLE _T("NetRtmpEnable")
#define DEFAULT_NET_RTMP_ENABLE 0
#define INI_NET_RTMP_URI _T("NetRtmpUri")
#define DEFAULT_NET_RTMP_URI INI_NULL
#define INI_NET_AUDIO_ENABLE _T("NetAudioEnable")
#define DEFAULT_NET_AUDIO_ENABLE 0

#define INI_VIDEO_BRIGHTNESS _T("VideoBrightness")
#define INI_VIDEO_CONTRAST _T("VideoContrast")
#define INI_VIDEO_HUE _T("VideoHue")
#define INI_VIDEO_SATURATION _T("VideoSaturation")
#define INI_VIDEO_SHARPNESS _T("VideoSharpness")
#define INI_VIDEO_WIDTH _T("VideoWidth")
#define INI_VIDEO_HEIGHT _T("VideoHeight")
#define INI_VIDEO_FRAME_RATE _T("VideoFrameRate")
#define INI_VIDEO_STANDARD _T("VideoStandard")
#define INI_VIDEO_DEINTERLACE _T("VideoDeinterlace")
#define DEFAULT_VIDEO_DEINTERLACE deinterlace_Private

#define INI_VIDEO_HD_BRIGHTNESS _T("VideoHDBrightness")
#define INI_VIDEO_HD_CONTRAST _T("VideoHDContrast")
#define INI_VIDEO_HD_HUE _T("VideoHDHue")
#define INI_VIDEO_HD_SATURATION _T("VideoHDSaturation")
#define INI_VIDEO_HD_SHARPNESS _T("VideoHDSharpness")
#define INI_VIDEO_HD_WIDTH _T("VideoHDWidth")
#define INI_VIDEO_HD_HEIGHT _T("VideoHDHeight")
#define INI_VIDEO_HD_FRAME_RATE _T("VideoHDFrameRate")

#define INI_TEXT_OSD_ENABLE1 _T("TextOsdEnable1")
#define DEFAULT_TEXT_OSD_ENABLE1 0
#define INI_TEXT_OSD_TRANSPARENT1 _T("TextOsdTransparent1")
#define DEFAULT_TEXT_OSD_TRANSPARENT1 1
#define INI_TEXT_OSD_X1 _T("TextOsdX1")
#define DEFAULT_TEXT_OSD_X1 20
#define INI_TEXT_OSD_Y1 _T("TextOsdY1")
#define DEFAULT_TEXT_OSD_Y1 50
#define INI_TEXT_OSD_FONTNAME1 _T("TextOsdFont1")
#define DEFAULT_TEXT_OSD_FONTNAME1 _T("Arial")
#define INI_TEXT_OSD_FONTSZ1 _T("TextOsdFontSize1")
#define DEFAULT_TEXT_OSD_FONTSZ1 20
#define INI_TEXT_OSD_COLOR1 _T("TextOsdColor1")
#define DEFAULT_TEXT_OSD_COLOR1 RGB(0, 0, 255)
#define INI_TEXT_OSD_STR1 _T("TextOsdStr1")
#define DEFAULT_TEXT_OSD_STR1 INI_NULL
#define DEFAULT_OSD_BKCOLOR 0

#define INI_TEXT_OSD_ENABLE2 _T("TextOsdEnable2")
#define DEFAULT_TEXT_OSD_ENABLE2 0
#define INI_TEXT_OSD_TRANSPARENT2 _T("TextOsdTransparent2")
#define DEFAULT_TEXT_OSD_TRANSPARENT2 1
#define INI_TEXT_OSD_X2 _T("TextOsdX2")
#define DEFAULT_TEXT_OSD_X2 20
#define INI_TEXT_OSD_Y2 _T("TextOsdY2")
#define DEFAULT_TEXT_OSD_Y2 80
#define INI_TEXT_OSD_FONTNAME2 _T("TextOsdFont2")
#define DEFAULT_TEXT_OSD_FONTNAME2 _T("Arial")
#define INI_TEXT_OSD_FONTSZ2 _T("TextOsdFontSize2")
#define DEFAULT_TEXT_OSD_FONTSZ2 20
#define INI_TEXT_OSD_COLOR2 _T("TextOsdColor2")
#define DEFAULT_TEXT_OSD_COLOR2 RGB(0, 0, 255)
#define INI_TEXT_OSD_STR2 _T("TextOsdStr2")
#define DEFAULT_TEXT_OSD_STR2 INI_NULL

#define INI_TIME_OSD_ENABLE _T("TimeOsdEnable")
#define DEFAULT_TIME_OSD_ENABLE 0
#define INI_TIME_OSD_TRANSPARENT _T("TimeOsdTransparent")
#define DEFAULT_TIME_OSD_TRANSPARENT 1
#define INI_TIME_OSD_X _T("TimeOsdX")
#define DEFAULT_TIME_OSD_X 20
#define INI_TIME_OSD_Y _T("TimeOsdY")
#define DEFAULT_TIME_OSD_Y 20
#define INI_TIME_OSD_FONTNAME _T("TimeOsdFont")
#define DEFAULT_TIME_OSD_FONTNAME _T("Arial")
#define INI_TIME_OSD_FONTSZ _T("TimeOsdFontSize")
#define DEFAULT_TIME_OSD_FONTSZ 20
#define INI_TIME_OSD_COLOR _T("TimeOsdColor")
#define DEFAULT_TIME_OSD_COLOR RGB(0, 0, 255)

#define INI_PIC_OSD_ENABLE _T("PicOsdEnable")
#define DEFAULT_PIC_OSD_ENABLE 0
#define INI_PIC_OSD_TRANSPARENT _T("PicOsdTransparent")
#define DEFAULT_PIC_OSD_TRANSPARENT 128
#define INI_PIC_OSD_X _T("PicOsdX")
#define DEFAULT_PIC_OSD_X 10
#define INI_PIC_OSD_Y _T("PicOsdY")
#define DEFAULT_PIC_OSD_Y 10
#define INI_PIC_OSD_FILE _T("PicOsdFile")
#define DEFAULT_PIC_OSD_FILE INI_NULL

#define INI_SAVE_SECTION _T("SaveSection")
#define INI_CAP_FILE_FORMAT _T("CapFileFormat")
#define DEFAULT_CAP_FILE_FORMAT 0 // 0 jpg;1 bmp
#define INI_CAP_JPEG_QUALITY _T("CapJpegQuality")
#define DEFAULT_CAP_JPEG_QUALITY 100
#define INI_MP4_REPAIR_SUPPORT _T("MP4RepairSupport")
#define DEFAULT_MP4_REPAIR_SUPPORT 1
#define INI_FILE_SAVE_DIR _T("FileSaveDir")
#define DEFAULT_FILE_SAVE_DIR INI_NULL
#define INI_REC_FILE_DUR _T("FileRecDur")
#define DEFAULT_REC_FILE_DUR 5 // minutes

#define INI_DEFAULT(x) INI_##x, DEFAULT_##x
#define INI_READ_INT(inisection, iniitem, defaultval) ::GetPrivateProfileInt(inisection, iniitem, defaultval, theApp.m_IniFileName)
#define INI_WRITE_INT(inisection, iniitem, val) ini_write_int(inisection, iniitem, val)
#define INI_READ_STRING(inisection, iniitem, defaultstr) ini_read_string(inisection, iniitem, defaultstr)
#define INI_WRITE_STRING(inisection, iniitem, inistr) ::WritePrivateProfileString(inisection, iniitem, inistr, theApp.m_IniFileName)

#define pDemoDlg ((CVcDemoDlg*)theApp.m_pMainWnd)

typedef struct {
	int pointSize;
	COLORREF fontColor;
	CString fontName;
} TEXTFONTINFO, *PTEXTFONTINFO;


// CVcDemoApp:
// See VcDemo.cpp for the implementation of this class
//

class CVcDemoApp : public CWinApp
{
public:
	CVcDemoApp();

// Overrides
public:
	virtual BOOL InitInstance();
	void DXSDKErrorMsg(LPCTSTR pDXSDKFunctionName, unsigned int err);
	CString m_IniFileName;

// Implementation

	DECLARE_MESSAGE_MAP()
	virtual int ExitInstance();
};

extern CVcDemoApp theApp;

void SetTextColorFont(CWnd *pWnd, TEXTFONTINFO &fontInfo);

BOOL ini_write_int(LPCTSTR inisection, LPCTSTR iniitem, UINT val);
CString ini_read_string(LPCTSTR inisection, LPCTSTR iniitem, LPCTSTR defaultstr);

UINT ini_dev_read_int(unsigned devindex, LPCTSTR iniitem, int defaultval);
BOOL ini_dev_write_int(unsigned devindex, LPCTSTR iniitem, UINT val);
CString ini_dev_read_string(unsigned devindex, LPCTSTR iniitem, LPCTSTR defaultstr);
BOOL ini_dev_write_string(unsigned devindex, LPCTSTR iniitem, LPCTSTR str);
