
// VcDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"
#include "afxdialogex.h"

#include "NetStreamDlg.h"
#include "OSDSettingDlg.h"
#include "VideoSettingDlg.h"
#include "SaveSettingDlg.h"
#include "EncodeSettingDlg.h"
#include "MP4RepairDlg.h"
#include "MP4CutDlg.h"
#include "ProgressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static CProgressDlg g_repair_dlg;
static CProgressDlg g_cut_dlg;

unsigned __stdcall EncVideoCallback(unsigned char* buffer, unsigned bufferSize,bool bIsKey, LONGLONG nTmStamp, dxmp4_handle hmp4, void* context)
{
	PDXDEVINFO pInfo = (PDXDEVINFO)context;
	if (pInfo)
	{
		if (pInfo->bNetTrans)
		{ // ݷ
			DXNetTransData(pInfo->devHandle, pInfo->nNetProtcol, data_vid, buffer, bufferSize, bIsKey, nTmStamp);
		}

		if (hmp4 && pInfo->bRecord)
		{ // д¼ļܵýݱ޸
			DXWriteMp4file(hmp4, data_vid, buffer, bufferSize, bIsKey, nTmStamp);
		}
	}
	return 0;
}

unsigned __stdcall EncAudioCallback(unsigned char* buffer, unsigned bufferSize, LONGLONG nTmStamp, dxmp4_handle hmp4, void* context)
{
	PDXDEVINFO pInfo = (PDXDEVINFO)context;
	if (pInfo)
	{
		if (pInfo->bNetTrans && pInfo->bNetAudio)
		{ // ݷ
			DXNetTransData(pInfo->devHandle, pInfo->nNetProtcol, data_aud, buffer, bufferSize, false, nTmStamp);
		}

		if (hmp4 && pInfo->bRecord && pInfo->bRecAudio)
		{ // д¼ļܵýݱ޸
			DXWriteMp4file(hmp4, data_aud, buffer, bufferSize, false, nTmStamp);
		}
	}
	return 0;
}

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CVcDemoDlg dialog




CVcDemoDlg::CVcDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CVcDemoDlg::IDD, pParent)
	, m_uDevCount(0)
	, m_uDevSelect(0)
{
	m_WinMode = m_WinOldMode = win_mode_1;
	ZeroMemory(m_DxDev, sizeof(m_DxDev));
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVcDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVcDemoDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_VIDEOWIN_MSG, &CVcDemoDlg::OnVideowinMsg)
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_VIDEOSOURCE, &CVcDemoDlg::OnSelchangeVideosource)
	ON_CBN_SELCHANGE(IDC_AUDIODEV, &CVcDemoDlg::OnSelchangeAudiodev)
	ON_BN_CLICKED(IDC_MUTE, &CVcDemoDlg::OnBnClickedMute)
	ON_BN_CLICKED(IDC_SAVESETTING, &CVcDemoDlg::OnBnClickedSavesetting)
	ON_BN_CLICKED(IDC_RECCONTROL, &CVcDemoDlg::OnBnClickedReccontrol)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_ENCSETTING, &CVcDemoDlg::OnBnClickedEncsetting)
	ON_BN_CLICKED(IDC_VIDEOSNAPSHOT, &CVcDemoDlg::OnBnClickedVideosnapshot)
	ON_BN_CLICKED(IDC_NETSETTING, &CVcDemoDlg::OnBnClickedNetsetting)
	ON_BN_CLICKED(IDC_VIDEOSETTING, &CVcDemoDlg::OnBnClickedVideosetting)
	ON_BN_CLICKED(IDC_OSDSETTING, &CVcDemoDlg::OnBnClickedOsdsetting)
	ON_BN_CLICKED(IDC_VIDEO_FLIP, &CVcDemoDlg::OnBnClickedVideoFlip)
	ON_BN_CLICKED(IDC_VIDEO_MIRROR, &CVcDemoDlg::OnBnClickedVideoMirror)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_FULLSCREEN, &CVcDemoDlg::OnBnClickedFullscreen)
	ON_BN_CLICKED(IDC_REPAIRMP4FILE, &CVcDemoDlg::OnBnClickedRepairmp4file)
	ON_BN_CLICKED(IDC_MP4FILECUT, &CVcDemoDlg::OnBnClickedMp4filecut)
END_MESSAGE_MAP()

// CVcDemoDlg message handlers

BOOL CVcDemoDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	::SetPriorityClass(::GetCurrentProcess(), HIGH_PRIORITY_CLASS); // appĽȼ

	m_uDevCount = DXGetDeviceCount();
	if (m_uDevCount == 0)
	{
		AfxMessageBox(_T("DX Device not exist!"), MB_OK | MB_ICONERROR);
	}

#define MAX_AUDIO_DEV_NUM	16
	DEVICE_TAG audioDev[MAX_AUDIO_DEV_NUM];
	unsigned audioNum = MAX_AUDIO_DEV_NUM;
	unsigned r = DXEnumAudioDevices(audioDev, audioNum);
	DXSDK_CHECK_ERROR("DXEnumAudioDevices", r);

	CString str;
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_AUDIODEV);
	for (unsigned i=0; i<audioNum; i++)
	{
		str = audioDev[i].deviceName;
		pCtrl->SetItemData(pCtrl->AddString(str), audioDev[i].idx);
	}

	GetDlgItem(IDC_WINRECT)->GetWindowRect(m_WinRect);
	ScreenToClient(m_WinRect);

	RECT rc = {0, 0, 1, 1};
	for (unsigned i=0; i<MAX_DXDEV_NUM; i++)
	{
		m_DxDev[i].devIndex = i;
		m_DxDev[i].pVideoWin = new CVideoWin(i);
		if (m_DxDev[i].pVideoWin)
		{
			m_DxDev[i].pVideoWin->Create(NULL, SS_NOPREFIX | SS_NOTIFY, rc, this);
		}
	}

	SetVideoWinMode(0, m_uDevCount > 1 ? win_mode_4 : win_mode_1);

	for (unsigned i=0; i<m_uDevCount; i++)
	{
		m_DxDev[i].devHandle = DXOpenDevice(i, &r);
		DXSDK_CHECK_ERROR("DXOpenDevice", r);
		if (m_DxDev[i].devHandle != NULL)
		{
			DeviceStart(i);
			SetTimeOSD(i);
			SetTextOSD_1(i);
			SetTextOSD_2(i);
			SetPictureOSD(i);
		}
	}

	SelectVideoWin();

	str = INI_READ_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, DEFAULT_FILE_SAVE_DIR);
	if (str.IsEmpty())
	{
		DWORD dwDrives = ::GetLogicalDrives();
		unsigned nIndex = 3;
		for (; nIndex<32; nIndex++)
		{
			if (dwDrives & (1 << nIndex))
			{
				str.Format(_T("%c:\\"), 'A' + nIndex);
				if (::GetDriveType(str) == DRIVE_FIXED)
				{
					break;
				}
			}
		}

		if (nIndex >= 32)
		{
			str = "C:\\";
		}
		str += "DXVcDemo";
		INI_WRITE_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, str);
	}

	unsigned n = INI_READ_INT(INI_SAVE_SECTION, INI_MP4_REPAIR_SUPPORT, DEFAULT_MP4_REPAIR_SUPPORT);
	DXMp4fileRepairSupport(n != 0);

	GetDlgItem(IDC_VIDEOSETTING)->EnableWindow(m_uDevCount > 0);
	GetDlgItem(IDC_OSDSETTING)->EnableWindow(m_uDevCount > 0);
	GetDlgItem(IDC_ENCSETTING)->EnableWindow(m_uDevCount > 0);
	GetDlgItem(IDC_NETSETTING)->EnableWindow(m_uDevCount > 0);

	LOGFONT logFont;
	GetFont()->GetLogFont(&logFont);
	logFont.lfHeight = 28;
	m_Font.CreateFontIndirect(&logFont);
	GetDlgItem(IDC_STATUS)->SetFont(&m_Font);
	m_Brush.CreateSolidBrush(RGB(50, 150, 255));

	g_repair_dlg.Create(CProgressDlg::IDD, this);
	g_cut_dlg.Create(CProgressDlg::IDD, this);

	SetTimer(MAX_DXDEV_NUM, 100, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVcDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVcDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();

		CRect rc;
		m_DxDev[m_uDevSelect].pVideoWin->GetWindowRect(rc);
		ScreenToClient(rc);
		rc.InflateRect(1, 1);

		CDC *pDC = GetDC();
		CPen Pen;
		Pen.CreatePen(PS_SOLID, 1, RGB(255, 255, 0));

		CPen *pPen = pDC->SelectObject(&Pen);
		CBrush *pBrush = (CBrush*)pDC->SelectStockObject(NULL_BRUSH);

		pDC->Rectangle(rc);

		pDC->SelectObject(pPen);
		pDC->SelectObject(pBrush);

		ReleaseDC(pDC);
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



afx_msg LRESULT CVcDemoDlg::OnVideowinMsg(WPARAM wParam, LPARAM lParam)
{
	unsigned uIndex = wParam;
	if (uIndex < MAX_DXDEV_NUM)
	{
		switch (lParam)
		{
		case WIN_LEFTCLICK:
			{
				if (m_uDevSelect != uIndex)
				{
					CRect rc0(0, 0, 0, 0);
					if (m_DxDev[m_uDevSelect].pVideoWin->IsWindowVisible())
					{
						m_DxDev[m_uDevSelect].pVideoWin->GetWindowRect(rc0);
						ScreenToClient(rc0);
						rc0.InflateRect(1, 1);
					}

					m_uDevSelect = uIndex;
					SelectVideoWin();

					CRect rc1;
					m_DxDev[uIndex].pVideoWin->GetWindowRect(rc1);
					ScreenToClient(rc1);
					rc1.InflateRect(1, 1);

					InvalidateRect(rc0, TRUE);
					InvalidateRect(rc1, TRUE);
				}
			}
			break;

		case WIN_LEFTDBCLICK:
			{
				if (m_WinMode == win_mode_1)
				{
					SetVideoWinMode(0, m_WinOldMode == win_mode_1 ? win_mode_4 : m_WinOldMode);
				}
				else
				{
					SetVideoWinMode(m_uDevSelect,  win_mode_1);
				}
			}
			break;

		default:
			break;
		}
	}
	return 0;
}


void CVcDemoDlg::SetVideoWinMode(int nStart, win_mode_e mode)
{
	int winSplit;
	switch (mode)
	{
	case win_mode_4:
		winSplit = 2;
		break;
	case win_mode_9:
		winSplit = 3;
		break;
	case win_mode_16:
		winSplit = 4;
		break;
	case win_mode_1:
	default:
		winSplit = 1;
		break;
	}

	m_WinOldMode = m_WinMode;
	m_WinMode = mode;

	int nWidth  = (m_WinRect.Width() - winSplit) / winSplit;
	int nHeight = (m_WinRect.Height() - winSplit) / winSplit;

	for (int i=0; i<MAX_DXDEV_NUM; i++)
	{
		if (m_DxDev[i].devHandle != NULL)
		{
			VideoPreviewStop(i);
		}
		m_DxDev[i].pVideoWin->ShowWindow(SW_HIDE);
	}

	CRect rc;
	for (int i=0; i<winSplit; i++)
	{
		rc.left   = m_WinRect.left;
		rc.right  = rc.left + nWidth;
		rc.top    = m_WinRect.top + i * nHeight + i;
		rc.bottom = rc.top + nHeight;
		for (int j=0; j<winSplit; j++)
		{
			rc.OffsetRect((j == 0) ? 0 : nWidth + 1, 0);
			if (nStart < MAX_DXDEV_NUM)
			{
				m_DxDev[nStart].pVideoWin->MoveWindow(rc, TRUE);
				m_DxDev[nStart].pVideoWin->ShowWindow(SW_SHOW);
				if (m_DxDev[i].devHandle != NULL)
				{
					VideoPreviewStart(i);
				}
				nStart++;
			}
		}
	}
}


void CVcDemoDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: Add your message handler code here
	KillTimer(MAX_DXDEV_NUM);
	for (int i=0; i<MAX_DXDEV_NUM; i++)
	{
		if (m_DxDev[i].devHandle)
		{
			if (m_DxDev[i].bNetTrans)
			{
				NetStreamStop(i);
			}
			if (m_DxDev[i].bRecord)
			{
				RecordControl(i);
			}
			if (m_DxDev[i].bTimeOSD || m_DxDev[i].bPictureOSD || m_DxDev[i].bTextOSD_1 || m_DxDev[i].bTextOSD_2)
			{
				DXEnOSDDisp(m_DxDev[i].devHandle, osd_type_all, -1, FALSE);
			}
			VideoPreviewStop(i);
			DXDeviceStop(m_DxDev[i].devHandle);
			DXCloseDevice(m_DxDev[i].devHandle);
		}
		if (m_DxDev[i].pVideoWin)
		{
			m_DxDev[i].pVideoWin->DestroyWindow();
			delete m_DxDev[i].pVideoWin;
		}
	}

	g_repair_dlg.DestroyWindow();
	g_cut_dlg.DestroyWindow();
}


void CVcDemoDlg::FullScreenVideoFlip()
{
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		((CButton*)GetDlgItem(IDC_VIDEO_FLIP))->SetCheck(m_DxDev[m_uDevSelect].bFlip ? BST_UNCHECKED : BST_CHECKED);
		OnBnClickedVideoFlip();
	}
}



void CVcDemoDlg::FullScreenVideoMirror()
{
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		((CButton*)GetDlgItem(IDC_VIDEO_MIRROR))->SetCheck(m_DxDev[m_uDevSelect].bMirror ? BST_UNCHECKED : BST_CHECKED);
		OnBnClickedVideoMirror();
	}
}



void CVcDemoDlg::ExitFullScreen()
{
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		VideoPreviewStop(m_uDevSelect);
		m_DxDev[m_uDevSelect].pVideoWin->SetFullScreen(FALSE);
		VideoPreviewStart(m_uDevSelect);
	}
}



void CVcDemoDlg::SelectVideoWin(void)
{
	CComboBox *pAduioDev = (CComboBox*)GetDlgItem(IDC_AUDIODEV);
	CComboBox *pVideoSrc = (CComboBox*)GetDlgItem(IDC_VIDEOSOURCE);
	pVideoSrc->ResetContent();

	if (m_DxDev[m_uDevSelect].devHandle && !DXDeviceIsUVC(m_DxDev[m_uDevSelect].devHandle))
	{
#define DEV_MAX_SOURCES	16
		unsigned curIndex;
		char* devSrc[DEV_MAX_SOURCES];
		BYTE num = DEV_MAX_SOURCES;
		unsigned r = DXGetVideoSourcesEx(m_DxDev[m_uDevSelect].devHandle, &curIndex, devSrc, &num);
		DXSDK_CHECK_ERROR("DXGetVideoSourcesEx", r);
		if (r == 0)
		{
			USES_CONVERSION;

			CString str;
			int nIndex = 0;
			for (unsigned i=0; i<num; i++)
			{
				str.Format(_T("%d: %s"), nIndex++, A2T(devSrc[i]));
				pVideoSrc->AddString(str);
			}
			pVideoSrc->SetCurSel(curIndex);
		}
	}

	pAduioDev->SetCurSel(m_DxDev[m_uDevSelect].bSoundOut && m_DxDev[m_uDevSelect].devHandle != NULL ? m_DxDev[m_uDevSelect].audioDev : -1);
	pAduioDev->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);
	pVideoSrc->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);

	((CButton*)GetDlgItem(IDC_MUTE))->SetCheck(m_DxDev[m_uDevSelect].bMute ? BST_CHECKED : BST_UNCHECKED);
	GetDlgItem(IDC_MUTE)->EnableWindow(m_DxDev[m_uDevSelect].bSoundOut && m_DxDev[m_uDevSelect].devHandle != NULL);
	((CButton*)GetDlgItem(IDC_VIDEO_FLIP))->SetCheck(m_DxDev[m_uDevSelect].bFlip ? BST_CHECKED : BST_UNCHECKED);
	GetDlgItem(IDC_VIDEO_FLIP)->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);
	((CButton*)GetDlgItem(IDC_VIDEO_MIRROR))->SetCheck(m_DxDev[m_uDevSelect].bMirror ? BST_CHECKED : BST_UNCHECKED);
	GetDlgItem(IDC_VIDEO_MIRROR)->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);
	GetDlgItem(IDC_VIDEOSNAPSHOT)->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);
	GetDlgItem(IDC_RECCONTROL)->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);
	GetDlgItem(IDC_FULLSCREEN)->EnableWindow(m_DxDev[m_uDevSelect].devHandle != NULL);
	SetDlgItemText(IDC_RECCONTROL, m_DxDev[m_uDevSelect].bRecord ? _T("Record Stop") : _T("Record Start"));

	SetVideoStatus(m_uDevSelect);
}



void CVcDemoDlg::OnSelchangeVideosource()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		int nSel = ((CComboBox*)GetDlgItem(IDC_VIDEOSOURCE))->GetCurSel();
		if (nSel >= 0 && nSel != m_DxDev[m_uDevSelect].videoSource)
		{
			VideoPreviewStop(m_uDevSelect);
			ini_dev_write_int(m_uDevSelect, INI_VIDEO_SOURCE_INDEX, nSel);
			SetVideoSource(m_uDevSelect);
			VideoPreviewStart(m_uDevSelect);
		}
	}
}


void CVcDemoDlg::OnSelchangeAudiodev()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_AUDIODEV);
		int nSel = pCtrl->GetCurSel();
		if (nSel >= 0)
		{
			unsigned n = ini_dev_read_int(m_uDevSelect, INI_DEFAULT(AUDIO_DEVICE_INDEX));
			if (n != nSel)
			{
				ini_dev_write_int(m_uDevSelect, INI_AUDIO_DEVICE_INDEX, nSel);
				DeviceRestart(m_uDevSelect);
			}
		}
	}
}


void CVcDemoDlg::OnBnClickedMute()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		m_DxDev[m_uDevSelect].bMute = ((CButton*)GetDlgItem(IDC_MUTE))->GetCheck() == BST_CHECKED;
		unsigned r = DXEnableMute(m_DxDev[m_uDevSelect].devHandle, m_DxDev[m_uDevSelect].bMute);
		DXSDK_CHECK_ERROR("DXEnableMute", r);
	}
}


void CVcDemoDlg::OnBnClickedSavesetting()
{
	// TODO: Add your control notification handler code here
	CString dir0 = INI_READ_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, DEFAULT_FILE_SAVE_DIR);
	unsigned dur0 = INI_READ_INT(INI_SAVE_SECTION, INI_REC_FILE_DUR, DEFAULT_REC_FILE_DUR);
	unsigned support0 = INI_READ_INT(INI_SAVE_SECTION, INI_MP4_REPAIR_SUPPORT, DEFAULT_MP4_REPAIR_SUPPORT);

	CSaveSettingDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		CString dir1 = INI_READ_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, DEFAULT_FILE_SAVE_DIR);
		unsigned dur1 = INI_READ_INT(INI_SAVE_SECTION, INI_REC_FILE_DUR, DEFAULT_REC_FILE_DUR);
		unsigned support1 = INI_READ_INT(INI_SAVE_SECTION, INI_MP4_REPAIR_SUPPORT, DEFAULT_MP4_REPAIR_SUPPORT);

		if (dir0 != dir1 || dur0 != dur1 || support0 != support1)
		{// ¼仯ֹͣ¼
			if (support0 != support1)
			{
				DXMp4fileRepairSupport(support1 != 0);
			}
			
			for (unsigned i=0; i<m_uDevCount; i++)
			{
				if (m_DxDev[i].bRecord)
				{
					// ֹͣǰ¼
					RecordControl(i);
					// ¼
					RecordControl(i);
				}
			}
		}
	}
}


void CVcDemoDlg::OnBnClickedReccontrol()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		RecordControl(m_uDevSelect);
		SelectVideoWin();
	}
}


void CVcDemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent < MAX_DXDEV_NUM)
	{
		RecordStop(nIDEvent);
		RecordStart(nIDEvent);
	}
	else
	{
		for (unsigned i=0; i<m_uDevCount; i++)
		{
			if (m_DxDev[i].devHandle)
			{
				unsigned n, r = DXGetSignalPresent(m_DxDev[i].devHandle, n);
				if (r == 0)
				{
					BOOL bChanged = (n == 0 && m_DxDev[i].bSignal || n != 0 && !m_DxDev[i].bSignal);
					m_DxDev[i].bSignal = n != 0;
					if (bChanged && i == m_uDevSelect)
					{
						SetVideoStatus(i);
					}
				}
			}
		}

		if (g_repair_dlg.IsWindowVisible())
		{
			int n = DXMp4fileRepairProgress();
			if (n == -1 || n == 100)
			{ /* Repair success or failure */
				g_repair_dlg.ShowWindow(SW_HIDE);
			}
			else
			{
				g_repair_dlg.UpdateProgress(n);
			}
		}

		if (g_cut_dlg.IsWindowVisible())
		{
			int n = DXMp4fileMergeProgress();
			if (n == -1 || n == 100)
			{ /* Merge success or failure */
				g_cut_dlg.ShowWindow(SW_HIDE);
			}
			else
			{
				g_cut_dlg.UpdateProgress(n);
			}
		}
	}

	CDialogEx::OnTimer(nIDEvent);
}


void CVcDemoDlg::SetVideoStatus(unsigned int nIndex)
{
	CString str;
	if (m_DxDev[nIndex].devHandle)
	{
		if (m_DxDev[nIndex].bSignal)
		{
			str.Format(_T("%u*%u\r\n%.1ffps"), m_DxDev[nIndex].nWidth, m_DxDev[nIndex].nHeight, m_DxDev[nIndex].fFrameRate);
		}
		else
		{
			str = "Video\r\nNo Signal";
		}
	}
	else
	{
		str = "Video\r\nStopped";
	}
	SetDlgItemText(IDC_STATUS, str);
}


void CVcDemoDlg::SetAudioDevice(unsigned int nIndex)
{
	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_AUDIODEV);
	int nCount = pCtrl->GetCount();
	if (nCount > 0)
	{
		USES_CONVERSION;

		unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(AUDIO_DEVICE_INDEX));
		if (n >= (unsigned)nCount)
		{
			n = 0;
		}

		CString str;
		pCtrl->GetLBText(n, str);

		DEVICE_TAG dev;
		strcpy_s(dev.deviceName, MAX_DEVICE_NAME, T2A(str));
		dev.idx = pCtrl->GetItemData(n);

		unsigned r = DXSetAudioDevice(m_DxDev[nIndex].devHandle, &dev);
		DXSDK_CHECK_ERROR("DXSetAudioDevice", r);
		if (r == 0)
		{
			m_DxDev[nIndex].audioDev = n;
			m_DxDev[nIndex].bSoundOut = TRUE;
			return;
		}
		// Ƶ豸
		pCtrl->SetCurSel(-1);
	}
	m_DxDev[nIndex].bSoundOut = FALSE;
}


void CVcDemoDlg::SetVideoParam(unsigned int nIndex)
{
	unsigned r, nWidth, nHeight, nFrameRate;
	unsigned colorspace = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_COLOR_SPACE));
	if (DXDeviceIsHD(m_DxDev[nIndex].devHandle))
	{
		nWidth = ini_dev_read_int(nIndex, INI_VIDEO_HD_WIDTH, 0);
		nHeight = ini_dev_read_int(nIndex, INI_VIDEO_HD_HEIGHT, 0);
		nFrameRate = ini_dev_read_int(nIndex, INI_VIDEO_HD_FRAME_RATE, 0);
		if (nWidth != 0 && nHeight != 0 && nFrameRate != 0)
		{
			r = DXSetVideoParaHD(m_DxDev[nIndex].devHandle, colorspace, nWidth, nHeight, (float)nFrameRate);
			DXSDK_CHECK_ERROR("DXSetVideoParaHD", r);
		}
		r = DXGetVideoParaHD(m_DxDev[nIndex].devHandle, colorspace, m_DxDev[nIndex].nWidth, m_DxDev[nIndex].nHeight, m_DxDev[nIndex].fFrameRate);
		DXSDK_CHECK_ERROR("DXGetVideoParaHD", r);
	}
	else
	{
		nWidth = ini_dev_read_int(nIndex, INI_VIDEO_WIDTH, 0);
		nHeight = ini_dev_read_int(nIndex, INI_VIDEO_HEIGHT, 0);
		nFrameRate = ini_dev_read_int(nIndex, INI_VIDEO_FRAME_RATE, 0);
		unsigned nStandard = ini_dev_read_int(nIndex, INI_VIDEO_STANDARD, 0);
		if (nWidth != 0 && nHeight != 0 && nFrameRate != 0 && nStandard != 0)
		{
			r = DXSetVideoPara(m_DxDev[nIndex].devHandle, nStandard, colorspace, nWidth, nHeight, (float)nFrameRate);
			DXSDK_CHECK_ERROR("DXSetVideoPara", r);
		}
		r = DXGetVideoPara(m_DxDev[nIndex].devHandle, m_DxDev[nIndex].nStandard, colorspace, m_DxDev[nIndex].nWidth, m_DxDev[nIndex].nHeight, m_DxDev[nIndex].fFrameRate);
		DXSDK_CHECK_ERROR("DXGetVideoPara", r);
	}

	unsigned nTypes[] = { video_brightness, video_contrast, video_saturation, video_hue, video_sharpness };
	LPCTSTR strItems[] = { INI_VIDEO_BRIGHTNESS, INI_VIDEO_CONTRAST, INI_VIDEO_SATURATION, INI_VIDEO_HUE, INI_VIDEO_SHARPNESS };
	LPCTSTR strHDItems[] = { INI_VIDEO_HD_BRIGHTNESS, INI_VIDEO_HD_CONTRAST, INI_VIDEO_HD_SATURATION, INI_VIDEO_HD_HUE, INI_VIDEO_HD_SHARPNESS };
	for (unsigned i=0; i<_countof(nTypes); i++)
	{
		CString str = ini_dev_read_string(nIndex, DXDeviceIsHD(m_DxDev[nIndex].devHandle) ? strHDItems[i] : strItems[i], INI_NULL);
		if (!str.IsEmpty())
		{
			LONG nMin, nMax, nStep, nDefault, nFlags;
			r = DXGetDisplayParaRange(m_DxDev[nIndex].devHandle, nTypes[i], &nMin, &nMax, &nStep, &nDefault, &nFlags);
			DXSDK_CHECK_ERROR("DXGetDisplayParaRange", r);
			if (r == 0)
			{
				int nVal = _ttoi(str);
				if (nVal >= nMin && nVal <= nMax)
				{
					r = DXSetDisplayPara(m_DxDev[nIndex].devHandle, nTypes[i], nVal, 0);
					DXSDK_CHECK_ERROR("DXSetDisplayPara", r);
				}
			}
		}
	}
}



void CVcDemoDlg::SetVideoSource(unsigned int nIndex)
{
	if (DXDeviceIsUVC(m_DxDev[nIndex].devHandle))
	{
		return;
	}

	unsigned sourceIndex;
	unsigned char num;
	unsigned r = DXGetVideoSourcesEx(m_DxDev[nIndex].devHandle, &sourceIndex, NULL, &num);
	DXSDK_CHECK_ERROR("DXGetVideoSourcesEx", r);
	if (r == 0)
	{
		unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_SOURCE_INDEX));
		if (sourceIndex != n && n < num)
		{
			r = DXSetVideoSourceEx(m_DxDev[nIndex].devHandle, n);
			DXSDK_CHECK_ERROR("DXSetVideoSourceEx", r);
			m_DxDev[nIndex].videoSource = n;
			return;
		}
		m_DxDev[nIndex].videoSource = sourceIndex;
	}
}



void CVcDemoDlg::SetVideoDeinterlace(unsigned int nIndex)
{
	if (!DXDeviceIsHD(m_DxDev[nIndex].devHandle))
	{
		unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_DEINTERLACE));
		DXEnableDeinterlace(m_DxDev[nIndex].devHandle, n);
	}
}



void CVcDemoDlg::SetTimeOSD(unsigned int nIndex)
{
	if (m_DxDev[nIndex].bTimeOSD)
	{
		unsigned r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_time, 0, FALSE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bTimeOSD = FALSE;
	}

	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_ENABLE));
	if (n != 0)
	{
		USES_CONVERSION;

		n = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_TRANSPARENT));
		int x = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_X));
		int y = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_Y));
		int sz = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_FONTSZ));
		COLORREF cr = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_COLOR));
		CString name = ini_dev_read_string(nIndex, INI_DEFAULT(TIME_OSD_FONTNAME));
		unsigned r = DXSetTimeOSD(m_DxDev[nIndex].devHandle, x, y, sz, T2A(name), cr, DEFAULT_OSD_BKCOLOR, n != 0);
		DXSDK_CHECK_ERROR("DXSetTimeOSD", r);
		r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_time, 0, TRUE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bTimeOSD = TRUE;
	}
}



void CVcDemoDlg::SetTextOSD_1(unsigned int nIndex)
{
	if (m_DxDev[nIndex].bTextOSD_1)
	{
		unsigned r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_text, 0, FALSE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bTextOSD_1 = FALSE;
	}

	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_ENABLE1));
	CString str = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_STR1));
	if (n != 0 && !str.IsEmpty())
	{
		USES_CONVERSION;

		n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_TRANSPARENT1));
		int x = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_X1));
		int y = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_Y1));
		int sz = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_FONTSZ1));
		COLORREF cr = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_COLOR1));
		CString name = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_FONTNAME1));
		unsigned r = DXSetTextOSD(m_DxDev[nIndex].devHandle, x, y, 0, T2A(str), sz, T2A(name), cr, DEFAULT_OSD_BKCOLOR, n != 0);
		DXSDK_CHECK_ERROR("DXSetTextOSD", r);
		r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_text, 0, TRUE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bTextOSD_1 = TRUE;
	}
}



void CVcDemoDlg::SetTextOSD_2(unsigned int nIndex)
{
	if (m_DxDev[nIndex].bTextOSD_2)
	{
		unsigned r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_text, 1, FALSE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bTextOSD_2 = FALSE;
	}

	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_ENABLE2));
	CString str = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_STR2));
	if (n != 0 && !str.IsEmpty())
	{
		USES_CONVERSION;

		n = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_TRANSPARENT2));
		int x = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_X2));
		int y = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_Y2));
		int sz = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_FONTSZ2));
		COLORREF cr = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_COLOR2));
		CString name = ini_dev_read_string(nIndex, INI_DEFAULT(TEXT_OSD_FONTNAME2));
		unsigned r = DXSetTextOSD(m_DxDev[nIndex].devHandle, x, y, 1, T2A(str), sz, T2A(name), cr, DEFAULT_OSD_BKCOLOR, n != 0);
		DXSDK_CHECK_ERROR("DXSetTextOSD", r);
		r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_text, 1, TRUE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bTextOSD_2 = TRUE;
	}
}



void CVcDemoDlg::SetPictureOSD(unsigned int nIndex)
{
	if (m_DxDev[nIndex].bPictureOSD)
	{
		unsigned r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_picture, 0, FALSE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bPictureOSD = FALSE;
	}

	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_ENABLE));
	CString str = ini_dev_read_string(nIndex, INI_DEFAULT(PIC_OSD_FILE));
	if (n != 0 && ::PathFileExists(str))
	{
		USES_CONVERSION;

		n = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_TRANSPARENT));
		int x = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_X));
		int y = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_Y));

		unsigned r = DXSetPictureOSD(m_DxDev[nIndex].devHandle, x, y, 0, T2A(str), TRUE, (BYTE)n);
		DXSDK_CHECK_ERROR("DXSetPictureOSD", r);
		r = DXEnOSDDisp(m_DxDev[nIndex].devHandle, osd_type_picture, 0, TRUE);
		DXSDK_CHECK_ERROR("DXEnOSDDisp", r);
		m_DxDev[nIndex].bPictureOSD = TRUE;
	}
}



void CVcDemoDlg::VideoPreviewStart(unsigned int nIndex)
{
	unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_RENDER_TYPE));
	unsigned r = DXStartPreview(m_DxDev[nIndex].devHandle, m_DxDev[nIndex].pVideoWin->GetSafeHwnd(), NULL, n <= dp_d3d ? n : dp_d3d);
	DXSDK_CHECK_ERROR("DXStartPreview", r);
	if (m_DxDev[nIndex].bSoundOut)
	{
		r = DXSetSoundOut(m_DxDev[nIndex].devHandle, TRUE);
		DXSDK_CHECK_ERROR("DXSetSoundOut", r);
	}
}


void CVcDemoDlg::VideoPreviewStop(unsigned int nIndex)
{
	unsigned r = DXStopPreview(m_DxDev[nIndex].devHandle);
	DXSDK_CHECK_ERROR("DXStopPreview", r);
}


void CVcDemoDlg::DeviceStart(unsigned int nIndex)
{
	SetAudioDevice(nIndex);
	SetVideoParam(nIndex);
	SetVideoDeinterlace(nIndex);

	unsigned r = DXDeviceRun(m_DxDev[nIndex].devHandle);
	DXSDK_CHECK_ERROR("DXDeviceRun", r);

	SetVideoSource(nIndex);
	VideoPreviewStart(nIndex);
	NetStreamStart(nIndex);
}


void CVcDemoDlg::DeviceRestart(unsigned int nIndex)
{
	BOOL bRecord = m_DxDev[nIndex].bRecord;
	if (m_DxDev[nIndex].bRecord)
	{
		RecordControl(nIndex);
	}

	if (m_DxDev[nIndex].bNetTrans)
	{
		NetStreamStop(nIndex);
	}

	VideoPreviewStop(nIndex);

	unsigned r = DXDeviceStop(m_DxDev[nIndex].devHandle);
	DXSDK_CHECK_ERROR("DXDeviceStop", r);

	DeviceStart(nIndex);
	
	if (bRecord)
	{
		RecordControl(nIndex);
	}

	if (nIndex == m_uDevSelect)
	{
		SelectVideoWin();
	}
}


#define USE_XVID_REC_AVI 0 // ص/rtspͬʱ
BOOL CVcDemoDlg::RecordStart(unsigned int nIndex)
{
	if (nIndex < MAX_DXDEV_NUM && m_DxDev[nIndex].devHandle && !m_DxDev[nIndex].bRecord)
	{
		CString str;
		if (GetFilename(str, ".mp4"))
		{
#if USE_XVID_REC_AVI
			USES_CONVERSION;
			// xvidƵֻʹavi¼ʽ
			// h264Ƶʹavimp4¼ʽ
			DEVICE_TAG devTag;
			devTag.idx = codec_xvid;
			strcpy_s(devTag.deviceName, MAX_DEVICE_NAME, XVIDCODEC_FILTER);
			unsigned r = DXSetVideoCodec(m_DxDev[nIndex].devHandle, &devTag);
			DXSDK_CHECK_ERROR("DXSetVideoCodec", r);
			if (m_DxDev[nIndex].bSoundOut)
			{
				// avi¼ʱƵʹima adpcm
				// mp4¼ʱƵʹaac
				devTag.idx = acodec_sys;
				strcpy_s(devTag.deviceName, MAX_DEVICE_NAME, SYS_FILTER);
				r = DXSetAudioCodec(m_DxDev[nIndex].devHandle, &devTag);
				DXSDK_CHECK_ERROR("DXSetAudioCodec", r);
			}

#define VIDEO_ENC_RATIO 2 // 1/2֡
			VidCodecPara para;
			para.fps = (int)m_DxDev[nIndex].fFrameRate;
			if (VIDEO_ENC_RATIO > 1)
			{
				para.fps /= VIDEO_ENC_RATIO;
			}
			para.keyframeinterval = (int)m_DxDev[nIndex].fFrameRate;
			unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_BIT_RATE));
			para.Bitrate = n;
			n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_CONTROL));
			para.rcMode = n == 0 ? codec_CBR : codec_VBR;
			para.Quality = 28; // ֵԽСԽ
			para.Maxrbps = 8192;
			para.Peekbps = 4096;

			r = DXSetVideoCodecPara(m_DxDev[nIndex].devHandle, codec_xvid, &para);
			DXSDK_CHECK_ERROR("DXSetVideoCodecPara", r);

			n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_TYPE)); // Ƿ¼Ƶ
			r = DXStartCaptureEx(m_DxDev[nIndex].devHandle, T2A(str), m_DxDev[nIndex].bSoundOut && n == 1, FILE_AVI, NULL, NULL, NULL, VIDEO_ENC_RATIO);
			if (r == 0)
			{
				m_DxDev[nIndex].bRecord = TRUE;
				return TRUE;
			}
#else
			if (EncodeCallbackControl(nIndex, TRUE)) // صʱд¼
			{
				USES_CONVERSION;

				unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_TYPE)); // Ƿ¼Ƶ
				unsigned r = DXCreateMp4file(m_DxDev[nIndex].devHandle, T2A(str), m_DxDev[nIndex].bSoundOut && n == 1);
				DXSDK_CHECK_ERROR("DXCreateMp4file", r);
				if (r == 0)
				{
					m_DxDev[nIndex].bRecAudio = n == 1;
					m_DxDev[nIndex].bRecord = TRUE;
					return TRUE;
				}
			}
#endif
		}
		if (!m_DxDev[nIndex].bRecord)
		{
			AfxMessageBox(_T("Record file create failure!"), MB_OK | MB_ICONERROR);
		}
	}
	return FALSE;
}


void CVcDemoDlg::RecordStop(unsigned int nIndex)
{
	if (nIndex < MAX_DXDEV_NUM && m_DxDev[nIndex].devHandle && m_DxDev[nIndex].bRecord)
	{
#if USE_XVID_REC_AVI
		DXStopCapture(m_DxDev[nIndex].devHandle);
		m_DxDev[nIndex].bRecord = FALSE;
#else
		m_DxDev[nIndex].bRecord = FALSE;
		m_DxDev[nIndex].bRecAudio = FALSE;
		EncodeCallbackControl(nIndex, FALSE);

		unsigned r = DXCloseMp4file(m_DxDev[nIndex].devHandle);
		DXSDK_CHECK_ERROR("DXCloseMp4file", r);
#endif
	}
}

void CVcDemoDlg::RecordControl(unsigned int nIndex)
{
	if (m_DxDev[nIndex].bRecord)
	{
		RecordStop(nIndex);
		KillTimer(nIndex);
	}
	else if (RecordStart(nIndex))
	{
		unsigned n = INI_READ_INT(INI_SAVE_SECTION, INI_REC_FILE_DUR, DEFAULT_REC_FILE_DUR);
		SetTimer(nIndex, MIN_2_MILLISEC(n), NULL);
	}
}


void CVcDemoDlg::NetStreamStart(unsigned int nIndex)
{
	if (nIndex < MAX_DXDEV_NUM && m_DxDev[nIndex].devHandle && !m_DxDev[nIndex].bNetTrans)
	{
		unsigned rtspEnable = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTSP_ENABLE));
		unsigned rtspPort = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTSP_PORT));
		unsigned rtmpEnable = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTMP_ENABLE));
		unsigned audioEnable = ini_dev_read_int(nIndex, INI_DEFAULT(NET_AUDIO_ENABLE));
		CString strUri = ini_dev_read_string(nIndex, INI_DEFAULT(NET_RTMP_URI));

		int nType;
		if (rtspEnable && rtmpEnable && !strUri.IsEmpty())
		{
			nType = net_all;
		}
		else if (rtspEnable)
		{
			nType = net_crtsp;
		}
		else if (rtmpEnable && !strUri.IsEmpty())
		{
			nType = net_crtmp;
		}
		else
		{
			return;
		}

		if (EncodeCallbackControl(nIndex, TRUE)) // صʱд
		{
			NetTransPara para = {0};
			if (nType == net_all || nType == net_crtsp)
			{
				para.port = rtspPort == 0 ? 554 : 8554;
			}
			if (nType == net_all || nType == net_crtmp)
			{
				USES_CONVERSION;
				strcpy_s(para.crtmp_uri, MAX_PATH, T2A(strUri));
			}

			unsigned r = DXStartNetTrans(m_DxDev[nIndex].devHandle, nType, &para);
			DXSDK_CHECK_ERROR("DXStartNetTrans", r);
			if (r == 0)
			{
				m_DxDev[nIndex].bNetAudio = audioEnable != 0;
				m_DxDev[nIndex].nNetProtcol = nType;
				m_DxDev[nIndex].bNetTrans = TRUE;
			}
		}
	}
}

void CVcDemoDlg::NetStreamStop(unsigned int nIndex)
{
	if (nIndex < MAX_DXDEV_NUM && m_DxDev[nIndex].devHandle && m_DxDev[nIndex].bNetTrans)
	{
		m_DxDev[nIndex].bNetTrans = FALSE;
		m_DxDev[nIndex].bNetAudio = FALSE;
		EncodeCallbackControl(nIndex, FALSE);

		unsigned r = DXStopNetTrans(m_DxDev[nIndex].devHandle, net_all);
		DXSDK_CHECK_ERROR("DXStopNetTrans", r);
	}
}

BOOL CVcDemoDlg::EncodeCallbackControl(unsigned int nIndex, BOOL bStart)
{
	if (nIndex < MAX_DXDEV_NUM && m_DxDev[nIndex].devHandle)
	{
		if (bStart)
		{
			if (!m_DxDev[nIndex].bEncode)
			{
				DEVICE_TAG devTag = {0};
				unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_ENCODER_TYPE));
				devTag.idx = n == 0 ? codec_intel264 : codec_x264;
				strcpy_s(devTag.deviceName, MAX_DEVICE_NAME, n == 0 ? INTEL264CODEC_FILTER : X264CODEC_FILTER);

				unsigned r = DXSetVideoCodec(m_DxDev[nIndex].devHandle, &devTag);
				DXSDK_CHECK_ERROR("DXSetVideoCodec", r);
				if (m_DxDev[nIndex].bSoundOut)
				{
					devTag.idx = acodec_aac;
					strcpy_s(devTag.deviceName, MAX_DEVICE_NAME, AAC_FILTER);
					r = DXSetAudioCodec(m_DxDev[nIndex].devHandle, &devTag);
					DXSDK_CHECK_ERROR("DXSetAudioCodec", r);
				}

				unsigned m = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_FRAME_RATIO));
				VidCodecPara para;
				para.fps = (int)m_DxDev[nIndex].fFrameRate;
				if (m > 1 && m <=4)
				{
					para.fps /= m; // ȫ֡ʻǲ֡ʣ1/21/31/4
				}
				para.keyframeinterval = para.fps; // ÿһGOP
				n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_BIT_RATE));
				para.Bitrate = n;
				n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_CONTROL));
				para.rcMode = n == 0 ? codec_CBR : codec_VBR;
				para.Quality = 28;
				para.Maxrbps = 8000;
				para.Peekbps = 2000;

				n = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_ENCODER_TYPE));
				r = DXSetVideoCodecPara(m_DxDev[nIndex].devHandle, n == 0 ? codec_intel264 : codec_x264, &para);
				DXSDK_CHECK_ERROR("DXSetVideoCodecPara", r);
				r = DXStartEncVideo(m_DxDev[nIndex].devHandle, m_DxDev[nIndex].bSoundOut, m);
				DXSDK_CHECK_ERROR("DXStartEncVideo", r);
				if (r == 0)
				{
					r = DXStartEncVideoCallback(m_DxDev[nIndex].devHandle, EncVideoCallback, &m_DxDev[nIndex]);
					DXSDK_CHECK_ERROR("DXStartEncVideoCallback", r);
					if (m_DxDev[nIndex].bSoundOut)
					{
						r = DXStartEncAudioCallback(m_DxDev[nIndex].devHandle, EncAudioCallback, &m_DxDev[nIndex]);
						DXSDK_CHECK_ERROR("DXStartEncAudioCallback", r);
					}
					m_DxDev[nIndex].bEncode = TRUE;
				}
			}
			return m_DxDev[nIndex].bEncode;
		}
		else if (m_DxDev[nIndex].bEncode)
		{
			if (!(m_DxDev[nIndex].bNetTrans || m_DxDev[nIndex].bRecord))
			{
				unsigned r = DXStopEncVideoCallback(m_DxDev[nIndex].devHandle);
				DXSDK_CHECK_ERROR("DXStopEncVideoCallback", r);
				if (m_DxDev[nIndex].bSoundOut)
				{
					r = DXStopEncAudioCallback(m_DxDev[nIndex].devHandle);
					DXSDK_CHECK_ERROR("DXStopEncAudioCallback", r);
				}
				r = DXStopCapture(m_DxDev[nIndex].devHandle);
				DXSDK_CHECK_ERROR("DXStopCapture", r);
				m_DxDev[nIndex].bEncode = FALSE;
			}
		}
		return TRUE;
	}
	return FALSE;
}


BOOL CVcDemoDlg::GetFilename(CString &strFile, LPCSTR strExtend)
{
	CString str = INI_READ_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, DEFAULT_FILE_SAVE_DIR);
	if (!str.IsEmpty())
	{
		int nLen = str.GetLength();
		if (str[nLen - 1] != '\\')
		{
			str += '\\';
		}

		if (strcmp(strExtend, ".mp4") == 0)
		{ // ¼ļ
			str += "Rec\\";
		}
		else
		{
			str += "Pic\\";
		}

		USES_CONVERSION;

		if (MakeSureDirectoryPathExists(T2A(str)))
		{
			CTime time = CTime::GetCurrentTime();
			strFile = str + time.Format(_T("%Y%m%d-%H%M%S"));
			if (strExtend)
			{
				strFile += strExtend;
			}
			return TRUE;
		}
	}
	strFile.Empty();
	return FALSE;
}



void CVcDemoDlg::GetEncodeSetting(unsigned nIndex, ENCODEINFO &info)
{
	info.streamType = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_TYPE));
	info.streamControl = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_STREAM_CONTROL));
	info.encoderType = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_ENCODER_TYPE));
	info.frameRatio = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_FRAME_RATIO));
	info.bitrate = ini_dev_read_int(nIndex, INI_DEFAULT(ENC_BIT_RATE));
}



void CVcDemoDlg::OnBnClickedEncsetting()
{
	// TODO: Add your control notification handler code here
	ENCODEINFO encInfo[MAX_DXDEV_NUM];
	for (unsigned i=0; i<m_uDevCount; i++)
	{
		GetEncodeSetting(i, encInfo[i]);
	}

	CEncodeSettingDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		ENCODEINFO info;
		for (unsigned i=0; i<m_uDevCount; i++)
		{
			if (m_DxDev[i].bEncode)
			{
				GetEncodeSetting(i, info);
				if (memcmp(&encInfo[i], &info, sizeof(ENCODEINFO)) != 0)
				{ // б仯ֹͣ¼ƵҲֹͣȻ¼
					BOOL bRecord = m_DxDev[i].bRecord;
					if (m_DxDev[i].bRecord)
					{
						RecordControl(i);
					}

					if (m_DxDev[i].bNetTrans)
					{
						NetStreamStop(i);
					}

					if (bRecord)
					{ //¼
						RecordControl(i);
					}
					
					//
					NetStreamStart(i);
				}
			}
		}
	}
}




void CVcDemoDlg::OnBnClickedVideosnapshot()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		CString str;
		unsigned n = INI_READ_INT(INI_SAVE_SECTION, INI_CAP_FILE_FORMAT, DEFAULT_CAP_FILE_FORMAT);
		if (GetFilename(str, n == 0 ? ".jpg" : ".bmp"))
		{
			USES_CONVERSION;
			if (n == 0)
			{
				unsigned m = INI_READ_INT(INI_SAVE_SECTION, INI_CAP_JPEG_QUALITY, DEFAULT_CAP_JPEG_QUALITY);
				unsigned r = DXSnapToJPGFile(m_DxDev[m_uDevSelect].devHandle, T2A(str), m);
				DXSDK_CHECK_ERROR("DXSnapToJPGFile", r);
			}
			else
			{
				unsigned r = DXSnapToBMPFile(m_DxDev[m_uDevSelect].devHandle, T2A(str));
				DXSDK_CHECK_ERROR("DXSnapToBMPFile", r);
			}
		}
	}
}


void CVcDemoDlg::GetNetSetting(unsigned nIndex, NETSTREAMINFO &info)
{
	info.rtspEnable = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTSP_ENABLE));
	info.rtspPort = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTSP_PORT));
	info.rtmpEnable = ini_dev_read_int(nIndex, INI_DEFAULT(NET_RTMP_ENABLE));
	info.audioEnable = ini_dev_read_int(nIndex, INI_DEFAULT(NET_AUDIO_ENABLE));
	info.strUri = ini_dev_read_string(nIndex, INI_DEFAULT(NET_RTMP_URI));
}



void CVcDemoDlg::OnBnClickedNetsetting()
{
	// TODO: Add your control notification handler code here
	NETSTREAMINFO netInfo[MAX_DXDEV_NUM];
	for (unsigned i=0; i<m_uDevCount; i++)
	{
		GetNetSetting(i, netInfo[i]);
	}

	CNetStreamDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		BOOL bChanged;
		NETSTREAMINFO info;
		for (unsigned i=0; i<m_uDevCount; i++)
		{
			bChanged = FALSE;
			GetNetSetting(i, info);
			if (netInfo[i].rtspEnable || netInfo[i].rtmpEnable || info.rtspEnable || info.rtmpEnable)
			{
				if (netInfo[i].rtspEnable != info.rtspEnable || netInfo[i].rtspPort != info.rtspPort)
				{
					bChanged = TRUE;
				}
				else if (netInfo[i].rtmpEnable != info.rtmpEnable || netInfo[i].strUri != info.strUri)
				{
					bChanged = TRUE;
				}

				if (bChanged)
				{
					NetStreamStop(i);
					NetStreamStart(i);
				}
				m_DxDev[i].bNetAudio = m_DxDev[i].bNetTrans && info.audioEnable != 0;
			}
		}
	}
}


void CVcDemoDlg::GetVideoSetting(unsigned nIndex, VIDEOINFO &info, BOOL bHD)
{
	info.videoRender = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_RENDER_TYPE));
	info.videoWidth = ini_dev_read_int(nIndex, bHD ? INI_VIDEO_HD_WIDTH : INI_VIDEO_WIDTH, 0);
	info.videoHeight = ini_dev_read_int(nIndex, bHD ? INI_VIDEO_HD_HEIGHT : INI_VIDEO_HEIGHT, 0);
	info.videoFramerate = ini_dev_read_int(nIndex, bHD ? INI_VIDEO_HD_FRAME_RATE : INI_VIDEO_FRAME_RATE, 0);
	info.videoStandard = bHD ? 0 : ini_dev_read_int(nIndex, INI_VIDEO_STANDARD, 0);
	info.videoDeinterlace = bHD ? 0 : ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_DEINTERLACE));
}



void CVcDemoDlg::OnBnClickedVideosetting()
{
	// TODO: Add your control notification handler code here
	VIDEOINFO videoInfo[MAX_DXDEV_NUM];
	for (unsigned i=0; i<m_uDevCount; i++)
	{
		GetVideoSetting(i, videoInfo[i], DXDeviceIsHD(m_DxDev[i].devHandle));
		// ʵֵʼ
		videoInfo[i].videoWidth = m_DxDev[i].nWidth;
		videoInfo[i].videoHeight = m_DxDev[i].nHeight;
		videoInfo[i].videoFramerate = (unsigned)m_DxDev[i].fFrameRate;
		videoInfo[i].videoStandard = m_DxDev[i].nStandard;
	}

	CVideoSettingDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		VIDEOINFO info;
		for (unsigned i=0; i<m_uDevCount; i++)
		{
			GetVideoSetting(i, info, DXDeviceIsHD(m_DxDev[i].devHandle));
			if (videoInfo[i].videoWidth != info.videoWidth ||
				videoInfo[i].videoHeight != info.videoHeight ||
				videoInfo[i].videoFramerate != info.videoFramerate ||
				videoInfo[i].videoStandard != info.videoStandard)
			{
				DeviceRestart(i);
				continue;
			}

			if (videoInfo[i].videoRender != info.videoRender)
			{
				VideoPreviewStop(i);
				VideoPreviewStart(i);
			}

			if (videoInfo[i].videoDeinterlace != info.videoDeinterlace)
			{
				SetVideoDeinterlace(i);
			}
		}
	}
}


void CVcDemoDlg::GetOSDEnable(unsigned nIndex, OSDENABLE &en)
{
	en.osdEnable[0] = ini_dev_read_int(nIndex, INI_DEFAULT(TIME_OSD_ENABLE));
	en.osdEnable[1] = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_ENABLE1));
	en.osdEnable[2] = ini_dev_read_int(nIndex, INI_DEFAULT(TEXT_OSD_ENABLE2));
	en.osdEnable[3] = ini_dev_read_int(nIndex, INI_DEFAULT(PIC_OSD_ENABLE));
}



void CVcDemoDlg::OnBnClickedOsdsetting()
{
	// TODO: Add your control notification handler code here
	OSDENABLE osdEnable[MAX_DXDEV_NUM];
	for (unsigned i=0; i<m_uDevCount; i++)
	{
		GetOSDEnable(i, osdEnable[i]);
	}

	COSDSettingDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		OSDENABLE osdEn;
		for (unsigned i=0; i<m_uDevCount; i++)
		{
			GetOSDEnable(i, osdEn);

			if (osdEnable[i].osdEnable[0] != 0 || osdEn.osdEnable[0] != 0)
			{
				SetTimeOSD(i);
			}

			if (osdEnable[i].osdEnable[1] != 0 || osdEn.osdEnable[1] != 0)
			{
				SetTextOSD_1(i);
			}

			if (osdEnable[i].osdEnable[2] != 0 || osdEn.osdEnable[2] != 0)
			{
				SetTextOSD_2(i);
			}

			if (osdEnable[i].osdEnable[3] != 0 || osdEn.osdEnable[3] != 0)
			{
				SetPictureOSD(i);
			}
		}
	}
}


void CVcDemoDlg::OnBnClickedVideoFlip()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		m_DxDev[m_uDevSelect].bFlip = ((CButton*)GetDlgItem(IDC_VIDEO_FLIP))->GetCheck() == BST_CHECKED;
		unsigned r = DXFlipVideo(m_DxDev[m_uDevSelect].devHandle, m_DxDev[m_uDevSelect].bFlip);
		DXSDK_CHECK_ERROR("DXFlipVideo", r);
	}
}


void CVcDemoDlg::OnBnClickedVideoMirror()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		m_DxDev[m_uDevSelect].bMirror = ((CButton*)GetDlgItem(IDC_VIDEO_MIRROR))->GetCheck() == BST_CHECKED;
		unsigned r = DXMirrorVideo(m_DxDev[m_uDevSelect].devHandle, m_DxDev[m_uDevSelect].bMirror);
		DXSDK_CHECK_ERROR("DXMirrorVideo", r);
	}
}


HBRUSH CVcDemoDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  Change any attributes of the DC here
	if (pWnd->GetDlgCtrlID() == IDC_STATUS)
	{
		pDC->SetBkMode(TRANSPARENT);
		hbr = (HBRUSH)m_Brush;
	}
	// TODO:  Return a different brush if the default is not desired
	return hbr;
}


void CVcDemoDlg::OnBnClickedFullscreen()
{
	// TODO: Add your control notification handler code here
	if (m_DxDev[m_uDevSelect].devHandle)
	{
		VideoPreviewStop(m_uDevSelect);
		m_DxDev[m_uDevSelect].pVideoWin->SetFullScreen(TRUE);
		VideoPreviewStart(m_uDevSelect);
	}
}

void CVcDemoDlg::OnBnClickedRepairmp4file()
{
	// TODO: Add your control notification handler code here
	CMP4RepairDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		if (dlg.m_MP4FileName.IsEmpty() || dlg.m_MP4SaveName.IsEmpty())
		{
			return;
		}

		USES_CONVERSION;

		unsigned r = DXMp4fileRepair(T2A(dlg.m_MP4FileName), T2A(dlg.m_MP4SaveName));
		DXSDK_CHECK_ERROR("DXMp4fileRepair", r);
		if (r == 0)
		{
			g_repair_dlg.UpdateProgress(0);
			g_repair_dlg.CenterWindow();
			g_repair_dlg.ShowWindow(SW_SHOW);
		}
	}
}


void CVcDemoDlg::OnBnClickedMp4filecut()
{
	// TODO: Add your control notification handler code here
	CMP4CutDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		g_cut_dlg.UpdateProgress(0);
		g_cut_dlg.CenterWindow();
		g_cut_dlg.ShowWindow(SW_SHOW);
	}
}
