// VideoSettingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"
#include "VideoSettingDlg.h"
#include "afxdialogex.h"


// CVideoSettingDlg dialog

IMPLEMENT_DYNAMIC(CVideoSettingDlg, CDialogEx)

CVideoSettingDlg::CVideoSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CVideoSettingDlg::IDD, pParent)
	, m_nDevSel(0)
{

}

CVideoSettingDlg::~CVideoSettingDlg()
{
}

void CVideoSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CVideoSettingDlg, CDialogEx)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_DEVICE, &CVideoSettingDlg::OnSelchangeDevice)
	ON_BN_CLICKED(IDC_DEFAULT, &CVideoSettingDlg::OnBnClickedDefault)
	ON_BN_CLICKED(IDOK, &CVideoSettingDlg::OnBnClickedOk)
	ON_EN_KILLFOCUS(IDC_BRIGHTNESS_VAL, &CVideoSettingDlg::OnKillfocusBrightnessVal)
	ON_EN_KILLFOCUS(IDC_SATURATION_VAL, &CVideoSettingDlg::OnKillfocusSaturationVal)
	ON_EN_KILLFOCUS(IDC_SHARPNESS_VAL, &CVideoSettingDlg::OnKillfocusSharpnessVal)
	ON_EN_KILLFOCUS(IDC_CONTRAST_VAL, &CVideoSettingDlg::OnKillfocusContrastVal)
	ON_EN_KILLFOCUS(IDC_HUE_VAL, &CVideoSettingDlg::OnKillfocusHueVal)
END_MESSAGE_MAP()


// CVideoSettingDlg message handlers


void CVideoSettingDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
	int nID = pScrollBar->GetDlgCtrlID();

	unsigned nTypes[] = { video_brightness, video_contrast, video_saturation, video_hue, video_sharpness };
	int nIDs[] = { IDC_BRIGHTNESS, IDC_CONTRAST, IDC_SATURATION, IDC_HUE, IDC_SHARPNESS };
	int nEditID[] = { IDC_BRIGHTNESS_VAL, IDC_CONTRAST_VAL, IDC_SATURATION_VAL, IDC_HUE_VAL, IDC_SHARPNESS_VAL };

	for (unsigned i=0; i<_countof(nTypes); i++)
	{
		if (nID == nIDs[i])
		{
			PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(m_nDevSel);
			if (pInfo)
			{
				CSliderCtrl *pCtrl = (CSliderCtrl*)pScrollBar;
				int nVal = pCtrl->GetPos();
				SetDlgItemInt(nEditID[i], nVal);
				unsigned r = DXSetDisplayPara(pInfo->devHandle, nTypes[i], nVal, 0);
				DXSDK_CHECK_ERROR("DXSetDisplayPara", r);
			}
			break;
		}
	}

	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}


BOOL CVideoSettingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	unsigned nStandard[] = { standard_NTSC_M, standard_NTSC_M_J,
							standard_PAL_B, standard_PAL_D, standard_PAL_G, standard_PAL_H, standard_PAL_I, standard_PAL_M, standard_PAL_N,
							standard_SECAM_B, standard_SECAM_D, standard_SECAM_G, standard_SECAM_H, standard_SECAM_K, standard_SECAM_K1, standard_SECAM_L, standard_SECAM_L1 };
	LPCTSTR strStandard[] = { _T("NTSC_M"), _T("NTSC_M_J"),
							_T("PAL_B"), _T("PAL_D"), _T("PAL_G"), _T("PAL_H"), _T("PAL_I"), _T("PAL_M"), _T("PAL_N"),
							_T("SECAM_B"), _T("SECAM_D"), _T("SECAM_G"), _T("SECAM_H"), _T("SECAM_K"), _T("SECAM_K1"), _T("SECAM_L"), _T("SECAM_L1") };

	CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_STANDARD);
	for (int i=0; i<_countof(nStandard); i++)
	{
		pCtrl->SetItemData(pCtrl->AddString(strStandard[i]), nStandard[i]);
	}

	unsigned nDeinterlace[] = { deinterlace_None, deinterlace_SimpleBob, deinterlace_TomsMoComp, deinterlace_Private };
	LPCTSTR strDeinterlace[] = { _T("None"), _T("SimpleBob"), _T("TomsMoComp"), _T("Private") };
	pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_DEINTERLACE);
	for (int i=0; i<_countof(nDeinterlace); i++)
	{
		pCtrl->SetItemData(pCtrl->AddString(strDeinterlace[i]), nDeinterlace[i]);
	}

	CString str;
	pCtrl = (CComboBox*)GetDlgItem(IDC_DEVICE);
	for (int i=0; i<MAX_DXDEV_NUM; i++)
	{
		PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(i);
		if (pInfo->devHandle == NULL)
		{
			break;
		}
		str.Format(_T("%d:"), i);
		str += DXGetDeviceName(pInfo->devHandle);
		pCtrl->AddString(str);
	}

	m_nDevSel = 0;
	pCtrl->SetCurSel(m_nDevSel);
	SelDevVideoParam(m_nDevSel);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CVideoSettingDlg::SelDevVideoParam(int nIndex)
{
	PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(nIndex);
	if (pInfo)
	{
		LONG nMin, nMax, nVal, nStep, nDefault, nFlags;
		unsigned nTypes[] = { video_brightness, video_contrast, video_saturation, video_hue, video_sharpness };
		int nIDs[] = { IDC_BRIGHTNESS, IDC_CONTRAST, IDC_SATURATION, IDC_HUE, IDC_SHARPNESS };
		int nEditID[] = { IDC_BRIGHTNESS_VAL, IDC_CONTRAST_VAL, IDC_SATURATION_VAL, IDC_HUE_VAL, IDC_SHARPNESS_VAL };
		for (unsigned i=0; i<_countof(nTypes); i++)
		{
			unsigned r = DXGetDisplayParaRange(pInfo->devHandle, nTypes[i], &nMin, &nMax, &nStep, &nDefault, &nFlags);
			DXSDK_CHECK_ERROR("DXGetDisplayParaRange", r);
			if (r == 0)
			{
				CSliderCtrl *pCtrl = (CSliderCtrl*)GetDlgItem(nIDs[i]);
				pCtrl->SetRange(nMin, nMax);
				r = DXGetDisplayPara(pInfo->devHandle, nTypes[i], nVal, nFlags);
				DXSDK_CHECK_ERROR("DXGetDisplayPara", r);
				if (r == 0)
				{
					pCtrl->SetPos(nVal);
					SetDlgItemInt(nEditID[i], nVal);
				}
			}
		}

		unsigned n = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_RENDER_TYPE));
		((CComboBox*)GetDlgItem(IDC_VIDEO_RENDER))->SetCurSel(n);

		CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_SIZE);
		pCtrl->ResetContent();

		unsigned colorspace, width, height;
		float framerate;
		if (DXDeviceIsHD(pInfo->devHandle))
		{
			LPCTSTR strSize[] = { _T("720P"), _T("1080P") };
			for (int i=0; i<_countof(strSize); i++)
			{
				pCtrl->AddString(strSize[i]);
			}

			unsigned r = DXGetVideoParaHD(pInfo->devHandle, colorspace, width, height, framerate);
			DXSDK_CHECK_ERROR("DXGetVideoParaHD", r);
			if (r == 0)
			{
				int nSel = -1;
				if (width == 1280)
				{ // 720P
					nSel = 0;
				}
				else if (width == 1920)
				{ // 1080P
					nSel = 1;
				}
				pCtrl->SetCurSel(nSel);
			}

			SetDlgItemInt(IDC_VIDEO_FPS, (int)framerate);
		}
		else
		{
			LPCTSTR strSize[] = { _T("CIF"), _T("VGA"), _T("D1") };
			for (int i=0; i<_countof(strSize); i++)
			{
				pCtrl->AddString(strSize[i]);
			}

			unsigned standard;
			unsigned r = DXGetVideoPara(pInfo->devHandle, standard, colorspace, width, height, framerate);
			DXSDK_CHECK_ERROR("DXGetVideoPara", r);
			if (r == 0)
			{
				int nSel = -1;
				if (width < 360)
				{ //CIF
					nSel = 0;
				}
				else if (width == 640)
				{ //VGA
					nSel = 1;
				}
				else if (width == 720)
				{ //D1
					nSel = 2;
				}
				pCtrl->SetCurSel(nSel);

				pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_STANDARD);
				for (int i=0; i<pCtrl->GetCount(); i++)
				{
					if (pCtrl->GetItemData(i) == standard)
					{
						pCtrl->SetCurSel(i);
						break;
					}
				}
			}

			n = ini_dev_read_int(nIndex, INI_DEFAULT(VIDEO_DEINTERLACE));
			pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_DEINTERLACE);
			for (int i=0; i<pCtrl->GetCount(); i++)
			{
				if (pCtrl->GetItemData(i) == n)
				{
					pCtrl->SetCurSel(i);
					break;
				}
			}
		}

		GetDlgItem(IDC_STATIC_FPS)->ShowWindow(DXDeviceIsHD(pInfo->devHandle) ? SW_SHOW : SW_HIDE);
		GetDlgItem(IDC_VIDEO_FPS)->ShowWindow(DXDeviceIsHD(pInfo->devHandle) ? SW_SHOW : SW_HIDE);
		GetDlgItem(IDC_STATIC_VSD)->ShowWindow(DXDeviceIsHD(pInfo->devHandle) ? SW_HIDE : SW_SHOW);
		GetDlgItem(IDC_VIDEO_STANDARD)->ShowWindow(DXDeviceIsHD(pInfo->devHandle) ? SW_HIDE : SW_SHOW);
		GetDlgItem(IDC_STATIC_DEINTERLACE)->ShowWindow(DXDeviceIsHD(pInfo->devHandle) ? SW_HIDE : SW_SHOW);
		GetDlgItem(IDC_VIDEO_DEINTERLACE)->ShowWindow(DXDeviceIsHD(pInfo->devHandle) ? SW_HIDE : SW_SHOW);
	}
}


void CVideoSettingDlg::OnSelchangeDevice()
{
	// TODO: Add your control notification handler code here
	int nSel = ((CComboBox*)GetDlgItem(IDC_DEVICE))->GetCurSel();
	if (nSel >= 0 && nSel != m_nDevSel)
	{
		m_nDevSel = nSel;
		SelDevVideoParam(nSel);
	}
}


void CVideoSettingDlg::OnBnClickedDefault()
{
	// TODO: Add your control notification handler code here
	PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(m_nDevSel);
	if (pInfo)
	{
		unsigned nTypes[] = { video_brightness, video_contrast, video_saturation, video_hue, video_sharpness };
		int nIDs[] = { IDC_BRIGHTNESS, IDC_CONTRAST, IDC_SATURATION, IDC_HUE, IDC_SHARPNESS };
		int nEditID[] = { IDC_BRIGHTNESS_VAL, IDC_CONTRAST_VAL, IDC_SATURATION_VAL, IDC_HUE_VAL, IDC_SHARPNESS_VAL };
		LONG nMin, nMax, nStep, nDefault, nFlags;
		for (unsigned i=0; i<_countof(nTypes); i++)
		{
			unsigned r = DXGetDisplayParaRange(pInfo->devHandle, nTypes[i], &nMin, &nMax, &nStep, &nDefault, &nFlags);
			DXSDK_CHECK_ERROR("DXGetDisplayParaRange", r);
			if (r == 0)
			{
				CSliderCtrl *pCtrl = (CSliderCtrl*)GetDlgItem(nIDs[i]);
				pCtrl->SetPos(nDefault);
				SetDlgItemInt(nEditID[i], nDefault);
				r = DXSetDisplayPara(pInfo->devHandle, nTypes[i], nDefault, nFlags);
				DXSDK_CHECK_ERROR("DXSetDisplayPara", r);
			}
		}
	}
}


void CVideoSettingDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(m_nDevSel);
	if (pInfo)
	{
		LONG nVal, nFlags;
		unsigned nTypes[] = { video_brightness, video_contrast, video_saturation, video_hue, video_sharpness };
		LPCTSTR strItems[] = { INI_VIDEO_BRIGHTNESS, INI_VIDEO_CONTRAST, INI_VIDEO_SATURATION, INI_VIDEO_HUE, INI_VIDEO_SHARPNESS };
		LPCTSTR strHDItems[] = { INI_VIDEO_HD_BRIGHTNESS, INI_VIDEO_HD_CONTRAST, INI_VIDEO_HD_SATURATION, INI_VIDEO_HD_HUE, INI_VIDEO_HD_SHARPNESS };
		for (unsigned i=0; i<_countof(nTypes); i++)
		{
			unsigned r = DXGetDisplayPara(pInfo->devHandle, nTypes[i], nVal, nFlags);
			DXSDK_CHECK_ERROR("DXGetDisplayPara", r);
			if (r == 0)
			{
				ini_dev_write_int(m_nDevSel, DXDeviceIsHD(pInfo->devHandle) ? strHDItems[i] : strItems[i], nVal);
			}
		}

		int nSel = ((CComboBox*)GetDlgItem(IDC_VIDEO_RENDER))->GetCurSel();
		if (nSel >= 0)
		{
			ini_dev_write_int(m_nDevSel, INI_VIDEO_RENDER_TYPE, nSel);
		}

		unsigned nWidth, nHeight;
		if (DXDeviceIsHD(pInfo->devHandle))
		{
			nSel = ((CComboBox*)GetDlgItem(IDC_VIDEO_SIZE))->GetCurSel();
			switch (nSel)
			{
			case 0:
				nWidth = 1280;
				nHeight = 720;
				break;
			case 1:
				nWidth = 1920;
				nHeight = 1080;
				break;
			default:
				break;
			}

			if (nSel == 0 || nSel == 1)
			{
				ini_dev_write_int(m_nDevSel, INI_VIDEO_HD_WIDTH, nWidth);
				ini_dev_write_int(m_nDevSel, INI_VIDEO_HD_HEIGHT, nHeight);

				BOOL bSuccess;
				unsigned fps = GetDlgItemInt(IDC_VIDEO_FPS, &bSuccess);
				if (bSuccess && fps > 0)
				{
					ini_dev_write_int(m_nDevSel, INI_VIDEO_HD_FRAME_RATE, fps);
				}
			}
		}
		else
		{
			CComboBox *pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_STANDARD);
			nSel = pCtrl->GetCurSel();
			if (nSel >= 0)
			{
				unsigned nStandard = pCtrl->GetItemData(nSel);
				nSel = ((CComboBox*)GetDlgItem(IDC_VIDEO_SIZE))->GetCurSel();
				switch (nSel)
				{
				case 0:
					nWidth = (nStandard & (standard_NTSC_M | standard_NTSC_M_J)) ? 320 : 352;
					nHeight = (nStandard & (standard_NTSC_M | standard_NTSC_M_J)) ? 240 : 288;
					break;
				case 1:
					nWidth = 640;
					nHeight = 480;
					break;
				case 2:
					nWidth = 720;
					nHeight = (nStandard & (standard_NTSC_M | standard_NTSC_M_J)) ? 480 : 576;
					break;
				default:
					break;
				}

				if (nSel == 0 || nSel == 1 || nSel == 2)
				{
					ini_dev_write_int(m_nDevSel, INI_VIDEO_WIDTH, nWidth);
					ini_dev_write_int(m_nDevSel, INI_VIDEO_HEIGHT, nHeight);
					ini_dev_write_int(m_nDevSel, INI_VIDEO_FRAME_RATE, (nStandard & (standard_NTSC_M | standard_NTSC_M_J)) ? 30 : 25);
					ini_dev_write_int(m_nDevSel, INI_VIDEO_STANDARD, nStandard);
				}
			}

			pCtrl = (CComboBox*)GetDlgItem(IDC_VIDEO_DEINTERLACE);
			nSel = pCtrl->GetCurSel();
			if (nSel >= 0)
			{
				ini_dev_write_int(m_nDevSel, INI_VIDEO_DEINTERLACE, pCtrl->GetItemData(nSel));
			}
		}
	}

	CDialogEx::OnOK();
}


BOOL CVideoSettingDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_CHAR && pMsg->wParam == VK_RETURN)
	{
		unsigned nTypes[] = { video_brightness, video_contrast, video_saturation, video_hue, video_sharpness };
		int nIDs[] = { IDC_BRIGHTNESS, IDC_CONTRAST, IDC_SATURATION, IDC_HUE, IDC_SHARPNESS };
		int nEditID[] = { IDC_BRIGHTNESS_VAL, IDC_CONTRAST_VAL, IDC_SATURATION_VAL, IDC_HUE_VAL, IDC_SHARPNESS_VAL };
		for (int i=0; i<_countof(nEditID); i++)
		{
			if (pMsg->hwnd == GetDlgItem(nEditID[i])->m_hWnd)
			{
				BOOL bSuccess;
				int nVal = GetDlgItemInt(nEditID[i], &bSuccess);
				CSliderCtrl *pCtrl = (CSliderCtrl*)GetDlgItem(nIDs[i]);
				if (bSuccess)
				{
					int nMin, nMax;
					pCtrl->GetRange(nMin, nMax);
					if (nVal >= nMin && nVal <= nMax)
					{
						PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(m_nDevSel);
						if (pInfo)
						{
							unsigned r = DXSetDisplayPara(pInfo->devHandle, nTypes[i], nVal, 0);
							DXSDK_CHECK_ERROR("DXSetDisplayPara", r);
						}
						pCtrl->SetPos(nVal);
						break;
					}
				}
				SetDlgItemInt(nEditID[i], pCtrl->GetPos());
				break;
			}
		}
	}

	return CDialogEx::PreTranslateMessage(pMsg);
}


void CVideoSettingDlg::OnKillfocusBrightnessVal()
{
	// TODO: Add your control notification handler code here
	SetDlgItemInt(IDC_BRIGHTNESS_VAL, ((CSliderCtrl*)GetDlgItem(IDC_BRIGHTNESS))->GetPos());
}


void CVideoSettingDlg::OnKillfocusSaturationVal()
{
	// TODO: Add your control notification handler code here
	SetDlgItemInt(IDC_SATURATION_VAL, ((CSliderCtrl*)GetDlgItem(IDC_SATURATION))->GetPos());
}


void CVideoSettingDlg::OnKillfocusSharpnessVal()
{
	// TODO: Add your control notification handler code here
	SetDlgItemInt(IDC_SHARPNESS_VAL, ((CSliderCtrl*)GetDlgItem(IDC_SHARPNESS))->GetPos());
}


void CVideoSettingDlg::OnKillfocusContrastVal()
{
	// TODO: Add your control notification handler code here
	SetDlgItemInt(IDC_CONTRAST_VAL, ((CSliderCtrl*)GetDlgItem(IDC_CONTRAST))->GetPos());
}


void CVideoSettingDlg::OnKillfocusHueVal()
{
	// TODO: Add your control notification handler code here
	SetDlgItemInt(IDC_HUE_VAL, ((CSliderCtrl*)GetDlgItem(IDC_HUE))->GetPos());
}
