// VideoWin.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "VcDemoDlg.h"
#include "VideoWin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVideoWin

CVideoWin::CVideoWin(unsigned nIndex) : m_nIndex(nIndex), m_bFullScreen(FALSE), m_pParent(NULL)
{
}

CVideoWin::~CVideoWin()
{
}


BEGIN_MESSAGE_MAP(CVideoWin, CStatic)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CVideoWin)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_VIDEO_FLIP, &CVideoWin::OnVideoFlip)
	ON_COMMAND(ID_VIDEO_MIRROR, &CVideoWin::OnVideoMirror)
	ON_COMMAND(ID_EXIT_FULLSCREEN, &CVideoWin::OnExitFullscreen)
	ON_MESSAGE(WM_PREVIEW_UPDATE, &CVideoWin::OnPreviewUpdate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoWin message handlers

void CVideoWin::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CRect rc;
	GetClientRect(rc);
	dc.FillSolidRect(rc, RGB(0, 0, 0));

	// Do not call CStatic::OnPaint() for painting messages
}

void CVideoWin::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	GetParent()->PostMessage(WM_VIDEOWIN_MSG, m_nIndex, WIN_LEFTCLICK);

	CStatic::OnLButtonDown(nFlags, point);
}

void CVideoWin::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (m_bFullScreen)
	{
		CMenu menu;
		menu.LoadMenu(IDR_MENU_VIDEO);
		PDXDEVINFO pInfo = pDemoDlg->GetDevInfo(pDemoDlg->GetCurrentDev());
		if (pInfo->bFlip)
		{
			menu.GetSubMenu(0)->CheckMenuItem(ID_VIDEO_FLIP, MF_CHECKED);
		}
		if (pInfo->bMirror)
		{
			menu.GetSubMenu(0)->CheckMenuItem(ID_VIDEO_MIRROR, MF_CHECKED);
		}

		POINT  point;
		::GetCursorPos(&point);
		menu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTBUTTON ,point.x, point.y, this);
	}

	CStatic::OnRButtonDown(nFlags, point);
}


void CVideoWin::SetFullScreen(BOOL bFullScreen)
{
	if (bFullScreen)
	{
		if (!m_bFullScreen)
		{
			GetWindowRect(&m_Rect);
			GetParent()->ScreenToClient(&m_Rect);
			m_pParent = SetParent(NULL);

			CRect rc(0, 0, ::GetSystemMetrics(SM_CXSCREEN), ::GetSystemMetrics(SM_CYSCREEN));
			MoveWindow(rc);
			m_bFullScreen = TRUE;
		}
	}
	else if (m_bFullScreen)
	{
		SetParent(m_pParent);
		MoveWindow(&m_Rect);
		m_bFullScreen = FALSE;
	}
}


void CVideoWin::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	GetParent()->PostMessage(WM_VIDEOWIN_MSG, m_nIndex, WIN_LEFTDBCLICK);

	CStatic::OnLButtonDblClk(nFlags, point);
}


void CVideoWin::OnVideoFlip()
{
	// TODO: Add your command handler code here
	pDemoDlg->FullScreenVideoFlip();
}


void CVideoWin::OnVideoMirror()
{
	// TODO: Add your command handler code here
	pDemoDlg->FullScreenVideoMirror();
}


void CVideoWin::OnExitFullscreen()
{
	// TODO: Add your command handler code here
	pDemoDlg->ExitFullScreen();
}


afx_msg LRESULT CVideoWin::OnPreviewUpdate(WPARAM wParam, LPARAM lParam)
{ // Direct3DƵԤָVMR7/9ݲ֧
	DXUpdatePreview((device_handle)wParam);
	return 0;
}
