///////////////////////////////////////////////////////////////////////////////////////////////
// DeviceControl.h: interface for the DeviceControl class.
//
// Write by tony yu  tony@zhonganvision.com

//	copyright ShenZhen ZhongAn Vision

 // 20131210

/////////////////////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "DXMediaCap.h"
#include "ChannelWnd.h"



#if !defined(AFX_DEVICECONTROL_H__B4861B41_DB02_4E63_AEAA_1FBA5283B0C3__INCLUDED_)
#define AFX_DEVICECONTROL_H__B4861B41_DB02_4E63_AEAA_1FBA5283B0C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
typedef struct DEVICE_INFO
{
	DEVICE_INFO()
	{
		m_pWnd=NULL;
	 }
	CChannelWnd	*m_pWnd;
	unsigned int dwHeight;
	unsigned int dwWidth;
	float dwFrameRate;
	unsigned int dwColorspace;
	unsigned int dwVidStandard;
	unsigned  dwOpenDevState;
	BOOL dwConnectState;
	BOOL  dwPrviewState;
	BOOL  dwHDdevice;
	BOOL dwRecState;
	BOOL dwNetStreamState;
	BOOL dwOrgCallState;
	BOOL dwEncodCallState;
	BOOL dwCodecSetState;
	HANDLE dwChannelHandle;
	HWND dwPrvHandle;
	RECT dwPrvRect;

	PRECT dwSnapPicRect;
	RECT dwZoomRect;
	VidCodecPara  dwVideoCodecpara;
	CString       dwVideoCodecStr;
	DWORD			dwDispWidth;                     //Ԥʾ
	DWORD			dwDispHeight;                    //Ԥʾ߶
	DWORD			dwDispPosX;                      //Ԥʾˮƽʼλ
	DWORD			dwDispPosY; 

	DWORD			dwZoomWidth;                     //Ԥʾ
	DWORD			dwZoomHeight;                    //Ԥʾ߶
	DWORD			dwZoomPosX;                      //Ԥʾˮƽʼλ
	DWORD			dwZoomPosY; 
	unsigned int dwCardNo;



}Device_Info;


typedef struct Device_ColorPara
 {
	int ColorType;
	int MinVal;
	int MaxVal;
	int StepVal;
	int DefaultVal;
	int CurVal;
 }DeviceColorProp;

 static Device_ColorPara DeviceColorPara[23];      

typedef struct TOSD_INFO
{
	int TimeX;
	int TimeY;
	int TxtPlaceX ;
	int TxtPlaceY ;
	int PicPlaceX;
	int PicPlaceY;
	int TimeFontSizeVal;
	int TxtFontSizeVal;
	char * Osd_Txtstring;
	char* PicOsdFile;
	char * TimeFont;
	char * TxtFont;
	COLORREF TxtColor;
	COLORREF TimeColor;
	COLORREF BackColor;
	char Alpha ;
	int RectX;
	int RectY;
	int RectWidth;
	int RectHeight;
	int RectLineSizeVal;
	int RectLineStyle;
	COLORREF RectLineColor;
	int LineX0;
	int LineY0;
	int LineX1;
	int LineY1;
	int LineSizeVal;
	int LineStyle;
	COLORREF LineColor;
   
}TosdInfo;
             
 static TOSD_INFO TosdPara[23];     
class DeviceControl  
{
public:
	DeviceControl();
	virtual ~DeviceControl();
	int InitDevice();
	void UnInitDevice();

	HANDLE OpenDevice(int nCard,unsigned*OpenDevState);
	void CloseDevice(HANDLE ChannelHandle);
	BOOL  ConnectDevice(HANDLE ChannelHandle,
						int VideoStandard, 
						int ColorSpace,
						int nWidth,
						int nHeight,
						float FrameRate);
	void DisConnectDevice(HANDLE ChannelHandle);
	BOOL SetVideoSource(HANDLE ChannelHandle,unsigned VideoSource);
	BOOL GetVideoPara(HANDLE ChannelHandle,
					unsigned& nWidth,
					unsigned& nHeight,
					unsigned& ColorSpace,
					unsigned& VideoStandard,
					float& FrameRate);
	BOOL  StartPrview(HANDLE ChannelHandle,HWND PrvHwnd,PRECT rect, unsigned PrvModle,bool PrvEnable) ;
	BOOL StopPrview(HANDLE ChannelHandle);
	BOOL FreezePreview(HANDLE ChannelHandle,BOOL bFreeze);
	BOOL GetSignalPresent(HANDLE ChannelHandle, unsigned& signal);
	BOOL SnapPicture(HANDLE ChannelHandle, TCHAR* szFileName,int PictureType, PRECT rect);
	BOOL SetVideoFlip(HANDLE ChannelHandle,BOOL FlipEnable);
	BOOL GetVideoColorPara(HANDLE ChannelHandle, unsigned paraType, long& value, long& flags);
	BOOL GetVideoColorParaRange(HANDLE ChannelHandle,
								unsigned paraType,
								long* pMin,
								long* pMax, 
								long* pSteppingDelta,
								long* pDefault,
								long* pCapsFlags);
	BOOL SetVideoColorPara(HANDLE ChannelHandle, unsigned paraType, long value, long flags);
	BOOL SetOSDPara(HANDLE ChannelHandle,
					unsigned OsdType,
					int OsdNo,
					char* OsdFile,
					int x, 
					int y,  
					int pointSize,
					char* faceName,
					COLORREF OSDcolor, 
					COLORREF Backcolor,
					BOOL transparent,
					unsigned char PicAlpha);
	BOOL StartOsd(HANDLE ChannelHandle,unsigned OsdType,int OsdNo,BOOL osdEnable);

	BOOL SetVideoMirro(HANDLE ChannelHandle,BOOL MirroEnable);



	BOOL EnableDeinterlace(HANDLE ChannelHandle,int DeintType,BOOL enable);

	BOOL GetCurBuffer(HANDLE ChannelHandle,
					unsigned BufType,
					unsigned char* pbuffer,
					unsigned bufferLen,
					unsigned width,
					unsigned height,
					BOOL EnableFilp);

	BOOL ConvertYUVtoRGB(HANDLE ChannelHandle,
						void* pYUVBuf,
						void* pRGBBuf,
						long lImgWidth, 
						long lImgHeight,
						BOOL bInverted,
						BOOL bInvertColor);
	bool DeviceControl::SaveRGBToBmp( const char * fileName,  int iWidth, int iHeight, BYTE *pBuffer)  ;

	void DeviceControl::ContructBhh(int nWidth,int nHeight,BITMAPFILEHEADER& bhh); 

		
		//BMPļϢͷ  
	void DeviceControl::ConstructBih(int nWidth,int nHeight,BITMAPINFOHEADER& bih) ;
	
	BOOL StartRecord(HANDLE ChannelHandle,CString szFileName,CString CodecType, VidCodecPara nCodecPara,unsigned vidRatio);

	BOOL StopRecord(HANDLE ChannelHandle);

	BOOL FreezeRecord(HANDLE ChannelHandle,BOOL Enable);




};



#endif // !defined(AFX_DEVICECONTROL_H__B4861B41_DB02_4E63_AEAA_1FBA5283B0C3__INCLUDED_)

//extern DEVICE_INFO DeviceInfo[23];